﻿#Requires –Version 3

Param 
      (
      [string]$configfile,
      [switch]$parallel
       )


$Start=Get-Date
write-host "     ************************************************************     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     *            AI2 Create VMs  by Thorsten Raucamp           *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     *                  Version 0.95 2014-05-15                 *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     ************************************************************     " -ForegroundColor DarkGreen
Write-Host ""
Write-Host ""
write-host "     Beginne mit der Konfiguration der Infrastruktur am: " -NoNewline
Get-Date
$Host.UI.RawUI.WindowTitle = "Automatic Infrastructure Installer : Create VMs "


if ((Get-Command Test-Admin -ErrorAction Ignore).Verb -ne "Test") {Start-Process   -WorkingDirectory $PSHOME -FilePath "powershell.exe" -ArgumentList "$PSScriptRoot\SUB\H1_globale-Funktionen.ps1"  -Wait}

if (!(Test-Admin)) {
                    $powershell = [System.Diagnostics.Process]::GetCurrentProcess()
                    $psi = New-Object System.Diagnostics.ProcessStartInfo $powerShell.Path
                    $script = $MyInvocation.MyCommand.Path
                    $prm = $script
                    foreach($a in $args) {$prm += ' ' + $a}
                    $psi.Arguments = $prm
                    $psi.Verb = "runas"
                    #$psi
                    [System.Diagnostics.Process]::Start($psi) | Out-Null
                    return;
                    # Neustart des Skriptes mit Adminrechten, sollte das aktuelle Skript nicht mit Administratorrechten 
                    # gestartet worden sein. Übernommen von der c't www.ct.de/1017144
                   }

  if((Get-Item -Path HKLM:\SOFTWARE).GetSubKeyNames() -notcontains"AI2")
                {# Anlage eines neuen Schluessels fuer die Skripte
                 new-Item -Path HKLM:\SOFTWARE -name AI2
                 set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name Configfile -Value ""
                }


$ScriptDir=(Get-ItemProperty HKLM:\SOFTWARE\ai2).scriptdir
if (([string]::IsNullOrEmpty($ScriptDir))) {
        If (([string]::IsNullOrEmpty($PSCommandPath)))
                {$ScriptDir = (split-path -parent $psISE.CurrentFile.Fullpath) }
        else 
                {$ScriptDir =  (Split-Path -parent $PSCommandPath) }
        set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name Scriptdir -Value $ScriptDir
    }
[int]$osbuild=  (((Get-WmiObject Win32_OperatingSystem).version).split("."))[-1]
#
cd $ScriptDir

 If (([string]::IsNullOrEmpty($configfile))){
          if((Get-Item -Path HKLM:\SOFTWARE).GetSubKeyNames() -notcontains"AI2")
                {# Anlage eines neuen Schluessels fuer die Skripte
                 new-Item -Path HKLM:\SOFTWARE -name AI2
                 set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name Configfile -Value ""
                }
          $configfile=(Get-ItemProperty -path HKLM:\SOFTWARE\ai2).Configfile
          If (([string]::IsNullOrEmpty($configfile))){$configfile= ("$ScriptDir\cfg\ai2config.xml")}
         } 
if (!(Test-Path $configfile)) {Write-Host "Bitte starten Sie das Skript erneut mit dem Parameter -configfile und der entsprechenden Pfadangabe"}
set-ItemProperty -Path HKLM:\SOFTWARE\ai2 -name Configfile -Value $configfile
[xml]$config = Get-Content $configfile
$logfile=$config.CFG.log+"\startVMCreation.txt"
# Ende Header
#################################################################################################################################################

$ErrorActionPreference="Continue"
# Variablen belegen
$GB=1024*1024*1024
write-host "Starte die Konfiguration der VMs"

$Def=$config.CFG.VMs.Default
Write-Host "----"
$xecute="$ScriptDir\SUB\H1_globale-Funktionen.ps1"
Start-Process   -WorkingDirectory $PSHOME -FilePath "powershell.exe" -ArgumentList "$xecute" -RedirectStandardError $logfile  -Wait
Write-Host "Überprüfe virtuelle Switches" -ForegroundColor Cyan
$xecute="$ScriptDir\SUB\H2_configure-VSwitches.ps1"
Start-Process   -WorkingDirectory $PSHOME -FilePath "powershell.exe" -ArgumentList "$xecute" -RedirectStandardError $logfile  -Wait
                                             
$PSProzesseVorStart= (Get-Process | where {$_.processname -eq "Powershell"}).Id
if ($config.CFG.HOST.SelectedVMsOnly -eq $true)
     { $SelectedVMs = (Compare-Object -ReferenceObject ($config.CFG.HOST.SelectedVMs.Split(",")) -DifferenceObject $config.Cfg.VMs.VM.name  -ExcludeDifferent -IncludeEqual).inputObject }
else { $SelectedVMs = $config.Cfg.VMs.VM.name}

$SelectedVMs.count



ForEach ($VMx in $SelectedVMs)
         
        {$VMd=$config.cfg.HOST.VMPrefix+$VMx 
         $VMd
         if([string]::IsNullOrEmpty((get-vm | where {$_.name -eq $vmd})))  
            {                 
                  $xecute="$ScriptDir\SUB\H3_create-VM.ps1 -vmName $vmx -mitRollen"

                  if ($parallel) {Start-Process   -WorkingDirectory $PSHOME -FilePath "powershell.exe" -ArgumentList "$xecute" -RedirectStandardError $logfile
                                  Start-Sleep 120 
                                 }
                  else {Start-Process   -WorkingDirectory $PSHOME -FilePath "powershell.exe" -ArgumentList "$xecute" -RedirectStandardError $logfile  -Wait
                       }
                  
            }
         else {   $xecute="$ScriptDir\SUB\H4_create-VM.ps1 -vmName $vmx "
                  if ($parallel) {Start-Process   -WorkingDirectory $PSHOME -FilePath "powershell.exe" -ArgumentList "$xecute" -RedirectStandardError $logfile
                                  Start-Sleep 90 
                                 }
                  else {Start-Process   -WorkingDirectory $PSHOME -FilePath "powershell.exe" -ArgumentList "$xecute" -RedirectStandardError $logfile  -Wait
                       }
                

              }
        }
$PSlaufendeProzesse=(Get-Process | where {$_.processname -eq "Powershell"}).Id 


if ($PSProzesseVorStart.Count -eq 0)
            {
             Write-Host "vorher keine Prozesse, serielle Ausführung!"
             $PSzuStoppendeProzesse=$PSlaufendeProzesse
            }
else{$PSzuStoppendeProzesse=((Compare-Object -ReferenceObject $PSlaufendeProzesse -DifferenceObject $PSProzesseVorStart).inputobject)}
#Write-Host "zu stoppende prozesse"
#$PSzuStoppendeProzesse
if ($PSzuStoppendeProzesse.Count -gt 0){Wait-Process -Id $PSzuStoppendeProzesse}

write-host "Die Konfiguration der VMs ist nun beendet."
write-host "******************************************************"
"Ausführungszeit: {0:hh}:{0:mm}:{0:ss}" -f ((get-date)-$Start)
write-host "******************************************************"

Get-Date                        
        

################################################################################################################################################
