﻿#Requires –Version 3

Param 
      (
          [string]$vmName =$(throw '- Der Parameter -vmName wird benoetigt!') ,
          [string]$configfile
       )


$Start=Get-Date
write-host "     *********************************************************     " -ForegroundColor DarkGreen
write-host "     *                                                       *     " -ForegroundColor DarkGreen
write-host "     * AI2 Collax-Groupware-Suite Konfig by Thorsten Raucamp *     " -ForegroundColor DarkGreen
write-host "     *                                                       *     " -ForegroundColor DarkGreen
write-host "     *                Version 0.95 2014-05-15                *     " -ForegroundColor DarkGreen
write-host "     *                                                       *     " -ForegroundColor DarkGreen
write-host "     *********************************************************     " -ForegroundColor DarkGreen
Write-Host ""
Write-Host ""
Write-Host ""
Write-Host ""

if (!(Test-Admin)) {
                    $powershell = [System.Diagnostics.Process]::GetCurrentProcess()
                    $psi = New-Object System.Diagnostics.ProcessStartInfo $powerShell.Path
                    $script = $MyInvocation.MyCommand.Path
                    $prm = $script
                    foreach($a in $args) {$prm += ' ' + $a}
                    $psi.Arguments = $prm
                    $psi.Verb = "runas"
                    #$psi
                    [System.Diagnostics.Process]::Start($psi) | Out-Null
                    return;
                    # Neustart des Skriptes mit Adminrechten, sollte das aktuelle Skript nicht mit Administratorrechten 
                    # gestartet worden sein. Übernommen von der c't www.ct.de/1017144
                   }
if([string]::IsNullOrEmpty($configfile)) {$configfile=(Get-ItemProperty -path HKLM:\SOFTWARE\AI2).Configfile}
if (!(Test-Path $configfile)) {Write-Host "Bitte starten Sie das Skript erneut mit dem Parameter -configfile und der entsprechenden Pfadangabe"}
set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name Configfile -Value $configfile
[xml]$config = Get-Content $configfile
# Ende Header
$logfile=$config.cfg.log +$vmName+"CGS-config.txt"
$ErrorActionPreference="SilentlyContinue"
Stop-Transcript | Out-Null
$ErrorActionPreference="Continue"

Start-Transcript -Path $logfile -Append
#################################################################################################################################################
Write-Host ""
write-host "Bereite die Konfiguration der Collax Groupware Suite (MAIL) vor, am: " -NoNewline
Get-Date 
$DCIP=($config.CFG.VMs.vm | where {$_.Rollen -match "DC"}).srvip
$DCName=($config.CFG.VMs.vm | where {$_.Rollen -match "DC"}).Name
$DomainAdmin  = New-Object System.Management.Automation.PSCredential ($config.CFG.Domain.Name + "\"+$config.cfg.Domain.Admin), (ConvertTo-SecureString $config.CFG.Domain.DomainAdminPW -AsPlainText -Force)
$Host.UI.RawUI.WindowTitle = "Configure-VM -- $vmName -- AI2 --"
#überprüfe, ob DC schon fertig ist.
if (!([string]::IsNullOrEmpty($config.cfg.Rollen.cgs.require))){
    $preRolle=$config.cfg.Rollen.cgs.require
    $preSrvIP=($config.CFG.VMs.vm | where {$_.Rollen -match $preRolle}).srvip
    wait-forHost -computer $preSrvIP -Pause 120
    wait-forHost -computer $preSrvIP -Pause 120
    Write-Host "Warte auf die Rolle $preRolle auf Server $preSrvIP" -ForegroundColor Yellow
    do{write-host "." -NoNewLine -ForegroundColor "Red"}
    until (Check-Rolle -Rolle $preRolle -IP $preSrvIP)
    Write-Host "Die Rolle $preRolle steht zur Verfügung. Setzte das Skript CGS fort." -ForegroundColor Green
   }
   sleep 10

sleep 10
Write-Host "Warte auf WINRM."
Get-Date

do
{ sleep 10
  Write-Host "." -NoNewline -ForegroundColor Yellow
}
until ((Get-WmiObject -Query "Select * from Win32_service where Name='WinRM'" -ComputerName $DCIP -Credential $DomainAdmin).state -eq "Running")
Write-Host "WinRM steht zur Verfügung" -ForegroundColor Cyan
Get-Date
$cgs=$config.CFG.Rollen.CGS
$mail=$config.CFG.vms.vm |  where {$_.Rollen -match "CGS"}
$mail

$MailPath=$mail.Path
if([string]::IsNullOrEmpty($MailPath)){$MailPath=$config.cfg.VMs.Default.Path}


$vhd=$mailPath+"\"+$config.CFG.HOST.vmPrefix+$mail.Name+"\Virtual Hard Disks\"+$mail.additionalDisks.Disk.VHDName
$SVC=import-Csv   ((split-path -Parent $configfile) + "\svc.csv")
$LDAPUser= $SVC | where {$_.sam -eq $CGS.LDAPUsr}
$mip=$mail.srvip 
$mailName=$mail.Name
wait-forHost $DCIP -Pause 120
do
{  Start-Sleep 10
   $success = Check-Rolle -Rolle "DC" -IP $DCip
}
until ($success)

do
                   { sleep 10   
                     $status = (Invoke-Command -ComputerName PDC1 -Credential $DomainAdmin -ScriptBlock {(get-service | where {$_.name -eq "DNS"}).Status}).value
                   }
until ($status -eq "Running")
Write-Host "Fuege DNS-Eintrag für CGS hinzu"
Get-Date 
Import-Module add-DNSEintrag
if(!([string]::IsNullOrEmpty($cgs.InternerAlias))){add-DNSEintrag -Name $cgs.InternerAlias -IP $mip}


add-DNSEintrag -Name $mailName -IP $mip


# Einstellungen auf dem Domain-Controller vornehmen
Invoke-Command  -ComputerName $DCIP -Credential $DomainAdmin   -ScriptBlock  {
             # -> Mit Windows NT 4.0 kompatible Kryptografiealgorithmen zulassen aktivieren aus Computerkonfiguration -> Administrative Vorlagen -> System -> Netzwerkanmeldung
            Set-ItemProperty –Path registry::HKEY_LOCAL_MACHINE\System\CurrentControlSet\Services\Netlogon\Parameters –Name AllowNT4Crypto  -Type DWord –Value 1
            # Replikation des Objektes OtherMailBox in den Global Catalog aktivieren
                $DCX=$using:config.cfg.Domain.name
                $dc1,$dc2,$dc3,$dc4 =$DCX.split('.')
                $Pfad ="Dc=$dc1,DC=$dc2"
                if($DC3 -ne $null)
                    {$Pfad=$Pfad+",DC=$dc3"
                     if($DC4 -ne $null)
                        {$Pfad=$Pfad+",DC=$dc4"}}

            $otherMailBox="CN=Other-Mailbox,cn=Schema,cn=Configuration,"+$Pfad
            #regsvr32 schmmgmt.dll
            set-ADObject $otherMailBox -Replace @{IsMemberOfPartialAttributeSet=$true}
            # ggf get-adobject -searchbase "cn=Schema,cn=Configuration,"+$pfad -LdapFilter "(&(objectcategory=attributeSchema)(Name=Other-Mailbox))"
            # ggf add anstelle von Replace 
            #Sicherstellen, dass das Passwort in umgekehrter Reihenfolge gespeichert ist.
            $npw=$using:LDAPUser.Password
            $USR=$using:LDAPUser.sam
            

            Get-ADUser -Filter {sAMAccountName -eq $USR} | Set-ADAccountPassword -Reset -NewPassword (ConvertTo-SecureString -AsPlainText "$npw" -Force)
         

}
  


function set-cgswerte
{ Param(
            [string]$FileToChange
            
        )

    If (!(Test-Path $FileToChange)) 
            {Write-Host "Die angegebene Datei $FileToChange konnte nicht gefunden werden." -ForegroundColor Red
            break}
    #$fi= Get-Content -Path "f:\collax-ai.conf"
    $fi= [IO.File]::ReadAllText($FileToChange)
    
    $cgs=$config.CFG.Rollen.CGS
    $SVC=import-Csv   ((split-path -Parent $configfile) + "\svc.csv")
    $LDAPUser= $SVC | where {$_.sam -eq $CGS.LDAPUsr}
    $DCX=$config.cfg.Domain.name
         $dc1,$dc2,$dc3,$dc4 =$DCX.split('.')
         $BaseDN ="dc=$dc1,dc=$dc2"
                if($DC3 -ne $null)
                    {$BaseDN=$BaseDN+",dc=$dc3"
                     if($DC4 -ne $null)
                        {$BaseDN=$BaseDN+",dc=$dc4"}}
    
    $binddn="cn=Manager,$BaseDN"
    $fi=$fi.replace( "#basedn#", $BaseDN)
    $fi=$fi.replace( "#binddn#", $binddn)


    $fi=$fi.replace( "#SRVIP#", $mip)
    $fi=$fi.replace( "#NetMask#", $config.CFG.Rollen.DHCP.SubNetMask)
    $fi=$fi.replace( "#FQDN#", $mailName + "." + $config.CFG.Domain.Name)
    $fi=$fi.replace( "#IPGW#", $config.CFG.Network.GWIP)
    $fi=$fi.replace( "#Lang#", $CGS.Lang)
    $fi=$fi.replace( "#continent#", $cgs.Continent)
    $fi=$fi.replace( "#location#", $cgs.Region)
    $fi=$fi.replace("#IPDC#", $DCIP)
    $fi=$fi.replace("#DCName#",  $DCName)
    $fi=$fi.replace("#DOMAdm#", $config.cfg.Domain.Admin)
    $fi=$fi.replace("#DOMAdmPW#", $config.cfg.Domain.DomainAdminPW)
    $fi=$fi.replace("#NETBIOSNAME#",  $config.cfg.Domain.NetBIOSName)
    $fi=$fi.replace("#DOMAINNAME#",  $config.cfg.Domain.Name)
    $fi=$fi.replace("#MailDomain#",  $config.cfg.Domain.MailDomain)
    $fi=$fi.replace("#CertPW#", $CGS.CertPW)
    $fi=$fi.replace("#ADMMail#", $CGS.CollaxAdminMail)
    $fi=$fi.replace("#CAdmPW#", $CGS.CollaxAdminPW)
    $fi=$fi.replace("#CRootPW#",  $CGS.CollaxRootPW)
    $fi=$fi.replace("#LDAPUSR#", $CGS.LDAPUsr)
    $fi=$fi.replace("#LDAPUSRPW#", $LDAPUser.Password)
    #$fi=$fi.replace("#OWA#",  ($CGS.OWA).ToLower())
    #$fi=$fi.replace("#OWAAdm#",($CGS.OWAAdm).ToLower())
    $fi=$fi.replace("#RelayHost#", $CGS.RelayHost)
    $fi=$fi.replace("#SRV#", $mailName)
    $fi=$fi.replace("#useSmartHost#", $CGS.useSmartHost)
    $fi=$fi.replace("#smtpname#", $CGS.smtpname)
    $fi=$fi.replace("#smtpUseTLS#", $CGS.smtpUseTLS)
    $fi=$fi.replace("#maildomain#", $CGS.maildomain)
    $fi=$fi.replace("#smtppassword#", $CGS.smtppassword)
    $fi=$fi.replace("#altHostname#", $CGS.altHostname)
    $fi=$fi.replace("#smtpport#", $CGS.smtpport)
    Out-File -FilePath "$FileToChange" -InputObject $fi -Force -Encoding ascii
}

$Destdrive= (((Get-ChildItem function:[f-z]: -Name | Where-Object { -not (Test-Path -Path $_)}) | where {$_ -ne $x})[-1]).remove(1,1)


$a=(Get-Disk).Number
    Mount-DiskImage -ImagePath $vhd
$b=(Get-Disk).Number
$c= Compare-Object -ReferenceObject $a -DifferenceObject $b -PassThru
initialize-disk -number $c -partitionStyle mbr 
New-Partition -DiskNumber $c -UseMaximumSize -DriveLetter $Destdrive
Format-Volume -DriveLetter $Destdrive -FileSystem "FAT" -NewFileSystemLabel "Config" -confirm:$false
$cgs=$config.CFG.Rollen.CGS
  $pth=  (split-path -Parent $configfile)

$dest=$Destdrive+":\"
if (!(Test-Path $dest)){
        # Auf grund eines sporadisch auftrendenden Problems, dass zwar das Laufwerk vorhanden ist, Powershell aber nicht darauf zugreifen kann, wird der Vorgang wiederholt
        Remove-Partition -DiskNumber $c -PartitionNumber 1
        $destdrive = (((Get-ChildItem function:[f-z]: -Name | Where-Object { -not (Test-Path -Path $_)}) | where {$_ -ne $x})[-2]).remove(1,1)
        New-Partition -DiskNumber $c -UseMaximumSize -DriveLetter $Destdrive
        Format-Volume -DriveLetter $Destdrive -FileSystem "FAT" -NewFileSystemLabel "Config" -confirm:$false
        $dest=$Destdrive+":\"
        write-Host "Alternativer Laufwerksbuchstabe $dest"
        Test-Path $dest}


 If (Test-Path($pth+'\mail-CGS'))
     {
      robocopy.exe "$pth\mail-CGS" ($Dest) /np /ns /nc /ndl /np /nfl /e  /is

      Remove-ReadOnlyAttribute -Path $dest
     }
$SVC=import-Csv   ((split-path -Parent $configfile) + "\svc.csv")
$LDAPUser= $SVC | where {$_.sam -eq $CGS.LDAPUsr}

$inis=Get-ChildItem ($dest+"*.*" ) -Recurse
$files=$inis.VersionInfo.fileName

foreach($file in $files)
{ set-cgswerte $file }



Dismount-DiskImage -ImagePath $vhd

$vmx= $config.CFG.HOST.vmPrefix+$mail.Name 
$Adapter=$mail.AdditionalNICs.AdditionalNIC.Name
$switchName=$mail.AdditionalNICs.AdditionalNIC.SwitchName

$NetworkAdapter= Get-VMNetworkAdapter -VMName $vmx | where {$_.Switchname -eq $switchName}
Disconnect-VMNetworkAdapter -VMNetworkAdapter $NetworkAdapter 
Get-VMNetworkAdapter -VMName $vmx
sleep 10
connect-VMNetworkAdapter -VMNetworkAdapter $NetworkAdapter -SwitchName $switchName
Get-VMNetworkAdapter -VMName $vmx

# start-vm ($config.cfg.host.VMPrefix + $mailName)
Write-Host ""
write-host "Bitte wechseln Sie zur VM $mailName und wählen Sie den Menüpunkt  " -ForegroundColor Yellow
write-host '"Collax Groupware Suite Installation" aus!' -ForegroundColor Yellow
write-host '"Die weitere Installation wird dann automatisch fortgesetzt!' -ForegroundColor Yellow


$WAV= Get-ChildItem -Path 'C:\Windows\Media\Ring08.wav' |  Select-Object -ExpandProperty Fullname
$player = New-Object Media.SoundPlayer $WAV
$player.Load();
$player.PlayLooping()
sleep 5
$player.Stop()
vmconnect $env:COMPUTERNAME $vmx
#Start-Process c:\windows\system32\vmconnect.exe -ArgumentList "$env:COMPUTERNAME $vmx" 

<#Start-VM -Name $vmx
sleep 3
vmconnect $env:COMPUTERNAME $vmx
sleep 5

[void] [System.Reflection.Assembly]::LoadWithPartialName("'Microsoft.VisualBasic")
[void] [System.Reflection.Assembly]::LoadWithPartialName("'System.Windows.Forms")
$x=(get-process | where {$_.MainWindowTitle -match $vmx }  ).MainWindowTitle
[Microsoft.VisualBasic.Interaction]::AppActivate($x)

[System.Windows.Forms.SendKeys]::SendWait("{DOWN}~")
Write-Host "nach Sendkeys"
SLEEP 4
[Microsoft.VisualBasic.Interaction]::AppActivate($x)

[System.Windows.Forms.SendKeys]::SendWait("{DOWN}{ENTER}")
Write-Host "nach Sendkeys"
[System.Windows.Forms.SendKeys]::SendWait("{F2}")
#>

Get-Date 

write-host "Die Konfiguration der VMs ist nun beendet"
"Ausführungszeit: {0:hh}:{0:mm}:{0:ss}" -f ((get-date)-$Start)
Stop-Transcript | Out-Null
Get-Date
