﻿#Requires –Version 3

Param 
      (
          [string]$vmName =$(throw '- Der Parameter -vmName wird benoetigt!') ,
          [string]$configfile
       )


$Start=Get-Date
write-host "     ************************************************************     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     *   AI2 Configure-DirectAccess Client by Thorsten Raucamp  *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     *                  Version 0.95 2014-05-15                 *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     ************************************************************     " -ForegroundColor DarkGreen
Write-Host ""
Write-Host ""
write-host "     Konfiguriere Client $VMName am: " -NoNewline
Get-Date
$Host.UI.RawUI.WindowTitle = "Configure DA-Client -- $vmName --"

if (!(Test-Admin)) {
                    $powershell = [System.Diagnostics.Process]::GetCurrentProcess()
                    $psi = New-Object System.Diagnostics.ProcessStartInfo $powerShell.Path
                    $script = $MyInvocation.MyCommand.Path
                    $prm = $script
                    foreach($a in $args) {$prm += ' ' + $a}
                    $psi.Arguments = $prm
                    $psi.Verb = "runas"
                    #$psi
                    [System.Diagnostics.Process]::Start($psi) | Out-Null
                    return;
                    # Neustart des Skriptes mit Adminrechten, sollte das aktuelle Skript nicht mit Administratorrechten 
                    # gestartet worden sein. Übernommen von der c't www.ct.de/1017144
                   }
if([string]::IsNullOrEmpty($configfile)) {$configfile=(Get-ItemProperty -path HKLM:\SOFTWARE\AI2).Configfile}
if (!(Test-Path $configfile)) {Write-Host "Bitte starten Sie das Skript erneut mit dem Parameter -configfile und der entsprechenden Pfadangabe"}
set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name Configfile -Value $configfile
[xml]$config = Get-Content $configfile
# Ende Header
$logfile=$config.cfg.log +$vmName+"-DAClient.txt"
$ErrorActionPreference="SilentlyContinue"
Stop-Transcript | Out-Null
$ErrorActionPreference="Continue"

Start-Transcript -Path $logfile -Append
#################################################################################################################################################

# Ende Header



$Domain=$config.CFG.Domain 
$DomainAdmin = New-Object System.Management.Automation.PSCredential ($Domain.Name + "\"+$Domain.Admin), (ConvertTo-SecureString $Domain.AdminPW -AsPlainText -Force)

$srv =$config.CFG.VMs.vm | where {$_.name -match $VMName}
$VMAdminPW=$srv.AdminPW
if([string]::IsNullOrEmpty($VMAdminPW)) {$VMAdminPW=$config.cfg.VMs.Default.AdminPW}
$VMAdmin = New-Object System.Management.Automation.PSCredential "Administrator", (ConvertTo-SecureString $VMAdminPW -AsPlainText -Force)

$srvIP=$srv.srvip
write-host "Überprüfe die Voraussetzungen für den Client $srvIP ..."

wait-forPC -computer $srvIP -Cred $VMAdmin	
if (!([string]::IsNullOrEmpty($config.cfg.Rollen.sp.require))){
                $preRollen=($config.cfg.Rollen.DAClient.require).Split(",")
                foreach ($preRolle in $preRollen)

                    { $preSrvIP=($config.CFG.VMs.vm | where {$_.Rollen -match $preRolle}).srvip
                         Write-Host "Überprüfe Rolle $preRolle auf $preSrvIP" -ForegroundColor Cyan
                        
                         do{write-host "." -NoNewLine -ForegroundColor "Red"}

                         until (Check-Rolle -Rolle $preRolle -IP $preSrvIP)
                         Write-Host "Die Rolle $preRolle steht zur Verfügung." -ForegroundColor Green
            }
            
    }
 
        Write-Host "Überprüfe, ob $srvIP erreichbar ist!" 
        check-DomainMember  $srvIP
                  do
                        {Write-Host "X" -ForegroundColor Cyan -NoNewline
                        }
                  until ((Check-WMSCon $srvIP) -eq $true)

$da=$config.CFG.Rollen.DirectAccess
$DCIP=($config.CFG.VMs.vm | where {$_.Rollen -match "DC"}).srvip

$mac= Invoke-Command  -ComputerName $srvIP -Credential $DomainAdmin  -Scriptblock {(Get-NetAdapter).MacAddress}

  Invoke-Command  -ComputerName $DCIP -Credential $DomainAdmin  -Scriptblock {
                $client=$using:srv.Name
                # DHCP-Reservierung für die bisherige statische IP-Adresse hinzufügen
                Add-DhcpServerv4Reservation -IPAddress $using:srvIP -ClientId $Using:mac -Description "Reserviert für $client " -ScopeID $using:config.CFG.Network.NetID -Name  $client
                
                # Client in die DirectAccess-Gruppe aufnehmen
                $DC=get-content env:computername
                $domain=$using:config.CFG.Domain.Name
                
                $baseOU=$using:config.cfg.Domain.BaseOU
                $DCX=$using:config.cfg.Domain.name
                $dc1,$dc2,$dc3,$dc4 =$DCX.split('.')
                $Pfad ="Dc=$dc1,DC=$dc2"
                if($DC3 -ne $null)
                    {$Pfad=$Pfad+",DC=$dc3"
                     if($DC4 -ne $null)
                        {$Pfad=$Pfad+",DC=$dc4"}}
                $gru="OU=$baseOU,$Pfad"  
                 $dagruppe=$using:da.Gruppe
                do
                        {Write-Host "." -NoNewline -ForegroundColor Yellow
                         sleep 10
                        }
                until ((Get-ADGroup  -Filter "Name -like '$dagruppe'").name -eq $dagruppe)
                add-ADGroupMember -Identity "CN=$dagruppe,OU=Gruppen,$gru" -Members (Get-ADComputer -Filter "name -like '$client'").DistinguishedName
                Write-Host "Computer wurde in Gruppe $dagruppe aufgenommen " -ForegroundColor Green
                }

               
Invoke-Command  -ComputerName $srvIP -Credential $DomainAdmin  -Scriptblock {
                $IPInterface=(Get-NetIPAddress | where {$_.ipaddress -eq $using:srvIP}).InterfaceIndex 
                # von Statischer IP-Adresse wieder auf DHCP umstellen
                # Remove-NetRoute -NextHop $gateway -InterfaceIndex  (Get-NetIPAddress | where {$_.ipaddress -eq $using:srvIP}).InterfaceIndex -Confirm $false
                # Remove-NetRoute -InterfaceIndex $IPInterface -Confirm:$false -DestinationPrefix 0.0.0.0/0
               
                set-NetIPInterface -Dhcp Enabled -InterfaceIndex  $IPInterface
                Write-Host "Habe DHCP enabled" -ForegroundColor Green
                Set-DnsClientServerAddress -ResetServerAddresses -InterfaceIndex  $IPInterface 
                Write-Host "Habe DNS-Client resetted" -ForegroundColor Green
                Set-NetFirewallRule -Name "FPS-ICMP4-ERQ-in" -enabled true -Profile Domain
                Write-Host "Habe Ping auf Domain-Level gesetzt." -ForegroundColor Green
                get-date
                                           
                }
sleep 10

Invoke-Command  -ComputerName $srvIP -Credential $DomainAdmin  -Scriptblock {
                $IPInterface=(Get-NetIPAddress | where {$_.ipaddress -eq $using:srvIP}).InterfaceIndex 
                # von Statischer IP-Adresse wieder auf DHCP umstellen
                # Remove-NetRoute -NextHop $gateway -InterfaceIndex  (Get-NetIPAddress | where {$_.ipaddress -eq $using:srvIP}).InterfaceIndex -Confirm $false
                #set-NetIPInterface -Dhcp Enabled -InterfaceIndex  $IPInterface
                #Set-DnsClientServerAddress -ResetServerAddresses -InterfaceIndex  $IPInterface 
                #set-NetFirewallRule -DisplayName “Datei- und Druckerfreigabe (Echoanforderung - ICMPv4 eingehend)” -enabled True -Profile Domain
                Write-Host "Entferne nun das Standard-Gateway" -ForegroundColor Green
                     
                Remove-NetRoute -InterfaceIndex $IPInterface -Confirm:$false -DestinationPrefix 0.0.0.0/0
                Write-Host "Entfernt!" -ForegroundColor Green
                Restart-Computer                       
                }        

write-host "Die Konfiguration des DA-Clients $VMName ist nun beendet! Restart erfolgt , um die neuen GPOs anzuwenden!" -NoNewline 
Get-Date
Restart-Computer -ComputerName $srvIP -Wait -For PowerShell -Force -Credential  $DomainAdmin
"Ausführungszeit: {0:hh}:{0:mm}:{0:ss}" -f ((get-date)-$Start)
get-date
Stop-Transcript | Out-Null


     
