﻿#Requires –Version 3

Param 
      (
          [string]$vmName =$(throw '- Der Parameter -vmName wird benoetigt!') ,
          [string]$configfile
       )


$Start=Get-Date
write-host "     *********************************************************     " -ForegroundColor DarkGreen
write-host "     *                                                       *     " -ForegroundColor DarkGreen
write-host "     * AI2 Installation DomainController by Thorsten Raucamp *     " -ForegroundColor DarkGreen
write-host "     *                                                       *     " -ForegroundColor DarkGreen
write-host "     *                Version 0.95 2014-05-15                *     " -ForegroundColor DarkGreen
write-host "     *                                                       *     " -ForegroundColor DarkGreen
write-host "     *********************************************************     " -ForegroundColor DarkGreen
Write-Host ""
Write-Host ""
Write-Host ""
Write-Host ""
write-host "Erstelle DC am: " -NoNewline
Get-Date
$Host.UI.RawUI.WindowTitle = "Configure Domaincontroller -- $vmName --"

if ((Get-Command Test-Admin -ErrorAction Ignore).Verb -ne "Test") {Start-Process   -WorkingDirectory $PSHOME -FilePath "powershell.exe" -ArgumentList "$PSScriptRoot\SUB\H1_globale-Funktionen.ps1" -Wait}


if (!(Test-Admin)) {
                    $powershell = [System.Diagnostics.Process]::GetCurrentProcess()
                    $psi = New-Object System.Diagnostics.ProcessStartInfo $powerShell.Path
                    $script = $MyInvocation.MyCommand.Path
                    $prm = $script
                    foreach($a in $args) {$prm += ' ' + $a}
                    $psi.Arguments = $prm
                    $psi.Verb = "runas"
                    #$psi
                    [System.Diagnostics.Process]::Start($psi) | Out-Null
                    return;
                    # Neustart des Skriptes mit Adminrechten, sollte das aktuelle Skript nicht mit Administratorrechten 
                    # gestartet worden sein. Übernommen von der c't www.ct.de/1017144
                   }
if([string]::IsNullOrEmpty($configfile)) {$configfile=(Get-ItemProperty -path HKLM:\SOFTWARE\AI2).Configfile}
if (!(Test-Path $configfile)) {Write-Host "Bitte starten Sie das Skript erneut mit dem Parameter -configfile und der entsprechenden Pfadangabe"}
set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name Configfile -Value $configfile
[xml]$config = Get-Content $configfile

$lang=Import-Csv ((Split-Path $configfile -Parent)+"\translations.csv")

# Ende Header

#Functions
Function add-DNSEintrag 
{<#
        .SYNOPSIS
            Erstellt sowohl den DNS-Eintrag, als auch gleichzeitig den PTR-Eintrag
        .Parameter Name
            Name des Computers, der im DNS eigetragen werden soll
            Erforderlicher Parameter!
 
        .Parameter IP
            IP des Computers, der im DNS eigetragen werden soll
            Erforderlicher Parameter!
   
        
        .Notes
            Wird fuer AI2 benoetigt.
        .link
            http://www.raucamp-solutions.de/AI2
     #>
    Param(
            [string]$Name =$(throw '- Der Parameter -Name des Eintrags wird benoetigt!') ,
            $IP =$(throw '- Der Parameter -IP des Eintrags wird benoetigt!')
            
            
         )
    [xml]$config = Get-Content ((get-ItemProperty -Path HKLM:\SOFTWARE\AI2).Configfile)
     $DCIP=($config.CFG.VMs.vm | where {$_.Rollen -match "DC"}).srvip
     $ADMCred = New-Object System.Management.Automation.PSCredential ($config.CFG.Domain.Name + "\"+$config.cfg.Domain.Admin), (ConvertTo-SecureString $config.CFG.Domain.DomainAdminPW -AsPlainText -Force)
     $zoneName= $IP.split('.')[2]+"."+$IP.split('.')[1]+"."+$IP.split('.')[0]+ ".in-addr.arpa"
     $DomainName=$config.cfg.Domain.Name
     $fqn=$name + "." +  $DomainName
     
    Invoke-Command  -ComputerName $DCIP -Credential $ADMCred  -Scriptblock {
             $IP=$using:IP
             $name=$using:Name
             $Zonename=$using:Zonename
             $fqn=$using:fqn
             Add-DnsServerResourceRecord –ZoneName $using:DomainName –A –Name $Name –AllowUpdateAny –AgeRecord  –IPv4Address $IP –TimeToLive 01.00:00:00 
             Add-DnsServerResourceRecord -Name $IP.split('.')[3] -Ptr -ZoneName $zoneName -AllowUpdateAny -PtrDomainName $fqn  
            }
           
}

# Ende Functions

$logfile=$config.cfg.log +$vmName+"-DC.txt"
$ErrorActionPreference="SilentlyContinue"
Stop-Transcript | Out-Null
$ErrorActionPreference="Continue"

Start-Transcript -Path $logfile -Append

#################################################################################################################################################
$skpath=(Get-ItemProperty HKLM:\SOFTWARE\AI2).scriptdir
$ConfirmPreference = "none"
Set-ExecutionPolicy bypass -force
Write-Host "Beginne mit der Konfiguration..." -NoNewline
Get-Date
$vm=$config.CFG.VMs.vm | where {$_.Rollen -match "DC"}
$Domain=$config.CFG.Domain  
# Credentials des lokalen Administrators
$VMAdminPW=$vm.AdminPW
if([string]::IsNullOrEmpty($VMAdminPW)) {$VMAdminPW=$config.cfg.VMs.Default.AdminPW}
$VMAdmin = New-Object System.Management.Automation.PSCredential "Administrator", (ConvertTo-SecureString $VMAdminPW -AsPlainText -Force)

$SRV = $vm.SRVIP
# hier die Credentials des Domain-Admins
$DomainAdmin = New-Object System.Management.Automation.PSCredential ($Domain.Name + "\"+$Domain.Admin), (ConvertTo-SecureString $Domain.DomainAdminPW -AsPlainText -Force)

wait-forPC -computer $srv -Cred $VMAdmin
<#
wait-forHost -computer $srv 
sleep 10
Write-Host "Warte auf WINRM."
Get-Date

do
{ sleep 10
  Write-Host "." -NoNewline -ForegroundColor Yellow
}
until ((Get-WmiObject -Query "Select * from Win32_service where Name='WinRM'" -ComputerName $SRV -Credential $DomainAdmin).state -eq "Running")
Write-Host "WinRM steht zur Verfügung" -ForegroundColor Cyan
Get-Date
Check-WMSCon -ComputerName $SRV
#>
$ErrorActionPreference="Continue"
Invoke-Command  -ComputerName $SRV -Credential $VMAdmin  -ScriptBlock   {
                   Write-Host "Installierte Software:"
                   Get-ItemProperty HKLM:\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\* | sort -Property DisplayName | Format-Table DisplayName, Publisher, DisplayVersion
                   $Cmmand= "sc.exe config NlaSvc start= delayed-auto"
                   Invoke-Expression -Command $Cmmand

                }
<#Write-Host "Vor AD-Einrichtung warte auf Computer"
wait-forHost -computer $SRV -Pause 180
Write-Host "Erneuter Check, ob Computer auch ansprechbar"
wait-forHost -computer $SRV -Pause 180
#>
wait-forPC -computer $srv -Cred $VMAdmin
Write-Host "Starte mit der Konfiguration"
Get-Date
$ErrorActionPreference="Continue"
do
{# Warteschleife
}
until (Check-WMSCon -ComputerName $SRV)
$ADScript= {
     if((Get-Item -Path HKLM:\SOFTWARE).GetSubKeyNames() -notcontains"AI2")
           {
            # Anlage eines neuen Schluessels fuer die Skripte
            new-Item -Path HKLM:\SOFTWARE -name AI2
           
           (Get-Item -Path HKLM:\SOFTWARE\AI2).GetSubKeyNames()
           }
     if(!(Get-ItemProperty -path HKLM:\SOFTWARE\AI2).AD)
                {
                 if (!((get-windowsfeature -Name AD-Domain-Services).installed)) {Install-WindowsFeature -Name AD-Domain-Services -IncludeManagementTools}
                 if (!((get-windowsfeature -Name Windows-server-backup).installed)) {Install-WindowsFeature -Name Windows-server-backup -IncludeManagementTools -IncludeAllSubFeature}
                 if (!((get-windowsfeature -Name DHCP).installed)) {Install-WindowsFeature -Name DHCP -IncludeManagementTools -IncludeAllSubFeature}
                 sleep 1
                 Write-Host "Starte mit ADDS-Deployment" -ForegroundColor Cyan 
                 Import-Module ADDSDeployment
                 if (!(Get-Module | where {$_.Name -ccontains "ADDSDeployment"})) 
                                {Write-host "Warte auf das Modul ADDSDeployment!" -ForegroundColor Yellow
                                 if (!((get-windowsfeature -Name AD-Domain-Services).installed)) {Install-WindowsFeature -Name AD-Domain-Services -IncludeManagementTools}
                                sleep 60
                                Import-Module ADDSDeployment
                                Get-Module
                                if (!(Get-Module | where {$_.Name -ccontains "ADDSDeployment"})) {pause}
                                }
                 Install-ADDSForest  `
                    -CreateDnsDelegation:$false  `
                    -DatabasePath "C:\Windows\NTDS"  `
                    -DomainMode $using:Domain.DomainMode  `
                    -DomainName $using:Domain.Name  `
                    -DomainNetbiosName $using:Domain.NetBIOSName  `
                    -ForestMode $using:Domain.DomainMode  `
                    -InstallDns:$true  `
                    -LogPath "C:\Windows\NTDS"  `
                    -SafeModeAdministratorPassword (ConvertTo-SecureString -AsPlainText $using:Domain.DomainAdminPW -Force)  `
                    -NoRebootOnCompletion:$true  `
                    -SysvolPath "C:\Windows\SYSVOL"  `
                    -Force:$true `
                    -NoDNSonNetwork `
                    -SkipPreChecks
                Out-File -FilePath c:\log\ps.txt -Append -InputObject "Install-ADDSForest ist abgeschlossen!"
                set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name AD -Value $true
                get-date  |Out-File -FilePath c:\log\ps.txt -Append
                $Cmmand= "sc.exe config NlaSvc start= delayed-auto"
                Invoke-Expression -Command $Cmmand
                Restart-Computer -Force 
                }

     
    }

$Error.Clear()

$erg= Invoke-Command  -ComputerName $SRV -Credential $VMAdmin  -ScriptBlock  $ADScript

#Write-host " Ergebnis des AD-Skriptblocks : $erg " -ForegroundColor Cyan
if ($Error[0]){$error[0]
                Write-Host "2.Versuch, AD zu erstellen" -NoNewline -ForegroundColor Yellow
                sleep 300
                Get-Date
                $Error.Clear()
                Invoke-Command  -ComputerName $SRV -Credential $VMAdmin  -ScriptBlock  $ADScript
                Restart-Computer  -Force
                
              }
#Neu

Write-Host "gehe schlafen..." -NoNewline -ForegroundColor Gray
sleep -Seconds 90
wait-forHost $SRV -Pause 1
Write-Host "...Setze Script fort" -ForegroundColor Gray
wait-forPC -computer $SRV -Cred $DomainAdmin
#Neu     wait-forHost -computer $srv -Pause 180

     <#wait-forHost -computer $SRV -Pause 180
     Write-Host "bin aufgewacht"
     sleep -Seconds 10 
     Write-Host "mache weiter..." -ForegroundColor Green
     wait-forHost -computer $SRV -Pause 180
     #>

    $preRolle="AD"
      
    Write-Host "Warte auf die Rolle $preRolle auf Server $Srv" -ForegroundColor Yellow

    do{write-host "." -NoNewLine -ForegroundColor Yellow}
    until (Check-Rolle -Rolle $preRolle -IP $Srv)
    Write-Host "Warte auf DNS."

Get-Date
 Write-Host "Warte auf den DNS-Dienst auf Server $Srv" -ForegroundColor Yellow
$Error.Clear()   
do
{ sleep 1
  Write-Host "." -NoNewline -ForegroundColor Yellow
}
until ((Get-WmiObject -Query "Select * from Win32_service where Name='DNS'" -ComputerName $SRV -Credential $DomainAdmin).state -eq "Running")

if ($Error[0]){$error[0]
                Write-Host "2.Versuch, auf DNS zuzugreifen." -NoNewline -ForegroundColor Yellow
                sleep 300
                Get-Date
                do
                    { sleep 10
                      Write-Host "." -NoNewline -ForegroundColor Yellow
                      $dnsrunning=(Get-WmiObject -Query "Select * from Win32_service where Name='DNS'" -ComputerName $SRV -Credential $DomainAdmin).state
                      if ($dnsrunning-ne "Running") {$dnsrunning= (Invoke-Command  -ComputerName $SRV -Credential $DomainAdmin  -ScriptBlock  {(Get-Service dns).status} ).value }
                     
                    }
                until ($dnsrunning -eq "Running")
                
                $Error.Clear()
                }



# DNS, DHCP und Kennwortpolicy
 Invoke-Command  -ComputerName $SRV -Credential $DomainAdmin  -ScriptBlock  {
    if(((Get-ItemProperty -path HKLM:\SOFTWARE\AI2).AD) -and (!(Get-ItemProperty -path HKLM:\SOFTWARE\AI2).DNS) ){
           write-host "Warte auf DNS-Autokonfiguration" 
            get-date
            do
            {
               Write-Host "." -NoNewline -ForegroundColor Cyan 
            }
            until ((get-DnsServerZone | where {$_.ZoneName -eq $using:Domain.Name}).IsDsIntegrated)
            if ((Get-NetConnectionProfile).NetworkCategory -ne "DomainAuthenticated"){Restart-Service -Name NlaSvc -Force}
            do
            { $x= (Get-Service nlasvc).status
              sleep 1  
            }
            until ($x -eq "Running")
            Get-Date
            
            Write-Host "Beginne mit DNS-Konfiguration"
            
            

            
            get-date

            Out-File -FilePath c:\log\ps.txt -Append -InputObject "Beginne mit DNS"
            get-date  |Out-File -FilePath c:\log\ps.txt -Append
            Enable-WSManCredSSP -Role Server -Force 
            $GWIP= $using:config.cfg.Network.GWIP
            $GWIP
            $DHCP=$using:config.cfg.Rollen.DHCP
            $srv=$using:srv
            Write-Host "Warte auf DNS-Dienst" -NoNewline
            Start-Service "DNS"
             do{write-host "." -NoNewLine -ForegroundColor "Red"
                sleep 10}
             until ((Get-Service |where {$_.Name -eq "DNS"}).Status -eq "Running")

            $DNS=$using:config.cfg.Rollen.DNS
            Set-DnsServerForwarder –IPAddress $GWIP |Out-File -FilePath c:\log\ps.txt -Append
            # DNS Reverse Zone einrichten
            $networkID=$using:config.CFG.Network.NetID+"/"+$using:config.CFG.Network.PrefixLength
            Add-DnsServerPrimaryZone -NetworkID $networkID -ReplicationScope "Forest"
            
            ####
            Set-DnsServerScavenging -ScavengingState $true -RefreshInterval $DNS.RefreshInterval -NoRefreshInterval $DNS.NoRefreshInterval -Verbose -PassThru 
            Set-DnsServerZoneAging $using:config.CFG.Domain.Name  -Aging $true  -ScavengeServers $srv -RefreshInterval $DNS.ZoneRefreshInterval -NoRefreshInterval $DNS.ZoneNoRefreshInterval -PassThru -Verbose
            set-DnsClientServerAddress -InterfaceAlias "Ethernet" -ServerAddresses "$srv,127.0.0.1"
            if (([System.Convert]::ToBoolean($DNS.UseRootHints)) -eq $false) {dnscmd /config /isslave 1 }
            
            ##### BPA
            #Enable-NetAdapterLso -Name *
            #Enable-NetAdapterRss -Name *
            #Enable-NetAdapterIPsecOffload -Name *
            ####
            Start-Sleep -Seconds 10
         
            Write-Host "DNS-Konfiguration ist abgeschlossen, beginne mit DHCP-Konfiguration..." 
            get-date
            Out-File -FilePath c:\log\ps.txt -Append -InputObject "Beginne mit DHCP"
            get-date  |Out-File -FilePath c:\log\ps.txt -Append

            Add-WindowsFeature DHCP -IncludeAllSubFeature -IncludeManagementTools |Out-File -FilePath c:\log\ps.txt -Append
            Set-DhcpServerv4Binding -BindingState $true -InterfaceAlias Ethernet |Out-File -FilePath c:\log\ps.txt -Append
            $dcfqdn=$using:vm.name+"."+$using:Domain.Name
            Add-DhcpServerInDC -DnsName $dcfqdn -ipaddress $using:vm.srvip |Out-File -FilePath c:\log\ps.txt -Append
            Add-DhcpServerv4Scope -Name $dhcp.v4ScopeName `
            -StartRange $DHCP.StartRange  `
            -EndRange $DHCP.EndRange `
            -SubnetMask $using:config.cfg.Rollen.DHCP.SubNetMask |Out-File -FilePath c:\log\ps.txt -Append
            # 3 --> Router  / 4--> Zeitserver  / 5 --> Namenserver / 6 DNS-Server
             Set-DhcpServerv4OptionValue -OptionId 6 `
            -value $DHCP.DNSServer #|Out-File -FilePath c:\log\ps.txt -Append # DNS-Server fuer DHCP festlegen. }
            Set-DhcpServerv4OptionValue -OptionId 5 `
            -value $DHCP.DNSServer #|Out-File -FilePath c:\log\ps.txt -Append # Namensserver fuer DHCP festlegen. }
            Set-DhcpServerv4OptionValue -OptionId 4 `
            -value  $GWIP #|Out-File -FilePath c:\log\ps.txt -Append # Zeitserver fuer DHCP festlegen. }
            Set-DhcpServerv4OptionValue -OptionId 3 `
            -value  $GWIP #|Out-File -FilePath c:\log\ps.txt -Append # Router fuer DHCP festlegen. }
            Set-DhcpServerv4OptionValue -OptionId 15 `
            -value  $using:config.CFG.Domain.Name #|Out-File -FilePath c:\log\ps.txt -Append # Router fuer DHCP festlegen. }
            netsh dhcp add securitygroups
            Restart-service dhcpserver
            Set-ItemProperty –Path registry::HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\ServerManager\Roles\12 –Name ConfigurationState –Value 2


           
            $IPv6=$using:config.cfg.Rollen.IPv6
            if ($IPv6.configure -eq $true){
                    Write-Host "Konfiguriere IPv6-Einstellungen!" -ForegroundColor Cyan
                    #set-DnsClientServerAddress  -ResetServerAddresses -InterfaceAlias "Ethernet"
                    # Definition des DHCPv6 Bereiches
                    Add-DhcpServerv6Scope -Name $IPv6.v6ScopeName -Description "Default IPv6 Bereich" -Prefix $IPv6.Prefix -PreferredLifeTime $ipv6.PreferredLifeTime -ValidLifeTime $IPv6.ValidLifeTime -State Active 
                    Add-DhcpServerv6ExclusionRange -Prefix $IPv6.Prefix -StartRange $IPv6.ExclusionStartRange -EndRange $IPv6.ExclusionEndRange
                    #Setzen der DHCPv6-Optionen
                    set-DhcpServerv6OptionValue -DomainSearchList $using:config.CFG.Domain.Name 
                    $DNSServer6= ($using:config.CFG.VMs.vm | where {$_.Rollen -match "DC"}).ipv6
                    set-DhcpServerv6OptionValue -DnsServer $DNSServer6
                    # Konfigruation der Firewall
                    Set-NetFirewallRule -Name "FPS-ICMP6-ERQ-In"  -Enabled True -Direction Inbound -Action Allow  #-DisplayName “Datei- und Druckerfreigabe (Echoanforderung - ICMPv6 eingehend)"
                    #set-dns-Server mit IPv6-Optionen
                    #set-DnsClientServerAddress -InterfaceAlias "Ethernet" -ServerAddresses "$srv, 127.0.0.1,$DNSServer6,::1" 
                    set-DnsClientServerAddress -InterfaceAlias "Ethernet" -ServerAddresses "$DNSServer6,::1" 

                    $networkID6=$IPv6.Prefix +"/"+$IPv6.PrefixLength
                    Add-DnsServerPrimaryZone -NetworkID $networkID6 -ReplicationScope "Forest"

                    netsh interface ipv6 set interface Ethernet forwarding=enabled
                    # Gateway herausnehmen

                    #Set-DhcpServerSetting  -ComputerName $srv -ActivatePolicies $true
                    # Set-DhcpServerv6Binding -InterfaceAlias "Ethernet" -BindingState $true
                    # Set-DhcpServerv6DnsSetting -IPAddress $DNSServer -DynamicUpdates OnClientRequest
                   }


     
      
          
           
            Out-File -FilePath c:\log\ps.txt -Append -InputObject "DHCP-Konfiguration ist abgeschlossen!"
            get-date  |Out-File -FilePath c:\log\ps.txt -Append
 
            Write-Host "DHCP-Konfiguration ist abgeschlossen, Setze Policies..."
            get-date
            # Kennworteinstellungen
             [bool]$ComplexityEnabled=$false
             if ($using:domain.KennwortPolicy.ComplexityEnabled -eq $true)
                {$ComplexityEnabled=$true}
             [bool]$ReversibleEncryptionEnabled=$false
             if ($using:domain.KennwortPolicy.ReversibleEncryptionEnabled -eq $true)
                {$ReversibleEncryptionEnabled=$true}
             set-ADDefaultDomainPasswordPolicy `
                -identity (get-ADDefaultDomainPasswordPolicy).objectGuid `
                -ComplexityEnabled $ComplexityEnabled `
                -MinPasswordAge $using:domain.KennwortPolicy.MinPasswordAge `
                -MaxPasswordAge $using:domain.KennwortPolicy.MaxPasswordAge `
                -MinPasswordLength $using:domain.KennwortPolicy.MinPasswordLength `
                -PasswordHistoryCount $using:domain.KennwortPolicy.PasswordHistoryCount `
                -LockoutDuration $using:domain.KennwortPolicy.LockoutDuration `
                -LockoutObservationWindow $using:domain.KennwortPolicy.LockoutObservationWindow `
                -ReversibleEncryptionEnabled $ReversibleEncryptionEnabled `
                -LockoutThreshold $using:domain.KennwortPolicy.LockoutThreshold
             set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name DNS -Value $true
             Write-Host "DNS, DHCP und Kennwortpolicy wurde angelegt" -ForegroundColor Green
            }
    }



 # Active Directory-Standorte und -Dienste konfigurierencls
 if (([System.Convert]::ToBoolean($Domain.SubnetzeEintragen)) -eq $true) {
       Invoke-Command  -ComputerName $SRV -Credential $DomainAdmin  -ScriptBlock  {
                    $Domain=$using:Domain       
                    If ($Domain.SiteName -ne "Default-First-Site-Name" ) { Get-ADReplicationSite "Default-First-Site-Name" | Rename-ADObject -NewName $Domain.SiteName}
       
                    # Übernommen von http://blogs.msdn.com/b/adpowershell/archive/2009/05/05/how-to-create-a-function-to-validate-the-existence-of-an-ad-object-test-xadobject.aspx
                    # Author Jairo Cadena

                    function Test-XADObject() {
                        [CmdletBinding(ConfirmImpact="Low")]
                        Param (
                                [Parameter(Mandatory=$true,
                                Position=0,
                                ValueFromPipeline=$true,
                                HelpMessage="Identity of the AD object to verify if exists or not."
                                )]
                                [Object] $Identity
                               )
                        trap [Exception] {return $false}
                        $auxObject = Get-ADObject -Identity $Identity
                        return $true
                    }

                    # Übernommen von http://blogs.msdn.com/b/adpowershell/archive/2009/05/05/how-to-create-a-function-to-validate-the-existence-of-an-ad-object-test-xadobject.aspx
                    # Author: Swaminathan Pattabiraman - Developer – Active Directory Powershell Team
                    #
                    # Advanced Function to create a new subnet.
                    #
                    function New-XADSubnet() {
                        [CmdletBinding(ConfirmImpact="Low")]
                        Param (
                                [Parameter(Mandatory=$true,
                                Position=0,
                                ValueFromPipeline=$true,
                                HelpMessage="Prefix of the subnet to be created. This should be a combination of IP Address followed by / and Prefix length. IPv4 example: 157.54.208.0/20  IPv6 example: 3FFE:FFFF:0:C000::/64 . NOTE: If the prefix length is not specified then this cmdlet will auto-generate the prefix length based on the number of trailing zero bits. For example: If supplied Prefix is 157.54.208.0 then the subnet created is 157.54.208.0/20. Another example: If supplied Prefix is 3FFE:FFFF:0:C000:: then the subnet created is 3FFE:FFFF:0:C000::/34"
                                )]
                                [String] $Prefix,
                                [Parameter(Mandatory=$false,
                                Position=1,
                                ValueFromPipeline=$false,
                                HelpMessage="Site to which the subnet will be applied. Accepts Site name, Guid, DN or ADObject representing the site"
                                )]
                                [Object] $Site,
                                [Parameter(Mandatory=$false,
                                ValueFromPipeline=$false,
                                HelpMessage="Description"
                                )]
                                [String] $Description,
                                [Parameter(Mandatory=$false,
                                ValueFromPipeline=$false,
                                HelpMessage="Location"
                                )]
                                [String] $Location
                              )
                        PROCESS {
                                 if ([String]::IsNullOrEmpty($Prefix)) {
                                 throw New-Object System.Management.Automation.PSArgumentException("Prefix name cannot be an empty string, please try again.")
                                }
                        $newSubnetName = $Prefix
                        if ($Prefix.Contains("/")) {
                            $subnetIPAddressStr,$prefixLengthStr = $newSubnetName.Split("/")
                            $subnetIPAddress = [System.Net.IPAddress]::Parse($subnetIPAddressStr)
                            $specifiedPrefixLength = [int]::Parse($prefixLengthStr)
                            $ipAddressPrefixLength = GetIPAddressPrefixLength $subnetIPAddress
                            if ($ipAddressPrefixLength -gt $specifiedPrefixLength) {
                                 throw New-Object System.Management.Automation.PSArgumentException("The subnet prefix length you specified is incorrect. Please check the prefix and try again.")
                                }
                           } 
                        else {
                                $subnetIPAddress = [System.Net.IPAddress]::Parse($newSubnetName)
                                $prefixLength = GetIPAddressPrefixLength $subnetIPAddress
                                $newSubnetName = $newSubnetName + "/" + $prefixLength
                             }
   
                        # Get the configuration partition DN, the sites container and build the new site DN
                        $configNCDN = (Get-ADRootDSE).ConfigurationNamingContext
                        $subnetContainerDN = ("CN=Subnets,CN=Sites," + $configNCDN)
                        $newSubnetDN = ("CN=" + $newSubnetName +"," + $subnetContainerDN)
                        $siteDN = $null
                        if ($Site -ne $null) {$siteDN = (Get-XADSite $Site).DistinguishedName}
   
                        # Verify if the subnet already exists
                        $subnetExists = Test-XADObject -Identity $newSubnetDN
                        if ($subnetExists) {throw New-Object System.Management.Automation.PSArgumentException("Subnet already exists. Please check the name and try again.")}
                        [Hashtable] $ht = new-object -type hashtable
                        if ($siteDN -ne $null) {$ht.Add("siteObject", $siteDN)}
                        if (-not [String]::IsNullOrEmpty($Description)) {$ht.Add("description", $Description)}
                        if (-not [String]::IsNullOrEmpty($Location)) {$ht.Add("location", $Location)}
   
                        # Create subnet object 
                        if ($ht.Count -eq 0) {New-ADObject -Name $newSubnetName -Path $subnetContainerDN -Type subnet} 
                        else {New-ADObject -Name $newSubnetName -Path $subnetContainerDN -Type subnet -OtherAttributes $ht}
                        # Fetch the subnet object
                        Get-ADObject $newSubnetDN -properties "siteObject", "description", "location"
                       }
                    }

                    #
                    # Internal utility function
                    # This function returns the number of trailing zeroes in the input byte
                    #
                    function GetNumberOfTrailingZeroes {
                                Param ([byte] $x)
                                $numOfTrailingZeroes = 0;
                                if ( $x -eq 0) {return 8}
                                if ( $x % 2 -eq 0) {
                                        $numOfTrailingZeroes ++;
                                        $numOfTrailingZeroes +=  GetNumberOfTrailingZeroes($x/2);
                                    }
                                return $numOfTrailingZeroes
                            }
                    #
                    # Internal utility function
                    # This function returns the number of non-zero bits in an ip-address
                    #
                    function GetIPAddressPrefixLength {
                                Param ([System.Net.IPAddress] $ipAddress)
                                $byteArray = $ipAddress.GetAddressBytes()
                                $numOfTrailingZeroes = 0;
                                for ($i = $byteArray.Length - 1; $i -ge 0; $i--) {
                                        $numOfZeroesInByte = GetNumberOfTrailingZeroes($byteArray[$i]);
                                        if ($numOfZeroesInByte -eq 0) {break;}
                                        $numOfTrailingZeroes += $numOfZeroesInByte;
                                      }
                                (($byteArray.Length * 8) - $numOfTrailingZeroes)

                              }
                    $networkID=$using:config.CFG.Network.NetID+"/"+$using:config.CFG.Network.PrefixLength
                    New-XADSubnet $networkID -Location $Domain.SiteName -Description "IPv4"

                    $IPv6=$using:config.cfg.Rollen.IPv6
                    if (([System.Convert]::ToBoolean($IPv6.configure)) -eq $true){                    
                            $networkID6=$IPv6.Prefix +"/"+$IPv6.PrefixLength
                            New-XADSubnet $networkID6 -Location $Domain.SiteName -Description "IPv6"
                       }
                    # Übernommen von  http://blogs.msdn.com/b/adpowershell/archive/2009/08/18/active-directory-powershell-to-manage-sites-and-subnets-part-3-getting-site-and-subnets.aspx
                    # Swaminathan Pattabiraman  Developer – Active Directory Powershell Team

                    ##  Print a list of site and their subnets
                    $siteName =  "Default-First-Site-Name"
                    $configNCDN = (Get-ADRootDSE).ConfigurationNamingContext
                    $siteContainerDN = ("CN=Sites," + $configNCDN)
                    $siteDN = "CN=" + $siteName + "," + $siteContainerDN
                    $siteObj = Get-ADObject -Identity $siteDN -properties "siteObjectBL", "description", "location" 
                    foreach ($subnetDN in $siteObj.siteObjectBL) {
                    Get-ADObject -Identity $subnetDN -properties "siteObject", "description", "location" 
}

       
       
       }
 }

 $SCDisk=$vm.additionalDisks.Disk | where {$_.schattenkopie -eq $true}
 $GWIP= $config.cfg.Network.GWIP
 add-DNSEintrag -Name $config.cfg.Network.GWName -IP $GWIP
 
  #Time-sync auf der VM des DCs deaktivieren
  $vmd= $config.cfg.HOST.VMPrefix+$VMName
 #### TEST Disable-VMIntegrationService -VMName $vmd -Name "Time Synchronization"    
 get-VMIntegrationService -VMName $VMd  
 #Verzeichnis-Struktur anlegen 
           
 Invoke-Command  -ComputerName $SRV -Credential $DomainAdmin  -ScriptBlock  {
    if(((Get-ItemProperty -path HKLM:\SOFTWARE\AI2).DNS) -and (!(Get-ItemProperty -path HKLM:\SOFTWARE\AI2).OU) ){ 
               $shadowDisk=$using:scdisk
               if(!([string]::IsNullOrEmpty($shadowDisk.label))) {
                    #übernommen von http://blogs.technet.com/b/core/archive/2012/04/20/aktivierung-der-schattenkopien-auf-non-csv-clustered-volumes-per-powershell-in-windows-server-2008-r2.aspx
                    $diskname = $shadowDisk.label
                    $VolumeWmi = gwmi Win32_Volume -Namespace root/cimv2 | ?{ $_.Label -eq $diskname }
                    $DeviceID = $VolumeWmi.DeviceID.ToUpper().Replace("\\?\VOLUME", "").Replace("\","")
                    $TaskName = "ShadowCopyVolume" + $DeviceID
                    $TaskFor = "\\?\Volume" + $DeviceID + "\\"
                    $Task = "%systemroot%\system32\vssadmin.exe Create Shadow /AutoRetry=15 /For=$TaskFor"
                    Write-Host -foreground green "Task" $TaskName "wird für" $diskname "eingerichtet."
                    schtasks /create /RU SYSTEM /SC DAILY /ST 03:00 /TN $TaskName /TR $Task /V1
                   }
               if ($using:config.cfg.Domain.configTimeServer -eq $true ) {
                       Write-Host "Setze Zeitserver"
                       If (!([string]::IsNullOrEmpty($using:config.cfg.Network.GWIP))){$ntpsrc=$using:config.cfg.Network.GWIP+",0×1,"}
                       $ntpsrc=$ntpsrc+ "de.pool.ntp.org"
                       #übernommen von http://www.doktorlatte.de/windows-server-20082008r22012-ntp-bzw-zeitserver-per-eingabeaufforderung-einstellen/
                       net stop w32time # Windows-Zeitgeber beenden
                       $Cmmand = "W32TM /config /syncfromflags:manual /manualpeerlist:" + [char]34 + $ntpsrc + [char]34
                       Invoke-Expression -Command $Cmmand 
                       w32tm /config /reliable:yes # Den angebundenen Clients verfügbar machen
                       #reg add HKLM\SYSTEM\CurrentControlSet\Services\W32Time\TimeProviders\VMICTimeProvider /v Enabled /t reg_dword /d 0 
                       set-ItemProperty -Path HKLM:\SYSTEM\CurrentControlSet\Services\W32Time\TimeProviders\VMICTimeProvider -name Enabled -Value 0
                       # siehe http://technet.microsoft.com/de-de/library/virtual_active_directory_domain_controller_virtualization_hyperv(v=ws.10).aspx
                       net start w32time # Windows-Zeitgeber neu starten
                       Write-Host "Setze Zeitserver beendet!" -ForegroundColor Green 
                    }
               if(((Get-ItemProperty -path HKLM:\SOFTWARE\AI2).AD) -and (!(Get-ItemProperty -path HKLM:\SOFTWARE\AI2).OU) ){
                    $LID=(((Get-WmiObject Win32_OperatingSystem))).OSLanguage
                    $v = ($using:lang | where {$_.lid -eq $lid})
                    If ([string]::IsNullOrEmpty($v.language)){$v=$lang[0]}
                    $v.language
                    # Home-Vereichnise für die Benutzer
                    $HomeDir="d:\user\Home"
                    md $HomeDir
                    # Freigabe  anlegen
                    New-SmbShare –Name "Home$" –Path $HomeDir –Description "Freigabe für Homeverzeichnisse" -FullAccess $v.Admingroup, $v.NTsystem -ChangeAccess $v.authUser
                    # Möglichkeit der Offline-Synchronisation einschalten
                    net share "Home$" /cache:manual
                    # Berechtigung auf Dateiebene setzen
                    $acl = Get-Acl $HomeDir
                    $permission = $v.authUser,"ReadAndExecute, ListDirectory, Read","Allow"
                    $accessRule = New-Object System.Security.AccessControl.FileSystemAccessRule $permission
                    $acl.SetAccessRule($accessRule)
                    $acl.SetAccessRuleProtection($true, $false) 
                    $acl | Set-Acl $HomeDir
                    Write-Host " Home wurde angelegt"
        
                    # Entfernen der Berechtigung für VORDEFINIERT\Benutzer, da die Berechtigungen alle explizit gesetzt werden
                    $LWD=$HomeDir
                    # Inspiriert durch http://www.it-visions.de/lserver/CodeSampleDetails.aspx?c=4930 
                    # Zugriff auf ACL - Einträge 
                    $acl= Get-Acl $LWD
                    #Alle Einträge holen
                    $aces =$acl.GetAccessRules($true, $true, [System.Security.Principal.NTAccount])
                    # Schleife über alle ACEs
                    foreach ($ace in $aces)
                        {
                            # Löschen aller Einträge von VORDEFINIERT\Benutzer
                            $ace.IdentityReference.ToString()
                            if ($ace.IdentityReference.ToString() -eq $v.BuildinUsers)
                                {$acl.RemoveAccessRule($ace)
                                 Write-Host "Berechtigung entfernt" -ForegroundColor Yellow}
                       }
                    # ACL speichern
                    set-acl -AclObject $ACL -Path $LWD
                    # Kontrollausgabe
                    $acl = Get-Acl $LWD
                    write-host "Aktuelle ACL für: $LWD"
                    $acl | fl
                    # Verzeichnis für die servergespeicherten Profile anlegen
                    $ProfileDir= "D:\user\Profile"
                    md $ProfileDir
                    New-SmbShare –Name "Profile$" –Path $ProfileDir –Description "Freigabe für Profilverzeichnis "  -FullAccess $v.Admingroup, $v.NTsystem -ChangeAccess $v.authUser
                    Write-Host " Profile wurde angelegt"

                    # Transferlaufwerk für alle Abteilungen
                    $TransferDir="D:\Daten\Transfer"
                    md $TransferDir
                    New-SmbShare –Name "Transfer" –Path $TransferDir –Description "Transferverzeichnis für alle "  -FullAccess $v.Admingroup, $v.NTsystem -ChangeAccess $v.authUser
                    $acl = Get-Acl $TransferDir
                    $permission = $v.authUser,"FullControl","Allow"
                    $accessRule = New-Object System.Security.AccessControl.FileSystemAccessRule $permission
                    $acl.SetAccessRule($accessRule)
                    $acl | Set-Acl $TransferDir
                    Write-Host "Transfer wurde angelegt"
                    set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name OU -Value $true
                    $InstShare=$using:config.cfg.Rollen.File.Share
                    if ((!([string]::IsNullOrEmpty($InstShare)))){
                    
                        # Install-Verzeichnis anlegen
                        $InstSrcDir="D:\Daten\$InstShare"
                        md $InstSrcDir
                        New-SmbShare –Name $InstShare –Path $InstSrcDir –Description "Verzeichnis für Installationssourcen "  -FullAccess $v.Admingroup, $v.NTsystem
                        $acl = Get-Acl $InstSrcDir
                        $permission = $v.Admingroup,"FullControl","Allow"
                        $accessRule = New-Object System.Security.AccessControl.FileSystemAccessRule $permission
                        $acl.SetAccessRule($accessRule)
                        $acl | Set-Acl $InstSrcDir
                        $Source="c:\install\File"
                        Write-Host "$InstShare wurde angelegt"
                        if (Test-Path $source)
                                           {# Wenn es existent ist 
                                            robocopy.exe $source ($instSrcDir) /s /np /ns /nc /nfl /ndl | Out-Host
                                           }
  
                       }


                   }
            Write-Host "Verzeichnis-Struktur wurde angelegt" -ForegroundColor Green


            set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name File -Value $true
            }
      }


    

                 # Datei aus der Config auslesen
    $SVC=import-Csv   ($config.cfg.Domain.Servicekonten)
    $Benutzer=import-Csv   ($config.cfg.Domain.Benutzerkonten)
    $usergroups=$config.cfg.Domain.Gruppen.split('#')

    # Gruppenanlage / OUs / Benutzer und Gruppenmitgliedschaften
Invoke-Command  -ComputerName $SRV -Credential $DomainAdmin  -ScriptBlock  {
     if(((Get-ItemProperty -path HKLM:\SOFTWARE\AI2).AD) -and (!(Get-ItemProperty -path HKLM:\SOFTWARE\AI2).USER) )
         {
          Write-Host "Beginne mit Benutzer und Gruppenanlage"
          get-date
            Out-File -FilePath c:\log\ps.txt -Append -InputObject "Beginne mit Usern"
            get-date  |Out-File -FilePath c:\log\ps.txt -Append
            $LID=(((Get-WmiObject Win32_OperatingSystem))).OSLanguage
            $v = ($using:lang | where {$_.lid -eq $lid})
            If ([string]::IsNullOrEmpty($v.language)){$v=$lang[0]}
            $v.language

                $DC=get-content env:computername
                $domain=$using:config.CFG.Domain.Name
                $fqdc=$DC+"."+$domain
                # OUs trennen
                $baseOU=$using:config.cfg.Domain.BaseOU
                $DCX=$using:config.cfg.Domain.name
                $dc1,$dc2,$dc3,$dc4 =$DCX.split('.')
                $Pfad ="Dc=$dc1,DC=$dc2"
                if($DC3 -ne $null)
                    {$Pfad=$Pfad+",DC=$dc3"
                     if($DC4 -ne $null)
                        {$Pfad=$Pfad+",DC=$dc4"}}

                # Anlage neuer OUs
                New-ADOrganizationalUnit -name $baseOU  -path $Pfad
                New-ADOrganizationalUnit -name Benutzer -path "OU=$baseOU,$Pfad"
                New-ADOrganizationalUnit -name Service  -path "OU=$baseOU,$Pfad"
                New-ADOrganizationalUnit -name Gruppen  -path "OU=$baseOU,$Pfad"
                New-ADOrganizationalUnit -name Computer -path "OU=$baseOU,$Pfad"
                New-ADOrganizationalUnit -name Abteilungen -path "OU=$baseOU,$Pfad"
                
                if ($using:domain.ADPapierkorb -eq $true){
                        # Papierkorb für AD einrichten (von Mark Marra,  www.mdmara.com/2013/04/best-paractes-for-configuring-new.html?m=1)
                        $ConfirmPreference = "none"
                        $ident = "CN=Recycle Bin Feature,CN=Optional Features, CN=Directory Service,CN=Windows NT,CN=Services,CN=Configuration,"+$Pfad
                        enable-adoptionalFeature -Identity $ident -Scope ForestOrConfigurationSet -Target $domain
                       } 
                if ($using:domain.RedirComputer -eq $true){
                        # Neue Computer automatisch in die OU Computer umleiten (von Mark Marra,  www.mdmara.com/2013/04/best-paractes-for-configuring-new.html?m=1)
                        $redircmp="OU=Computer,OU=$baseOU,$Pfad"
                        redircmp $redircmp
                       }

                #Auf dem Domain-Controller zur Syncronisation der Zeit einstellen (von Mark Marra,  www.mdmara.com/2013/04/best-paractes-for-configuring-new.html?m=1)
                $peerlist=$using:config.cfg.Network.GWIP+ ",0x8 0.pool.ntp.org,0x8 1.pool.ntp.org,0x8"
                w32tm /config /update /manualpeerlist:$peerlist /syncfromflags:MANUAL
                net stop w32time
                net start w32time



                # Anlage neuer Gruppen
                
                ForEach($group in $using:usergroups)
                    {$displayname,$groupname=$group.Split(':')
                     Write-Host "Erstelle Gruppen: Anzeigname: $displayname - Gruppenname:$groupname"
                     new-adgroup -displayname $displayname -name $groupname -path "OU=Gruppen,OU=$baseOU,$Pfad" -groupscope 1
                    }
                # Anlage vordefinierter Gruppen
                new-adgroup -displayname "Mail-Benutzer für die Collax Groupware Suite" -name "owa" -path "OU=Gruppen,OU=$baseOU,$Pfad" -groupscope 1
                new-adgroup -displayname "Mail-Benutzer mit erweiterten Rechten für die Collax Groupware Suite" -name "owaadmin" -path "OU=Gruppen,OU=$baseOU,$Pfad" -groupscope 1

              # Abteilungsgruppen und Abteilungslaufwerke  
                
                Foreach($Abteilung in ($using:config.CFG.Domain.Abteilungen).Split(','))
                {
                         Write-Host "Erstelle Gruppe: $Abteilung "
                         new-adgroup -displayname $Abteilung -name $Abteilung -path "OU=Abteilungen,OU=$baseOU,$Pfad" -groupscope 1
                         Write-Host "Erstelle Gruppeverzeichnis: $Abteilung "
                         md d:\daten\$Abteilung
                         $Berechtigung=$config.CFG.Domain.NetBIOSName+"\"+$Abteilung 
                         New-SmbShare –Name $Abteilung –Path d:\daten\$Abteilung –Description "Freigabe für $Abteilung" –FullAccess $Berechtigung
                         $name=$Abteilung
                                      $acl = Get-Acl d:\daten\$Abteilung
                                      $permission = "$NBN\$Abteilung","FullControl","Allow"
                                      $accessRule = New-Object System.Security.AccessControl.FileSystemAccessRule $permission
                                      $acl.SetAccessRule($accessRule)
                                      $acl | Set-Acl d:\daten\$Abteilung

                         #Grant-SmbShareAccess -Name $Abteilung -AccountName $GF -AccessRight "Read"
                        $TranferLW=$using:config.cfg.Domain.TransferLaufwerk 
                        $GruppenLW=$using:config.cfg.Domain.GruppenLaufwerk
                        $cmdf="@echo off
Net use $TranferLW \\$fqdc\Transfer  
Net use $GruppenLW \\$fqdc\$Abteilung"
                Out-File -FilePath "c:\windows\SYSVOL\SYSVOL\$Domain\scripts\$Abteilung.cmd" -Append -InputObject $cmdf  -Encoding ascii


                       }        
 

                # Anlage der Service-Accounts
                $using:svc     | ForEach-Object { New-ADuser -enabled $true -Name $_.SAM -samAccountName $_.SAM -Path "OU=Service,OU=$baseOU,$Pfad" -userPrincipalName $_.UPN -givenName $_.Vorname -SurName $_.Nachname -accountpassword  (ConvertTo-SecureString -AsPlainText $_.password -Force) -CannotChangePassword 1 -ChangePasswordAtLogon 0 -Description $_.Beschreibung -PasswordNeverExpires 1 -AllowReversiblePasswordEncryption 1 -ProfilePath ("\\$fqdc\user\profile\"+ $_.SAM)}
                 # Anlage der Benutzer-Accounts
                 $NBN=$using:config.cfg.Domain.NetBIOSName
                $DomainAdmins=$v.DomainAdmins
                $SchemaAdmins=$v.SchemaAdmins
                $EnterpriseAdmins=$v.EnterpriseAdmins

                $using:Benutzer| ForEach-Object { 
                                      #Anlage der Benutzer im AD  
                                      $abt=$_.Abteilung 
                                      $vorname= $_.Vorname
                                      $nachname=$_.Nachname
                                      $Mailadresse=$vorname+"."+$nachname+"@"+$using:config.cfg.Domain.MailDomain
                                      New-ADuser -enabled $true -Name $_.SAM  -DisplayName "$vorname $nachname"  -EmailAddress $Mailadresse -samAccountName $_.SAM -Path "OU=Benutzer,OU=$baseOU,$Pfad" -userPrincipalName $_.UPN -givenName $_.Vorname -SurName $_.Nachname -accountpassword  (ConvertTo-SecureString -AsPlainText $_.password -Force)  -Description $_.Beschreibung -Department $_.Abteilung -HomeDirectory ('\\users\home\'+ $_.SAM)  -Scriptpath "$abt.cmd" -OtherAttributes @{title=$_.Position; otherMailbox= $_.UPN } -ProfilePath ("\\$fqdc\profile$\"+ $_.SAM)
                                       
                                      # Erstellen des Homeverzeichnesses
                                      md ('D:\user\home\'+ $_.SAM)
                                      $name=$_.SAM
                                      $acl = Get-Acl d:\user\home\$name
                                      $UserRights = [System.Security.AccessControl.FileSystemRights] "ListDirectory, ReadData, WriteData, CreateFiles, CreateDirectories, AppendData, ReadExtendedAttributes, WriteExtendedAttributes, DeleteSubdirectoriesAndFiles, ReadAttributes, WriteAttributes, Write, ReadPermissions, Read, Modify, Synchronize"
                                      $permission = "$NBN\$name",$UserRights,"Allow" #"FullControl"
                                      $accessRule = New-Object System.Security.AccessControl.FileSystemAccessRule $permission
                                      $acl.SetAccessRule($accessRule)
                                      $acl | Set-Acl d:\user\home\$name
                                      $homeLetter =$using:config.cfg.Domain.HomeLaufwerk

                                      Get-ADUser -Identity $_.SAM | Set-ADUser -HomeDirectory "\\$fqdc\home$\$name" -HomeDrive $homeLetter
                                      $groupmember=($_.BenutzerGruppen).Split(' ')
                                      ForEach($groupname in $groupmember)
                                                {if ((([string]::IsNullOrEmpty($groupname)))) 
                                                    {}
                                                 elseif ($groupname -eq "ADM")
                                                    {add-ADGroupMember "CN=$DomainAdmins,CN=Users,$Pfad" $_.SAM
                                                     add-ADGroupMember "CN=$SchemaAdmins,CN=Users,$Pfad" $_.SAM
                                                     add-ADGroupMember "CN=$EnterpriseAdmins,CN=Users,$Pfad" $_.SAM}
                                                 else
                                                    {Write-Host " Benutzer $name wird Mitglied in $groupname."
                                                     add-ADGroupMember (get-adgroup $groupname) -member $_.SAM
													} 
                                      }

                                      #write-host "New-ADuser -enabled $true -Name $_.SAM -samAccountName $_.SAM -Path $_.Path -userPrincipalName $_.UPN -givenName $_.Vorname -SurName $_.Nachname -accountpassword  (ConvertTo-SecureString -AsPlainText $_.password -Force)  -Description $_.Beschreibung -Department $_.Abteilung -HomeDirectory ('\\users\home\'+ $_.SAM) -ProfilePath ('\\users\profiles\'+ $_.SAM) -Scriptpath ('\\logonScripts\'+ $_.SAM)  -OtherAttributes @{title=$_.Position ;mail= $_.UPN }"
                                    }

               <# ForEach($group in $using:usergroups)
                    {$displayname,$groupname=$group.Split(':')
                     Write-Host "Benutzer werden zur Gruppe :$groupname hinzugefuegt!"
                     $using:Benutzer | where-object {$_.BenutzerGruppen -match $groupname}   | foreach {add-ADGroupMember "cn=$groupname,OU=Gruppen,OU=$baseOU,$Pfad" $_.SAM}
                    }
                #>
                Foreach($Abteilung in ($using:config.CFG.Domain.Abteilungen).Split(',')){
                     Write-Host "Benutzer werden zur Gruppe :$Abteilung hinzugefuegt!"
                     $using:Benutzer | where-object {$_.Abteilung -match $Abteilung}   | foreach {add-ADGroupMember "cn=$Abteilung,OU=Abteilungen,OU=$baseOU,$Pfad" $_.SAM}
                    } 
                

                # Gruppe ADM
               <# $using:Benutzer | where-object {$_.BenutzerGruppen -match "ADM"}   | foreach {add-ADGroupMember "CN=$DomainAdmins,CN=Users,$Pfad" $_.SAM
                                                                                              add-ADGroupMember "CN=$SchemaAdmins,CN=Users,$Pfad" $_.SAM
                                                                                              add-ADGroupMember "CN=$EnterpriseAdmins,CN=Users,$Pfad" $_.SAM
                                                                                              #???Entferne ProfilePath
                                                                                              }
               #>
                Out-File -FilePath c:\log\ps.txt -Append -InputObject "USER-Konfiguration ist abgeschlossen!"
                get-date  |Out-File -FilePath c:\log\ps.txt -Append
                Write-Host "Gruppen und Benutzer erfolgreich angelegt."
                if ((Get-NetConnectionProfile).NetworkCategory -ne "DomainAuthenticated") {Restart-Service NLasvc -Force}
                set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name USER -Value $true
                Write-Host "DC ist nun konfiguriert." -NoNewline -ForegroundColor Green
                get-date 
                # ggf. neustart sinnvoll bevor DC gesetzt wird

                # BPA Stuff
                set-ItemProperty -Path "HKLM:\Software\Microsoft\Windows\CurrentVersion\Group Policy\History" -name "NetworkName" -Value $using:config.CFG.Domain.Name
                Set-DhcpServerv4OptionValue -OptionId 6 -value $using:config.CFG.Rollen.DHCP.DNSServer 
                $NBN=$using:config.cfg.Domain.NetBIOSName
                $DHCPUser= $using:svc | where {$_.Diensttyp -eq "DHCP"}
                If ([string]::IsNullOrEmpty($DHCPUser.sam)){$DHCPUser= $using:svc | where {$_.Diensttyp -eq "LDAP"}}
                $DHCPCred = New-Object System.Management.Automation.PSCredential ($NBN + "\"+$DHCPUser.SAM), (ConvertTo-SecureString $DHCPUser.Password -AsPlainText -Force)
                #### TEST Set-DhcpServerDnsCredential  -ComputerName $dc -Credential $DHCPCred
                Write-Host "$($DHCPUser.sam) ist für DHCP zuständig."
                # / BPA Stuff
                set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name DC -Value $true
                Write-host "Gruppen / OUs / Benutzer und Mitgliedschaften wurden erstellt." -ForegroundColor Green
                if (([System.Convert]::ToBoolean($using:config.CFG.Domain.ProtectOU)) -eq $true){
                               
                        Get-ADOrganizationalUnit -filter * -Properties ProtectedFromAccidentalDeletion | where {$_.ProtectedFromAccidentalDeletion -eq $false} | Set-ADOrganizationalUnit -ProtectedFromAccidentalDeletion $true
                      }

                #Backup AD
                <#
                # inspiriert durch http://serverfault.com/questions/510222/windows-server-2012-wbadmin-documentation

                $Day = Get-Date
                #Use this for Backups in Evening
                $Day = ($Day.AddDays(1)).DayOfWeek

                #Use this for Backups in the Morning
                #$Day = $Day.DayOfWeek

                $Date = Get-Date -format hhmmddMMyyyy
                $Server = hostname
                $Target = '\\backup\backups\'+$Server+'\'+$Day
                $VirtualMachines = Get-WBVirtualMachine


                $DailyFullWB = New-WBPolicy
                $BackupTarget = New-WBBackupTarget -NetworkPath $Target
                Set-WBPolicy -Policy $DailyFullWB
                Add-WBBackupTarget -Policy $DailyFullWB -Target $BackupTarget -Force
                Add-WBVirtualMachine -Policy $DailyFullWB -VirtualMachine $VirtualMachines
                Start-WBBackup -Policy $DailyFullWB -AllowDeleteOldBackups -Force   
                #>


                Get-Date
           
            }
    } 
   # ggf. neustart sinnvoll bevor DC gesetzt wird
   if (Check-Rolle -Rolle "DC" -IP $Srv)
      { sleep 5 
        $t=get-date 
        #set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name DC -Value $true
        set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name DCTime -Value $t
        Write-Host "Der DC ist nun funktionsfähig! $t" -ForegroundColor Green
     }

 
if(!(Check-Rolle -Rolle "DC" -IP $Srv)){
                    $powershell = [System.Diagnostics.Process]::GetCurrentProcess()
                    $psi = New-Object System.Diagnostics.ProcessStartInfo $powerShell.Path
                    $script = $MyInvocation.MyCommand.Path
                    $prm = $script
                    foreach($a in $args) {$prm += ' ' + $a}
                    $psi.Arguments = $prm
                    $psi.Verb = "runas"
                    #$psi
                    [System.Diagnostics.Process]::Start($psi) | Out-Null
                    return;
                    # Neustart des Skriptes mit Adminrechten, sollte das aktuelle Skript nicht mit Administratorrechten 
                    # gestartet worden sein. Übernommen von der c't www.ct.de/1017144
                   }

 
write-host "Die Konfiguration der VMs ist nun beendet"
"Ausführungszeit: {0:hh}:{0:mm}:{0:ss}" -f ((get-date)-$Start)
Stop-Transcript | Out-Null
