﻿#Requires –Version 3

Param 
      (
          [string]$vmName =$(throw '- Der Parameter -vmName wird benoetigt!') ,
          [string]$configfile
       )


$Start=Get-Date
write-host "     ************************************************************     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     * AI2 Configure-DirectAccess Server by Thorsten Raucamp    *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     *                  Version 0.95 2014-05-15                 *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     ************************************************************     " -ForegroundColor DarkGreen
Write-Host ""
Write-Host ""
write-host "     Konfiguriere Server $VMName am: " -NoNewline
Get-Date
$Host.UI.RawUI.WindowTitle = "Configure DirectAccess-Server -- $vmName --"

if (!(Test-Admin)) {
                    $powershell = [System.Diagnostics.Process]::GetCurrentProcess()
                    $psi = New-Object System.Diagnostics.ProcessStartInfo $powerShell.Path
                    $script = $MyInvocation.MyCommand.Path
                    $prm = $script
                    foreach($a in $args) {$prm += ' ' + $a}
                    $psi.Arguments = $prm
                    $psi.Verb = "runas"
                    #$psi
                    [System.Diagnostics.Process]::Start($psi) | Out-Null
                    return;
                    # Neustart des Skriptes mit Adminrechten, sollte das aktuelle Skript nicht mit Administratorrechten 
                    # gestartet worden sein. Übernommen von der c't www.ct.de/1017144
                   }
if([string]::IsNullOrEmpty($configfile)) {$configfile=(Get-ItemProperty -path HKLM:\SOFTWARE\AI2).Configfile}
if (!(Test-Path $configfile)) {Write-Host "Bitte starten Sie das Skript erneut mit dem Parameter -configfile und der entsprechenden Pfadangabe"}
set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name Configfile -Value $configfile
[xml]$config = Get-Content $configfile
# Ende Header
$logfile=$config.cfg.log +$vmName+"-DAServer.txt"
$ErrorActionPreference="SilentlyContinue"
Stop-Transcript | Out-Null
$ErrorActionPreference="Continue"

Start-Transcript -Path $logfile -Append
#################################################################################################################################################

# Ende Header



$Domain=$config.CFG.Domain 
$DomainAdmin = New-Object System.Management.Automation.PSCredential ($Domain.Name + "\"+$Domain.Admin), (ConvertTo-SecureString $Domain.AdminPW -AsPlainText -Force)

 $srv =$config.CFG.VMs.vm | where {$_.name -match $VMName}
 $srvIP=$srv.srvip
 $lang=Import-Csv ((Split-Path $configfile -Parent)+"\translations.csv")

 $da=$config.CFG.Rollen.DirectAccess
 $DCIP=($config.CFG.VMs.vm | where {$_.Rollen -match "DC"}).srvip
 $dC= ($config.CFG.VMs.vm | where {$_.Rollen -match "DC"}).name

write-host "Überprüfe die Voraussetzungen für den Server $srvIP ..."
Get-Date

        wait-forHost $srvIP
Write-Host "Host ist da! " -NoNewline 
Get-Date

        if (!([string]::IsNullOrEmpty($config.cfg.Rollen.sp.require))){
                $preRollen=($config.cfg.Rollen.DirectAccess.require).Split(",")
                foreach ($preRolle in $preRollen)
                    { $preSrvIP=($config.CFG.VMs.vm | where {$_.Rollen -match $preRolle}).srvip
                         $ErrorActionPreference="silentlyContinue"
                         do{
                                write-host "." -NoNewLine -ForegroundColor "Red"
                                $erg=(Check-Rolle -Rolle $preRolle -IP $preSrvIP)
                            }
                         until ($erg = $true)
                         $ErrorActionPreference="Continue"
                         Write-Host "Die Rolle $preRolle steht zur Verfügung." -ForegroundColor Green
                         Get-Date
            }
            
    }
 
do
{ sleep 10
  Write-Host "." -NoNewline -ForegroundColor Yellow
  $Erg = (Get-WmiObject -Query "Select * from Win32_service where Name='DNS'" -ComputerName $dC -Credential $DomainAdmin).state
}
until ($erg -eq "Running") 

                    Write-Host "Warte auf den DNS-Dienst auf Server $IP" -ForegroundColor Yellow
                    $Error.Clear()   
                    do
                        { $status=(Get-WmiObject -Query "Select * from Win32_service where Name='DNS'" -ComputerName $dC  -Credential $DomainAdmin).state
                          if (!($status -eq "running")){ 
                                sleep 1
                                Write-Host "-" -NoNewline -ForegroundColor Yellow
                                $status = $false
                                }
                        }
                    until ($status -eq "Running")

sleep 60
Check-WMSCon -ComputerName $dc
Check-WMSCon -ComputerName $srvIP   
        Write-Host "Überprüfe, ob $srvIP Mitglied in der Domäne ist" -BackgroundColor DarkGreen -ForegroundColor Yellow
        check-DomainMember  $srvIP
        Get-Date



Check-WMSCon -ComputerName $DCIP

   if (!([string]::IsNullOrEmpty($config.cfg.Rollen.DirectAccess.require))){
                         do{
                                write-host "." -NoNewLine -ForegroundColor "Red"
                                $erg=(Check-Rolle -Rolle $config.cfg.Rollen.DirectAccess.require -IP $DCIP)
                            }
                         until ($erg = $true)

                         }
 $dagruppe=$da.Gruppe
 add-ADGruppe -GruppenName $dagruppe -Displayname "Computer, die DirectAccess nutzen dürfen."


 Invoke-Command  -ComputerName $DCIP -Credential $DomainAdmin  -Scriptblock {
                $globalqueryblocklist=$using:da.globalqueryblocklist
                if ([string]::IsNullOrEmpty( $globalqueryblocklist)) {
                     $globalqueryblocklist="wpad isatap"
                     $stat=1
                   }
                if ( $globalqueryblocklist -eq "disabled"){
                     $globalqueryblocklist=""
                     $stat=0
                   }
                dnscmd /config /globalqueryblocklist $globalqueryblocklist
                dnscmd /config /enableglobalqueryblocklist $stat 
                }


Invoke-Command  -ComputerName $srvIP -Credential $DomainAdmin  -Scriptblock {

                 if (!((get-windowsfeature -name RemoteAccess).installed))
                            {   Write-Host "Installiere Windowsfeatures für DirectAccess" -ForegroundColor Cyan
                                Install-WindowsFeature RemoteAccess -IncludeManagementTools
                            }

                  if (!((get-windowsfeature -name DirectAccess-VPN).installed))
                            {   Write-Host "Installiere Windowsfeatures für DirectAccess Part 2" -ForegroundColor Cyan
                                Add-WindowsFeature -Name DirectAccess-VPN -IncludeManagementTools
                            }

                  
                  $LID=(((Get-WmiObject Win32_OperatingSystem))).OSLanguage
                  $v = ($using:lang | where {$_.lid -eq $lid})
                  If ([string]::IsNullOrEmpty($v.language)){$v=$lang[0]}
                  $v.language
                  $NetBiosName=$using:config.CFG.Domain.NetBIOSName
                  $DomainName=$using:config.CFG.Domain.Name
                  $dagruppe=$using:da.Gruppe
                  $srvName=$using:srv.Name
                  $ClGPO="$DomainName\DA-Client-GPO"
                  $SrvGPO="$DomainName\DA-Server-GPO"
                  $DAgroup="$NetBIOSName\$dagruppe"

                  $DAgroupOld="$DomainName\$($v.DomainComputers)"
                  $DAName=$srvName+"."+$using:config.CFG.Domain.Name
                  $PolicyStore = "$DomainName\DA-Clienteinstellungen"
                  $SupportEmail= $using:DA.SupportEmail
                  $CR1 ="HTTP:http://directaccess-WebProbeHost."+$DomainName 
                  $CR2 = "PING:"+$using:dC+"."+$DomainName
                  $Netzbezeichnung=$using:da.Netzbezeichnung
                  Write-Host ".." 
                  $using:da.publicAdress
                  $ClGPO
                  $SrvGPO
                  $DAgroup
                  $DAgroupOld
                  write-host "xxx $DAName xxx"
                  $PolicyStore 
                  $SupportEmail 
                  $CR1 
                  $CR2 
                  $Netzbezeichnung
               
                install-RemoteAccess -Prerequisite

                Install-RemoteAccess -NoPrerequisite `
                                     -Force `
                                     -PassThru `
                                     -ServerGpoName $SrvGPO `
                                     -ClientGpoName $ClGPO `
                                     -DAInstallType 'FullInstall' `
                                     -InternetInterface 'Ethernet' `
                                     -InternalInterface 'Ethernet' `
                                     -ConnectToAddress $using:da.publicAdress `
                                     -DeployNat `
                                     -Verbose `
                                     -ComputerName $DAName 


                 Add-DAClient -SecurityGroupNameList @($DAgroup) -Verbose -ComputerName $DAName
                 Remove-DAClient -SecurityGroupNameList @($DAgroupOld) -Verbose -ComputerName $DAName
                 Set-DAClient -OnlyRemoteComputers $using:DA.OnlyRemoteComputers -Verbose -ComputerName $DAName
                 Set-DAClientExperienceConfiguration -FriendlyName $Netzbezeichnung -PreferLocalNamesAllowed $True -PolicyStore $ClGPO -SupportEmail $SupportEmail  -CorporateResources @($CR1,$CR2)
                 set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name DirectAccess -Value $true

                    
                }   -Authentication Credssp

        

write-host "Die Konfiguration des DA-Servers $VMName ist nun beendet!"
"Ausführungszeit: {0:hh}:{0:mm}:{0:ss}" -f ((get-date)-$Start)
get-date
Stop-Transcript | Out-Null


     
