﻿$Start=Get-Date
write-host "     ********************************************************     " -ForegroundColor DarkGreen
write-host "     *                                                      *     " -ForegroundColor DarkGreen
write-host "     * AI2 Installation Collax Firewall by Thorsten Raucamp *     " -ForegroundColor DarkGreen
write-host "     *                                                      *     " -ForegroundColor DarkGreen
write-host "     *                Version 0.95 2014-05-15               *     " -ForegroundColor DarkGreen
write-host "     *                                                      *     " -ForegroundColor DarkGreen
write-host "     ********************************************************     " -ForegroundColor DarkGreen
Write-Host ""
Write-Host ""
Write-Host ""
write-host "Erstelle VMs am: " -NoNewline
Get-Date
$Host.UI.RawUI.WindowTitle = "Configure Firewall -- $vmName --"
if (!(Test-Admin)) {
                    $powershell = [System.Diagnostics.Process]::GetCurrentProcess()
                    $psi = New-Object System.Diagnostics.ProcessStartInfo $powerShell.Path
                    $script = $MyInvocation.MyCommand.Path
                    $prm = $script
                    foreach($a in $args) {$prm += ' ' + $a}
                    $psi.Arguments = $prm
                    $psi.Verb = "runas"
                    #$psi
                    [System.Diagnostics.Process]::Start($psi) | Out-Null
                    return;
                    # Neustart des Skriptes mit Adminrechten, sollte das aktuelle Skript nicht mit Administratorrechten 
                    # gestartet worden sein. Übernommen von der c't www.ct.de/1017144
                   }
if([string]::IsNullOrEmpty($configfile)) {$configfile=(Get-ItemProperty -path HKLM:\SOFTWARE\AI2).Configfile}
if (!(Test-Path $configfile)) {Write-Host "Bitte starten Sie das Skript erneut mit dem Parameter -configfile und der entsprechenden Pfadangabe"}
set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name Configfile -Value $configfile
[xml]$config = Get-Content $configfile
# Ende Header

$config.cfg.rollen.FW
$FW=$config.CFG.VMs.vm | where {$_.Rollen -match "FW"}
$FWPath=$FW.Path
if([string]::IsNullOrEmpty($FWPath)){$FWPath=$config.cfg.VMs.Default.Path}
$vmName = $fw.Name

$logfile=$config.cfg.log +$vmName+"FW-config.txt"
$ErrorActionPreference="SilentlyContinue"
Stop-Transcript | Out-Null
$ErrorActionPreference="Continue"

Start-Transcript -Path $logfile -Append
#################################################################################################################################################


#überprüfe, ob DC schon fertig ist.
if (!([string]::IsNullOrEmpty($config.cfg.Rollen.fw.require))){
    $preRolle=$config.cfg.Rollen.fw.require
    $preSrvIP=($config.CFG.VMs.vm | where {$_.Rollen -match $preRolle}).srvip
    wait-forHost -computer $preSrvIP -Pause 120
    wait-forHost -computer $preSrvIP -Pause 120
    
    
    Write-Host "Warte auf die Rolle $preRolle auf Server $preSrvIP" -ForegroundColor Yellow
    do{write-host "." -NoNewLine -ForegroundColor "Red"}
    until (Check-Rolle -Rolle $preRolle -IP $preSrvIP)
    Write-Host "Die Rolle $preRolle steht zur Verfügung. Setzte das Skript FW fort." -ForegroundColor Green
   }

#################################################################################################################################################


$vhd=$FWPath+"\"+$config.CFG.HOST.vmPrefix+$FW.Name+"\Virtual Hard Disks\"+$FW.additionalDisks.Disk.VHDName
$SVC=import-Csv   ((split-path -Parent $configfile) + "\svc.csv")
$Host.UI.RawUI.WindowTitle = "Configure-VM -- $vmName -- AI2 --"

function set-cgswerte
{ Param(
            [string]$FileToChange
            
        )

    If (!(Test-Path $FileToChange)) 
            {Write-Host "Die angegebene Datei $FileToChange konnte nicht gefunden werden." -ForegroundColor Red
            break}
    #$fi= Get-Content -Path "f:\collax-ai.conf"
    $fi= [IO.File]::ReadAllText($FileToChange)
    $DCIP=($config.CFG.VMs.vm | where {$_.Rollen -match "DC"}).srvip
    $DCName=($config.CFG.VMs.vm | where {$_.Rollen -match "DC"}).Name
    $FWs=$config.CFG.rollen.FW
    $FWIP= $FW.SRVIP
    $DCX=$config.cfg.Domain.name
         $dc1,$dc2,$dc3,$dc4 =$DCX.split('.')
         $BaseDN ="dc=$dc1,dc=$dc2"
                if($DC3 -ne $null)
                    {$BaseDN=$BaseDN+",dc=$dc3"
                     if($DC4 -ne $null)
                        {$BaseDN=$BaseDN+",dc=$dc4"}}
    
    $binddn="cn=Manager,$BaseDN"
    $fi=$fi.replace( "#basedn#", $BaseDN)
    $fi=$fi.replace( "#binddn#", $binddn)
    $fi=$fi.replace( "#SRVIP#", $FWIP)
    $fi=$fi.replace( "#NetMask#", $config.CFG.Rollen.DHCP.SubNetMask)
    $fi=$fi.replace( "#FQDN#", $vmname + "." + $config.CFG.Domain.Name)
    $fi=$fi.replace( "#IPGW#", $config.CFG.Network.GWIP)
    $fi=$fi.replace( "#NETZ#", $config.CFG.Network.NetID)
    $fi=$fi.replace( "#SUBNET#", $config.CFG.Rollen.DHCP.SubNetMask)
    $fi=$fi.replace( "#Lang#", $FWs.Lang)
    $fi=$fi.replace( "#continent#", $FWs.Continent)
    $fi=$fi.replace( "#location#", $FWs.Region)
    $fi=$fi.replace("#IPDC#", $DCIP)  
    $fi=$fi.replace("#DCName#",   $DCName)
    $fi=$fi.replace("#NETBIOSNAME#",  $config.cfg.Domain.NetBIOSName)
    $fi=$fi.replace("#DOMAINNAME#",  $config.cfg.Domain.Name)
    $fi=$fi.replace("#MailDomain#",  $config.cfg.Domain.MailDomain)
    $fi=$fi.replace("#CertPW#", $FWs.CertPW)
    $fi=$fi.replace("#ADMMail#", $FWs.CollaxAdminMail)
    $fi=$fi.replace("#CAdmPW#", $FWs.CollaxAdminPW)
    $fi=$fi.replace("#CRootPW#",  $FWs.CollaxRootPW)
    $fi=$fi.replace("#DAIP#",($config.CFG.vms.vm | Where-Object {$_.rollen -contains "DirectAccess"}).srvip)
    $fi=$fi.replace("#MAILIP#",($config.CFG.vms.vm |  Where-Object {$_.rollen -contains "CGS"}).srvip)
    # ToDo Andere Mail-Systeme wie Exchange berücksichtigen
    $fi=$fi.replace("#SRV#", $vmname)
    $fi=$fi.replace("#DMZNetwork#", $FWs.DMZNetwork) 
    $fi=$fi.replace("#DMZNetMask#", $FWs.DMZNetMask) 
    $fi=$fi.replace("#DMZNetzIPFW#", $FWs.DMZNetzIPFW)
    $fi=$fi.replace("#DMZROUTERIP#", $FWs.DMZROUTERIP)

    Out-File -FilePath "$FileToChange" -InputObject $fi -Force -Encoding ascii
}


#$Destdrive=$config.CFG.HOST.tmpLW
$destdrive = (((Get-ChildItem function:[f-z]: -Name | Where-Object { -not (Test-Path -Path $_)}) | where {$_ -ne $x})[-3]).remove(1,1)
#[string]$dest = ((Get-Partition (Get-Diskimage -ImagePath $vhd).Number | where {$_.size -gt (512)}).DriveLetter)+ ":\"
$a=(Get-Disk).Number
    Mount-DiskImage -ImagePath $vhd
$b=(Get-Disk).Number
$c= Compare-Object -ReferenceObject $a -DifferenceObject $b -PassThru
initialize-disk -number $c -partitionStyle mbr 
New-Partition -DiskNumber $c -UseMaximumSize -DriveLetter $Destdrive
Format-Volume -DriveLetter $Destdrive -FileSystem "FAT" -NewFileSystemLabel "Config" -confirm:$false
$pth=  (split-path -Parent $configfile)

$dest=$Destdrive+":\"
if (!(Test-Path $dest)){
        # Auf grund eines sporadisch auftrendenden Problems, dass zwar das Laufwerk vorhanden ist, Powershell aber nicht darauf zugreifen kann, wird der Vorgang wiederholt
        Remove-Partition -DiskNumber $c -PartitionNumber 1 -Confirm $false 
        $destdrive = (((Get-ChildItem function:[f-z]: -Name | Where-Object { -not (Test-Path -Path $_)}) | where {$_ -ne $x})[-4]).remove(1,1)
        New-Partition -DiskNumber $c -UseMaximumSize -DriveLetter $Destdrive
        Format-Volume -DriveLetter $Destdrive -FileSystem "FAT" -NewFileSystemLabel "Config" -confirm:$false
        $dest=$Destdrive+":\"
        write-Host "Alternativer Laufwerksbuchstabe $dest"
        Test-Path $dest}

  If (Test-Path($pth+'\FW-CSG'))
     {
      robocopy.exe "$pth\FW-CSG" ($Dest) /np /ns /nc /ndl /np /nfl /e  /is

      Remove-ReadOnlyAttribute -Path $dest
     }
$fwIP= $FW.srvip

$inis=Get-ChildItem ($dest+"*.*" ) -Recurse
$files=$inis.VersionInfo.fileName

foreach($file in $files)
{ set-cgswerte $file }

$delfile=($dest+"data\etc\rc.local\S55DirectAccess")


Dismount-DiskImage -ImagePath $vhd


$vmx= $config.CFG.HOST.vmPrefix+$fw.Name 
$nics=$fw.AdditionalNICs.AdditionalNIC 
foreach ($nic in $nics)
            {
             $Adapter=$nic.Name
             $switchName=$nic.SwitchName
             Write-Host $Adapter , $switchName
             $NetworkAdapter= Get-VMNetworkAdapter -VMName $vmx | where {$_.Switchname -eq $switchName}
             Disconnect-VMNetworkAdapter -VMNetworkAdapter $NetworkAdapter 
             #Get-VMNetworkAdapter -VMName $vmx
             Write-Host "---"
             sleep 4
             connect-VMNetworkAdapter -VMNetworkAdapter $NetworkAdapter -SwitchName $switchName
             #Get-VMNetworkAdapter -VMName $vmx
            }

Get-VMNetworkAdapter -VMName $vmx |ft

Start-Process c:\windows\system32\vmconnect.exe -ArgumentList "$env:COMPUTERNAME $vmx" 
#vmconnect $env:COMPUTERNAME $vmx
#start-vm ($config.cfg.host.VMPrefix + $mail.Name)

write-host "*************************************"
Write-Host ""
write-host "Bitte Starten Sie die VM $vmName manuell und wählen Sie den Menüpunkt  " -ForegroundColor Yellow
write-host '"Collax Security Gateway Installation" aus!' -ForegroundColor Yellow
write-host '"Die weitere Installation wird dann automatisch fortgesetzt!' -ForegroundColor Yellow


Get-Date 

write-host "Die Konfiguration der Firewal ist nun beendet"
"Ausführungszeit: {0:hh}:{0:mm}:{0:ss}" -f ((get-date)-$Start)
Stop-Transcript | Out-Null
#pause
