﻿
$Start=Get-Date

$Start=Get-Date
write-host "     ************************************************************     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     *  Skript Globale Funktionen für  AI2 by Thorsten Raucamp  *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     *                  Version 0.95 2014-05-15                 *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     ************************************************************     " -ForegroundColor DarkGreen
Write-Host ""
Write-Host ""
Write-Host ""
write-host "Globale Funktionen werden bereitgestellt am: " -NoNewline
Get-Date

function Test-Admin {
 <#
        .SYNOPSIS
           überprüft, ob das Skript mit Admin-Rechten ausgeführt wird.
        
        
        .Notes
            Ohne Parameter. Liefert false zurück, falls das Skript ohne Adminrechte gestartet wurde.
            Quelle: PowerShell.com Powertip of the Day 24.09.2013
        .link
            http://www.powershell.com
     #>
 [bool]((whoami /groups) -match "S-1-16-12288") 
 } 

if (!(Test-Admin)) {
                    $powershell = [System.Diagnostics.Process]::GetCurrentProcess()
                    $psi = New-Object System.Diagnostics.ProcessStartInfo $powerShell.Path
                    $script = $MyInvocation.MyCommand.Path
                    $prm = $script
                    foreach($a in $args) {$prm += ' ' + $a}
                    $psi.Arguments = $prm
                    $psi.Verb = "runas"
                    #$psi
                    [System.Diagnostics.Process]::Start($psi) | Out-Null
                    return;
                    # Neustart des Skriptes mit Adminrechten, sollte das aktuelle Skript nicht mit Administratorrechten 
                    # gestartet worden sein. Übernommen von der c't www.ct.de/1017144
                   }





######################################################################################################################################################################
$Name7="Test-Admin"
New-Item -Path $home\Documents\WindowsPowerShell\Modules\$name7\$name7.psm1 -ItemType File -Force -Value "function $Name7 {$((Get-Item function:\$name7).definition) }"   | Out-Null
######################################################################################################################################################################

function Test-Admin { [bool]((whoami /groups) -match "S-1-16-12288") } 

Test-Admin


function Get-Config
{
     <#
        .SYNOPSIS
            sucht die aktuelle Konfigurationsdatei und setzt sie in die Registry
        .Parameter Configfile
            Konfigurationsdatei mit vollständigem Pfad, die für die Ausführung des Skriptes herangezogen werden soll
            Optional, muss nur angegeben werden, wenn die Datei gewechselt werden muss!
        .Parameter ScriptDir
            Verzeichnis in dem die Skripte von AI2 liegen
            Optional, muss nur angegeben werden, wenn die Datei gewechselt werden muss!
        
        .Example
            get-config
            gibt die registrierte Konfigurationsdatei aus
        .Example
            get-config -Configfile G:\AI2\cfg\Testconfig.xml
            Ueberprueft, ob die Configdatei gültig ist und schreibt sie als neue Config-Datei in die Registry
        .Notes
            Wird benötigt um die zentrale Konfigurationsdatei zu bestimmen
        .link
            http://www.raucamp-solutions.de/AI2
     #>
     Param(
            [string]$Configfile,
            [string]$SkriptDir
          )
    if(!([string]::IsNullOrEmpty($configfile)))
        { # Es wurde eine Konfigruationsdatei übergeben
        #Überprüfen, ob die Datei auch existiert
         If (!(Test-Path $Configfile)) 
            {Write-Host "Die angegebene Konfigurationsdatei $Configfile konnte nicht gefunden werden." -ForegroundColor Red
            break}

        If (!([string]::IsNullOrEmpty($skriptdir)))
            {
             If (!(Test-Path $SkriptDir)) # Wenn nicht, dann erstelle es
                {Write-Host "Das angegebene Verzeichnis $skriptdir konnte nicht gefunden werden." -ForegroundColor Red
                 break
                }
            }

        # Überprüfung des allgemeinen Registry-Eintrags
        if((Get-Item -Path HKLM:\SOFTWARE).GetSubKeyNames() -notcontains"AI2")
           {
            # Anlage eines neuen Schluessels fuer die Skripte
            #new-Item -Path HKLM:\SOFTWARE -name RS
            new-Item -Path HKLM:\SOFTWARE -name AI2   
           }
        # Abspeichern des Skriptverzeichnissses wenn es einen Wert gibt
        if (!([string]::IsNullOrEmpty($skriptdir)))
           {set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name Scriptdir -Value $SKriptDir}
        # Schreiben der neuen Konfigurationsdatei in die Registry
        set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name Configfile -Value $configfile
        }
    else 
        {$Configfile=(Get-ItemProperty -path HKLM:\SOFTWARE\AI2).Configfile}
    
    If (!(Test-Path $Configfile)) 
        {# Wenn die Datei nicht existiert, dann Meldung!
        Write-Host "$configfile nicht gefunden! bitte Skript mit Angabe der Konfigdatei -configfile erneut ausführen!"}
  
    $Configfile
    
}
######################################################################################################################################################################
$Name0="get-config"
New-Item -Path $home\Documents\WindowsPowerShell\Modules\$name0\$name0.psm1 -ItemType File -Force -Value "function $Name0 {$((Get-Item function:\$name0).definition) }"  | Out-Null
######################################################################################################################################################################


function wait-forHost
    {
     <#
        .SYNOPSIS
            wartet darauf, dass der Host anpingbar wird
        .Parameter Computer
            Computername oder IP des Computers, auf den gewartet werden soll 
            Erforderlicher Parameter!
        .Parameter Pause
            [Optional] variiert die Wartezeit (in Sekunden), die nach dem ersten erfolgreichen Ping vergehen soll, bis die Funktion beendet wird
            Standardwert ist 10 (Sekunden)
        .Example
            Wait-forHost -Computer DC1 -pause 15
            Ueberprueft solange per Ping bis Computer DC1 wieder erreichbar ist. Dann werden noch 15 Sekunden gewartet, bis dass die Funktion beendet wird.
        .Notes
            Hilft, wenn der entfernte Computer zwischendurch neu gestartet wird
            von http://chrisfederico.wordpress.com/2008/07/18/ping-a-machine-from-powershell/ inspiriert
        .link
            http://www.raucamp-solutions.de/AI2
     #>
     Param(
            [string]$computer =$(throw '- Der Parameter -Computer wird benoetigt!'),
            [int]$Pause = 10
            )
    $ErrorActionPreference="SilentlyContinue"
    $ping = new-object System.Net.Networkinformation.Ping
    #Write-Host "Pinge $computer an." -ForegroundColor Cyan
    $result = $ping.send($Computer)
    if ($result.status -ne "Success"){
        do{
            $result = $ping.send($Computer)
            write-host "*" -NoNewLine -ForegroundColor Cyan
            sleep 10
            }
        until ($result.status -eq "Success")
        Write-host "Warte nun $pause Sekunden."
        sleep -Seconds $Pause
        write-host "." -ForegroundColor "Green"
        }
    $ErrorActionPreference="Continue"
    }
   # wait-forHost -computer 127.0.0.1 -Pause 1

   

######################################################################################################################################################################
$Name1="wait-forHost"
New-Item -Path $home\Documents\WindowsPowerShell\Modules\$name1\$name1.psm1 -ItemType File -Force -Value "function $Name1 {$((Get-Item function:\$name1).definition) }"  | Out-Null
######################################################################################################################################################################


function mount-ISO
{
 <#
        .SYNOPSIS
            Mounted das angegebene ISO, liefert den entsprechenden Laufwerksbuchstaben
        .Parameter Path
            Pfad zur ISO-Datei 
            Erforderlicher Parameter!
        
        
        .Notes
            Bindet das angegebene ISO ein und liefert den Laufwerksbuchstaben zurueck
        .link
            http://www.raucamp-solutions.de/AI2
     #>
    Param(
            [string]$Path =$(throw '- Der Parameter -Path wird benoetigt!')
    )

    Mount-DiskImage -ImagePath $Path
    (Get-DiskImage -ImagePath $path | Get-Volume).DriveLetter+ ":\"
    
}


######################################################################################################################################################################
$Name2="mount-ISO"
New-Item -Path $home\Documents\WindowsPowerShell\Modules\$name2\$name2.psm1 -ItemType File -Force -Value "function $Name2 {$((Get-Item function:\$name2).definition) }"  | Out-Null
######################################################################################################################################################################


Function Expand-Zip 
{
 <#
        .SYNOPSIS
           Entpackt angegebene Datei in den Zielordner
        .Parameter InputFile 
            Datei, die entpackt werden soll
            Erforderlicher Parameter!
        .Parameter DestinationFolder
            Verzeichnis, wohin entpackt werden soll
            Erforderlicher Parameter!
        
        
        .Notes
            Uebernommen von Brian Lalancette  autoSPSourcebuilder.ps1 http://autospsourcebuilder.codeplex.com
        .link
            http://autospsourcebuilder.codeplex.com
            http://www.raucamp-solutions.de/AI2
     #>
    Param(
            [string]$InputFile =$(throw '- Der Parameter -Inputfile wird benoetigt!'),
            [string]$DestinationFolder  =$(throw '- Der Parameter -DestinationFolder wird benoetigt!')
    )
    #
    $Shell = New-Object -ComObject Shell.Application
    $fileZip = $Shell.Namespace($InputFile)
    $Location = $Shell.Namespace($DestinationFolder)
    $Location.Copyhere($fileZip.items(),0x14)
}

######################################################################################################################################################################
$Name3="Expand-Zip"
New-Item -Path $home\Documents\WindowsPowerShell\Modules\$name3\$name3.psm1 -ItemType File -Force -Value "function $Name3 {$((Get-Item function:\$name3).definition) }"  | Out-Null
######################################################################################################################################################################



Function Remove-ReadOnlyAttribute 
{<#
        .SYNOPSIS
            Entfernt das Nur-Lesen (Read-Only)-Attribut des angegebenen Verzeichnisses
        .Parameter Path
            Pfad auf den das Entfernen angewendet werden soll 
            Erforderlicher Parameter!
        
        
        .Notes
            Entfernt das Nur-Lesen (Read-Only)-Attribut des angegebenen Verzeichnisses
            Uebernommen von Brian Lalancette  autoSPSourcebuilder.ps1 http://autospsourcebuilder.codeplex.com
        .link
            http://autospsourcebuilder.codeplex.com
            http://www.raucamp-solutions.de/AI2
     #>
    Param(
            [string]$Path =$(throw '- Der Parameter -Path wird benoetigt!')
    )
    
    ForEach ($item in (Get-ChildItem -Path $Path -Recurse -ErrorAction SilentlyContinue))
    {
        $attributes = @((Get-ItemProperty -Path $item.FullName).Attributes)
        If ($attributes -match "ReadOnly")
        {
            if ($attributes.Count -lt 2) { Set-ItemProperty -Path $item.FullName -Name Attributes -Value "Archive"}
            else
                {
                  #  Removing the 'ReadOnly' attribute
                  # Write-Host "  - Removing Read-Only attribute from file: $item"
                  Set-ItemProperty -Path $item.FullName -Name Attributes -Value ($attributes -replace "ReadOnly,","" )
                  # Set the file to just have the 'Archive' attribute
                  #Set-ItemProperty -Path $item.FullName -Name Attributes -Value "Archive"
                }
        }
    }
}

######################################################################################################################################################################
$Name4="Remove-ReadOnlyAttribute"
New-Item -Path $home\Documents\WindowsPowerShell\Modules\$name4\$name4.psm1 -ItemType File -Force -Value "function $Name4 {$((Get-Item function:\$name4).definition) }"  | Out-Null
######################################################################################################################################################################


Function check-DomainMember 
{<#
        .SYNOPSIS
            Ueberprueft, ob die VM bereits Mitglied in der Domain ist, wenn nicht, wird sie in die Domain aufgenommen
        .Parameter name
            Name der zu ueberpruefenden Domain
            Erforderlicher Parameter!
   
        
        .Notes
            Wird fuer AI2 benoetigt.
        .link
            http://www.raucamp-solutions.de/AI2
     #>
    Param(
            [string]$Name =$(throw '- Der Parameter -Name wird benoetigt!')    
    )
    $configfile=(get-ItemProperty -Path HKLM:\SOFTWARE\AI2).Configfile
    [xml]$config = Get-Content ((get-ItemProperty -Path HKLM:\SOFTWARE\AI2).Configfile)
    $ADMCred = New-Object System.Management.Automation.PSCredential ($config.CFG.Domain.Name + "\"+$config.cfg.Domain.Admin), (ConvertTo-SecureString $config.CFG.Domain.DomainAdminPW -AsPlainText -Force)
    $DomCred = New-Object System.Management.Automation.PSCredential ($config.CFG.Domain.Name + "\"+$config.cfg.Domain.Admin), (ConvertTo-SecureString $config.CFG.Domain.DomainAdminPW -AsPlainText -Force)
    
    if ($name -like "1*"){
                            $IP=$name 
                            $Name=($config.cfg.VMs.vm | Where-Object {$_.srvip -eq $ip}).name
                         }
    else{$IP=($config.cfg.VMs.vm | Where-Object {$_.name -eq $name}).srvip }
    Write-host "$Name mit der IP $IP wird ueberprueft, ob er bereits Mitglied in der Domain ist..."
    $DCIP=($config.CFG.VMs.vm | where {$_.Rollen -match "DC"}).srvip
    wait-forHost -computer $DCIP -Pause 2 # Warte auf DC, ob überhaupt erreichbar
    $Error.Clear()   
    do
    {
        $x= Check-Rolle -Rolle "DC" -IP $DCIP
    }
    until ($x -eq $true)


    do #Warte auf Anmeldung am DC möglich
           { [string]$status=(Get-WmiObject -Query "Select * from Win32_service where Name='LanmanWorkstation'" -ComputerName $DCIP -Credential $DomCred).state
             if (!($status -eq "running")){ 
                    sleep 1
                    Write-Host "." -NoNewline -ForegroundColor DarkYellow
                    $status = "n.v"
                  }
          }
    until ($status -eq "Running")
    
    do #Hole mir die aktuelle Liste der Domainmitglieder
        {   Write-Host "." -ForegroundColor Yellow
            $domainMember= Invoke-Command  -ComputerName $DCIP -Credential $DomCred  -Scriptblock { (get-adcomputer -filter *).name}
            sleep 3
        }
    until ($domainMember.count -gt 0)
    if($domainMember -contains $name)
         {Write-Host "Computer $name ist bereits Domain-Mitglied "}
    else {$ADMPW= ($config.cfg.VMs.vm | Where-Object {$_.name -eq $name}).AdminPW
                 If (([string]::IsNullOrEmpty($ADMPW))) {$ADMPW =$config.cfg.Domain.AdminPW}
                 $VMCred = New-Object System.Management.Automation.PSCredential "Administrator", (ConvertTo-SecureString $ADMPW -AsPlainText -Force)
                 $Error.Clear()
                 Write-Host "Verbinde mich mit $ip, um ihn in die Domain aufzunehmen " -ForegroundColor Yellow
                 do
                    {Write-Host "X" -ForegroundColor Cyan -nonewline}
                 until ((Check-WMSCon $IP) -eq $true)
                 $Error
                 <#do
                    { Write-Host "X" -ForegroundColor Yellow -nonewline
                      $Erg=(Check-WMSCon $DCIP)
                    }
                 until ($erg -eq $true)#>
                 $lang=Import-Csv ((Split-Path $configfile -Parent)+"\translations.csv")
                 Invoke-Command  -ComputerName $ip -Credential $VMCred  -ScriptBlock  {
                                  $adm= $using:DOMCred 
                                  $dc=$using:DCIP
                                  $LID=(((Get-WmiObject Win32_OperatingSystem))).OSLanguage
                                  $v = ($using:lang | where {$_.lid -eq $lid})
                                  If ([string]::IsNullOrEmpty($v.language)){$v=$lang[0]}
                                  do
                                    { sleep 1
                                         Write-Host "X" -NoNewline -ForegroundColor Yellow
                                         $Erg = (Get-WmiObject -Query "Select * from Win32_service where Name='LanmanServer'" -ComputerName $dC -Credential $adm).state
                                        }
                                  until ($erg -eq "Running") 
                                  Write-Host "Nehme Computer in die Domain auf!" -ForegroundColor Cyan -NoNewline
                                  Get-Date
                                  Add-Computer -DomainName $using:config.CFG.Domain.Name -Cred $adm -PassThru -force
                                  Write-Host "Domainbeitritt erfolgt, setze Firewall-Regeln" -ForegroundColor Green
                                  Set-NetFirewallRule -Name "FPS-ICMP4-ERQ-in" -enabled true -Profile Domain,private
                                  set-NetFirewallRule -Name  "RemoteDesktop-UserMode-In-TCP" -enabled True -Profile Domain,private # -DisplayName "Remotedesktop - Benutzermodus (TCP eingehend)" 
                                  set-NetFirewallRule -Name "RemoteDesktop-UserMode-In-UDP" -enabled True -Profile Domain,private  #-DisplayName "Remotedesktop - Benutzermodus (UDP eingehend)"     
                                  #set-NetFirewallRule -DisplayGroup  $v.Remotedesktop  -Profile Domain,private -Enabled True
                                  set-NetFirewallRule -DisplayGroup  $v.Remote_Service_Management  -Profile Domain,private -Enabled True
                                  Set-NetFirewallRule -Name "NETDIS-NB_Name-In-UDP" -Profile Domain,private -Enabled True
                                  Set-NetFirewallRule -Name "WMI-WINMGMT-In-TCP"  -Profile Domain,private -Enabled True
                                  Restart-Computer -Force 
                                  Write-Host "Firewallregeln aktualisiert, Restart erfolgt." -ForegroundColor Green -NoNewline
                                  get-date
                                 }
                 #Restart-Computer -ComputerName $IP -Wait -For PowerShell -Force -Credential  $ADMCred
                 Write-Host "Restart des Computers erfolgt!  " -NoNewline 
                 Get-Date
                 wait-forHost -computer $IP -Pause 10
                 sleep 10
                 #wait-forPC -computer $IP -Cred $ADMCred
                 do
                    { sleep 1
                      Write-Host "*" -ForegroundColor Blue -NoNewline
                    }
                 until (Check-WMSCon -ComputerName $IP)
                 $Error.Clear()   
                 <# Die Abfrage läuft manchmal auf den Fehler-->  Der RPC-Server ist nicht verfügbar. (Ausnahme von HRESULT: 0x800706BA)
                    Weder das Abschalten der Firewall auf beiden Systemen noch  set-service RemoteRegistry -Status Running haben dann geholfen. 
                    do
                        { [string]$status=(Get-WmiObject -Query "Select * from Win32_service where Name='LanmanWorkstation'" -ComputerName $IP -Credential $ADMCred).state
                          if (!($status -eq "running")){ 
                                sleep 1
                                Write-Host "-" -NoNewline -ForegroundColor DarkYellow
                                $status = "n.v"
                                }
                        }
                 until ($status -eq "Running")
                 #>
                 Write-Host "Konfiguriere WSMAN..." -ForegroundColor Yellow -NoNewline
                 Invoke-Command  -ComputerName $IP -Credential $ADMCred  -Scriptblock {
                                    if((Get-Item -Path HKLM:\SOFTWARE).GetSubKeyNames() -notcontains"AI2"){new-Item -Path HKLM:\SOFTWARE -name AI2}
                                    Enable-WSManCredSSP -Role Server -Force
                                    Write-Host "Enabled " -ForegroundColor Yellow
                                    Get-WSManCredSSP
                                   }
                 Write-Host "Vorgang abgeschlossen."
         }
           
}
######################################################################################################################################################################
$Name5="check-DomainMember"
New-Item -Path $home\Documents\WindowsPowerShell\Modules\$name5\$name5.psm1 -ItemType File -Force -Value "function $Name5 {$((Get-Item function:\$name5).definition) }"  | Out-Null
######################################################################################################################################################################

function Install-Patch
{
    <#
    .SYNOPSIS
        Patches a WIM or VHD file
    .DESCRIPTION
        Applies downloaded patches to a VHD or WIM file
    .NOTES
        File Name: Install-Patch.psm1
        Author: John Savill
        Requires: Tests on PowerShell 3 on Windows Server 2012
        Copyright (c) 2013 John Savill
    .LINK

        http://www.savilltech.com/
    .PARAMETER updateTargetPassed
        File (WIM, VHD or VHDX) to be patched
    .PARAMETER patchpath
        Path containing the updates
    .EXAMPLE
        Install-Patch d:\files\test.vhd d:\updates\win2012\
        Install-Patch d:\files\install.wim:4 d:\updates\win2012\
    #>
   
    [cmdletbinding()]
    Param(
    [Parameter(ValuefromPipeline=$false,Mandatory=$true)][string]$updateTargetPassed,
    [Parameter(ValuefromPipeline=$false,Mandatory=$true)][string]$patchpath)

    #$updateTargetPassed = "G:\Temp\Win2012DatacenterRTM.vhdx"
    #or
    #$updateTargetPassed = "d:\sources\install.wim:4"
    #$patchpath = "D:\software\Windows 2012 Updates\"

    if(($updateTargetPassed.ToLower().Contains(".vhd")) -eq $true) # if its VHD or VHDX. Contains is case sensitive so have to convert to lower when comparing
    {
        $isVHD = $true
    }
    else
    {
        $isVHD = $false
    }

    if($isVHD)
    {
        $updateTarget=$updateTargetPassed
        if ((Test-Path $updateTarget) -eq $false) #if not found
        {
            write-output "Source not found ($updateTarget)"
            break
        }
        else
        {
            mount-vhd -path $updateTarget
            $disks = Get-CimInstance -ClassName Win32_DiskDrive | where Caption -eq "Microsoft Virtual Disk"          
            foreach ($disk in $disks)
            {          
                $vols = Get-CimAssociatedInstance -CimInstance $disk -ResultClassName Win32_DiskPartition            
                foreach ($vol in $vols)
                {          
                    $updatedrive = Get-CimAssociatedInstance -CimInstance $vol -ResultClassName Win32_LogicalDisk |          
                    where VolumeName -ne 'System Reserved'        
                }          
            }
            $updatepath = $updatedrive.DeviceID + "\"
        }
    }
    if(!$isVHD)  #its a WIM file
    {
        #Need to extract the WIM part and the index
        #extract file name and the index number
        $updateTargetPassedSplit = $updateTargetPassed.Split(":")
        if($updateTargetPassedSplit.Count -eq 3) #one for drive letter, one for folder and one for image number so would have been two colons in it c:\temp\install.wim:4
        {
            $updateTarget = $updateTargetPassedSplit[0] + ":" + $updateTargetPassedSplit[1]   #There are two colons. The first is drive letter then the folder!
            $updateTargetIndex = $updateTargetPassedSplit[2]
            $updatepath = "c:\wimmount\"

            #check if exists and if not create it
            if ((Test-Path $updatepath) -eq $false) #if not found
            {
                Write-Host "Creating folder " + $updatepath
                New-Item -Path $updatepath -ItemType directory
                #could have also used [system.io.directory]::CreateDirectory($updatepath)
            }

            # Mount it as folder
            #dism /get-wiminfo /wimfile:install.wim
            dism /Mount-Wim /wimfile:$updateTarget /index:$updateTargetIndex /mountdir:$updatepath
        }
        else
        {
            write-output "Missing index number for WIM file. Example: c:\temp\install.wim:4"
            break
        }
    }

    # For WIM or VHD
    $updates = get-childitem -path $patchpath -Recurse | where {($_.extension -eq ".msu") -or ($_.extension -eq ".cab")} | select fullname
    foreach($update in $updates)
    {
        write-debug $update.fullname
        $command = "dism /image:" + $updatepath + " /add-package /packagepath:'" + $update.fullname + "'"
        write-debug $command
        Invoke-Expression $command
    }

    $command = "dism /image:" + $updatepath + " /Cleanup-Image /spsuperseded"
    Invoke-Expression $command

    if($isVHD)
    {
        dismount-vhd -path $updateTarget -confirm:$false
    }
    else
    {
        dism /Unmount-Wim /mountdir:$updatepath /commit
        #dism /Unmount-Wim /mountdir:$updatepath /discard
    }
}

######################################################################################################################################################################
$Name6="Install-Patch"
New-Item -Path $home\Documents\WindowsPowerShell\Modules\$name6\$name6.psm1 -ItemType File -Force -Value "function $Name6 {$((Get-Item function:\$name6).definition) }"  | Out-Null
######################################################################################################################################################################




######################################################################################################################################################################

Function add-DNSEintrag 
{   <#
        .SYNOPSIS
            Erstellt sowohl den DNS-Eintrag, als auch gleichzeitig den PTR-Eintrag
        .Parameter Name
            Name des Computers, der im DNS eigetragen werden soll
            Erforderlicher Parameter!
 
        .Parameter IP
            IP des Computers, der im DNS eigetragen werden soll
            Erforderlicher Parameter!
   
        
        .Notes
            Wird fuer AI2 benoetigt.
        .link
            http://www.raucamp-solutions.de/AI2
     #>
    Param(
            [string]$Name =$(throw '- Der Parameter -Name des Eintrags wird benoetigt!') ,
            $IP =$(throw '- Der Parameter -IP des Eintrags wird benoetigt!')
            
            
         )
    [xml]$config = Get-Content ((get-ItemProperty -Path HKLM:\SOFTWARE\AI2).Configfile)
     $DCIP=($config.CFG.VMs.vm | where {$_.Rollen -match "DC"}).srvip
     $DomainAdmin = New-Object System.Management.Automation.PSCredential ($config.CFG.Domain.Name + "\"+$config.cfg.Domain.Admin), (ConvertTo-SecureString $config.CFG.Domain.DomainAdminPW -AsPlainText -Force)
     $zoneName= $IP.split('.')[2]+[char]46+$IP.split('.')[1]+[char]46+$IP.split('.')[0]+ ".in-addr.arpa"
     $DomainName=$config.cfg.Domain.Name
     $fqn=$name + [char]46 +  $DomainName
      wait-forPC -computer $DCIP -Cred $DomainAdmin
      <#  
    # sleep 10
     Write-Host "Warte auf DNS."
#Get-Date

do
{ sleep 1
  Write-Host "." -NoNewline -ForegroundColor Yellow
}
 
until (((Get-WmiObject -Query "Select * from Win32_service " -ComputerName $DCIP  -Credential $DomainAdmin) |where {$_.Name -eq "DNS" }).state -eq "Running")
Write-Host "DNS steht zur Verfügung" -ForegroundColor Cyan -NoNewline
Get-Date
#>
    Invoke-Command  -ComputerName $DCIP -Credential $DomainAdmin  -Scriptblock {
          <#  Start-Service "DNS"
             do{write-host "." -NoNewLine -ForegroundColor Cyan
                sleep 10}
             until ((Get-Service |where {$_.Name -eq "DNS"}).Status -eq "Running") #>
             $IP=$using:IP
             $iName=$using:Name
             $iZonename=$using:Zonename
             $iDomainName= $using:DomainName 
             $fqn=$using:fqn
             Write-Host "Fuege DNS-Record hinzu..."
             Add-DnsServerResourceRecord -ZoneName $iDomainName -A -Name $iName -AllowUpdateAny -AgeRecord  -IPv4Address $IP -TimeToLive 01.00:00:00 
             Write-Host "Fuege PTR-Record hinzu..."
             Add-DnsServerResourceRecord -Name $IP.split('.')[3] -Ptr -ZoneName $izoneName -AllowUpdateAny -PtrDomainName $fqn  
             Write-Host "$iName wurde zum DNS hinzugefügt!"
             
            }
           
}
######################################################################################################################################################################
$Name8="add-DNSEintrag"
New-Item -Path $home\Documents\WindowsPowerShell\Modules\$name8\$name8.psm1 -ItemType File -Force -Value "function $Name8 {$((Get-Item function:\$name8).definition) }"  | Out-Null
######################################################################################################################################################################


######################################################################################################################################################################
function Get-Checksum
{<#
        .SYNOPSIS
            Berechnet wahlweise MD5 oder SHA1 Wert. Wird ab PowerShell Version 4 nicht mehr benötigt, da es die Funktion Get-FileHash gibt.
        .Parameter FiletoCheck
            Name der Datei, die überprüft werden soll.
            Erforderlicher Parameter!
 
        .Parameter Algorithm
            Algorithmus, nachdem berechnet werden soll. Standard ist SHA1
            Optionaler Parameter!
   
        
        .Notes
            Wird fuer AI2 benoetigt.
            Funktion Get-Checksum gefunden auf http://www.tinyint.com/index.php/2011/09/14/get-an-md5-or-sha1-checksum-with-powershell/#more-288
        .link
            http://www.raucamp-solutions.de/AI2
            http://www.tinyint.com/index.php/2011/09/14/get-an-md5-or-sha1-checksum-with-powershell/#more-288
     #>
    Param (
        [string]$FiletoCheck=$(throw("You must specify a filename to get the checksum of.")),
        [ValidateSet("sha1","md5")]
        [string]$Algorithm="sha1"
    )
    $fs = new-object System.IO.FileStream $FiletoCheck, "Open"
    $algo = [type]"System.Security.Cryptography.$Algorithm"
	$crypto = $algo::Create()
    $hash = [BitConverter]::ToString($crypto.ComputeHash($fs)).Replace("-", "")
    $fs.Close()
    $hash
}
######################################################################################################################################################################
$Name9="get-Checksum"
New-Item -Path $home\Documents\WindowsPowerShell\Modules\$name9\$name9.psm1 -ItemType File -Force -Value "function $Name9 {$((Get-Item function:\$name9).definition) }"  | Out-Null
######################################################################################################################################################################

Function Check-Rolle
{<#
        .SYNOPSIS
            Überprüft, ob die erwartete Rolle schon installiert ist.

        .Parameter Rolle
            Rolle, die überprüft werden soll
            Erforderlicher Parameter!
 
        .Parameter IP
            IP des Computers, der geprüft eigetragen werden soll
            Erforderlicher Parameter!
   
        
        .Notes
            Wird fuer AI2 benoetigt.
        .link
            http://www.raucamp-solutions.de/AI2
     #>
    Param(
            [string]$Rolle =$(throw '- Der Parameter -Rolle des Eintrags wird benoetigt!') ,
            $IP =$(throw '- Der Parameter -IP des Eintrags wird benoetigt!')
            
            
         )
     [xml]$config = Get-Content ((get-ItemProperty -Path HKLM:\SOFTWARE\AI2).Configfile)
     $vm=$config.CFG.VMs.vm | where {$_.srvip -match $IP}
     [string]$VMAdminPW=$vm.AdminPW
     if(([string]::IsNullOrEmpty($VMAdminPW)) -or ($VMAdminPW -eq " ") ) {$VMAdminPW=$config.cfg.VMs.Default.AdminPW}
     $VMAdmin = New-Object System.Management.Automation.PSCredential "Administrator", (ConvertTo-SecureString $VMAdminPW -AsPlainText -Force)
     $DomainAdmin = New-Object System.Management.Automation.PSCredential ($config.cfg.Domain.Name + "\"+$config.cfg.Domain.Admin), (ConvertTo-SecureString $config.cfg.Domain.DomainAdminPW -AsPlainText -Force)

     $ErrorActionPreference="silentlyContinue"
     wait-forHost -computer $IP 
     do
     {
         sleep 1
     }
     until  (Check-WMSCon -ComputerName $IP)

     wait-forPC -computer $IP -Cred $DomainAdmin
    

     <#if ($Rolle -eq "DC"){
                    #$ErrorActionPreference="silentlyContinue"
                    Write-Host "Warte auf den DNS-Dienst auf Server $IP" -ForegroundColor Yellow
                    $Error.Clear()   
                    do
                        { [string]$status=(Get-WmiObject -Query "Select * from Win32_service where Name='DNS'" -ComputerName $IP -Credential $VMAdmin).state
                          if (!($status -eq "running")){ 
                                sleep 1
                                Write-Host "-" -NoNewline -ForegroundColor DarkYellow
                                $status = "n.v"
                                }
                        }
                    until ($status -eq "Running")
                    $status = "n.v"
                    do
                        { $status=(Get-WmiObject -Query "Select * from Win32_service where Name='Netlogon'" -ComputerName $IP -Credential $VMAdmin).state
                          if (!($status -eq "running")){ 
                                sleep 1
                                Write-Host "-" -NoNewline -ForegroundColor Yellow
                                $status = "n.v"
                                }
                        }
                    until ($status -eq "Running")
                    # $ErrorActionPreference="Continue" 
     #LanmanServer

     }#>

     
     if ((Check-WMSCon $ip) -eq $false) {
                do
                    {sleep 1
                     wait-forHost -computer $IP 
                     Write-Host "." -NoNewline -ForegroundColor Yellow
                     $erg= (Check-WMSCon $ip)
                    }
                until ( $erg -eq $true)
               }
    $Error.Clear() 
    $res= Invoke-Command  -ComputerName $IP -Credential $DomainAdmin -ErrorAction SilentlyContinue -Scriptblock {
                          if((Get-Item -Path HKLM:\SOFTWARE).GetSubKeyNames() -notcontains"AI2")
                                {# Anlage eines neuen Schluessels fuer die Skripte
                                 new-Item -Path HKLM:\SOFTWARE -name AI2 
                                }
                          (Get-ItemProperty -path HKLM:\SOFTWARE\AI2).$using:Rolle
                         }
    if ($res-ne $true){ sleep 5
                        if (!((!([string]::IsNullOrEmpty($res))) -or ($res -ne " ") )) {Write-Host "Result: $res" -ForegroundColor Cyan}
                        $res=$false
                      }
    if ($error.count -gt 0 ){Write-Host "Fehler in Check-rolle" -ForegroundColor Cyan
                             $Error
                             $res =$false
                            }
    $ErrorActionPreference="Continue" 
    return $res
}
######################################################################################################################################################################
$Name10="Check-Rolle"
New-Item -Path $home\Documents\WindowsPowerShell\Modules\$name10\$name10.psm1 -ItemType File -Force -Value "function $Name10 {$((Get-Item function:\$name10).definition) }"  | Out-Null
######################################################################################################################################################################



Function Check-WMSCon
{
  param
  (
    $ComputerName = $env:COMPUTERNAME,
    [Int32[]]
    [Parameter(ValueFromPipeline=$true)]
    $Port = $(5985),
    [Int32]
    $Timeout=1000,
    [Switch]
    $AllResults
  )
  # Inspiriert durch Tobias Weltner in "Scripting mit Windows PowerShell 3.0 - Der Workshop" Microsoft Press
  Process
  { 
    do
    {
        

    $ErrorActionPreference="silentlyContinue"
    $count = 0
    $ok=$False
    ForEach ($PortNumber in $Port)
    { 
      $count ++
      $result = New-Object PSObject -Property ([Ordered]@{Port="$PortNumber";Open=$False;Type='TCP';ComputerName=$ComputerName})
      $TCPClient = New-Object System.Net.Sockets.TcpClient 
      $Connection = $TCPClient.BeginConnect($ComputerName, $PortNumber, $null, $null)
      try
      {
        if ($Connection.AsyncWaitHandle.WaitOne($Timeout, $false))
        {
          $null = $TCPClient.EndConnect($Connection)
          $result.Open = $true
        }
      } 
      catch {} finally { $TCPClient.Close() }
      $ErrorActionPreference="Continue"
      $result.open 
      if (($result.open ) -eq $true ){$OK=$true}
         }
    

    }
    until ($OK=$true)
  }
}

######################################################################################################################################################################
$Name11="Check-WMSCon"
New-Item -Path $home\Documents\WindowsPowerShell\Modules\$name11\$name11.psm1 -ItemType File -Force -Value "function $Name11 {$((Get-Item function:\$name11).definition) }"  | Out-Null
######################################################################################################################################################################


######################################################################################################################################################################

Function add-ADGruppe 
{   <#
        .SYNOPSIS
            Überprüft und erstellt eine Gruppe im AD
        .Parameter GruppenName
            Name des AD-Gruppe, die erstellt werden soll
            Erforderlicher Parameter!
 
        .Parameter Displayname
            Anzeigetext im AD für die Gruppe
            Optionaler Parameter!

        .Parameter Gruppenmitglieder
            Liste der Gruppenmitglieder, die hinzugefügt werden sollen (SAM)
            Optionaler Parameter!
   
        
        
        .Notes
            Wird fuer AI2 benoetigt.
        .link
            http://www.raucamp-solutions.de/AI2
     #>
    Param(
            [string]$GruppenName =$(throw '- Der Parameter -Name des Eintrags wird benoetigt!') ,
            $Displayname,
            $Gruppenmitglieder )
            
            
         
    [xml]$config = Get-Content ((get-ItemProperty -Path HKLM:\SOFTWARE\AI2).Configfile)
    $DCIP=($config.CFG.VMs.vm | where {$_.Rollen -match "DC"}).srvip
    $DomainAdmin = New-Object System.Management.Automation.PSCredential ($config.CFG.Domain.Name + "\"+$config.cfg.Domain.Admin), (ConvertTo-SecureString $config.CFG.Domain.DomainAdminPW -AsPlainText -Force)
    wait-forPC -computer $DCIP -Cred $DomainAdmin
    #wait-forHost -computer $DCIP | Out-Null
    #Check-WMSCon -ComputerName $DCIP | Out-Null
 

    do
        { sleep 1
          Write-Host "." -NoNewline -ForegroundColor Yellow
        }
 
    until (((Get-WmiObject -Query "Select * from Win32_service " -ComputerName $DCIP  -Credential $DomainAdmin) |where {$_.Name -eq "DNS" }).state -eq "Running")
    Invoke-Command  -ComputerName $DCIP -Credential $DomainAdmin  -Scriptblock {
                $baseOU=$using:config.cfg.Domain.BaseOU
                $GruppenName=$using:GruppenName
                $Displayname=$using:Displayname
                $Gruppenmitglieder=$using:Gruppenmitglieder
                if ([string]::IsNullOrEmpty($Displayname)){$Displayname="Gruppe $GruppenName"}
                if (!(get-ADGroup -Filter "Name -like '$GruppenName'") -eq $GruppenName) {
                        $DC=get-content env:computername
                        $domain=$using:config.CFG.Domain.Name
                        $baseOU=$using:config.cfg.Domain.BaseOU
                        $DCX=$using:config.cfg.Domain.name
                        $dc1,$dc2,$dc3,$dc4 =$DCX.split('.')
                        $Pfad ="Dc=$dc1,DC=$dc2"
                        if($DC3 -ne $null)
                            {$Pfad=$Pfad+",DC=$dc3"
                             if($DC4 -ne $null)
                                {$Pfad=$Pfad+",DC=$dc4"}
                            }
                        $ErrorActionPreference="Continue"
                        new-adgroup -displayname $Displayname -name $GruppenName -path "OU=Gruppen,OU=$baseOU,$Pfad" -groupscope 1
                        if (!(get-ADGroup -Filter "Name -like '$GruppenName'") -eq $GruppenName) {Write-Host "Die Gruppe $GruppenName konnte nicht angelegt werden. Fehler" -ForegroundColor Red}
                        else {Write-Host "$Displayname wurde angelegt!" -ForegroundColor Green}
                      }
                if (!([string]::IsNullOrEmpty($Gruppenmitglieder))){
                    $member=(Get-ADGroupMember -Identity $GruppenName).name
                    write-host "" -ForegroundColor Red
                    Foreach($Mitglied in ($Gruppenmitglieder).Split(",").trim()){
                        if (!([string]::IsNullOrEmpty($Mitglied))){
                                if(((Get-ADUser -Filter "*").name) -contains $Mitglied){
                                     if ($member -notcontains $Mitglied) {
                                          Write-Host "Fuege $Mitglied hinzu"
                                          add-ADGroupMember $GruppenName $Mitglied
                                        }
                                     else {Write-Host "$Mitglied ist bereits Mitglied der Gruppe $GruppenName" }
                                    }
                                else { if(((Get-ADGroup -Filter "*").name) -contains $Mitglied) {
                                            write-host "$member ist kein User, versuche Gruppe"
                                             if ($member -notcontains $Mitglied) {
                                                    Write-Host "Fuege Gruppe $Mitglied hinzu"
                                                    add-ADGroupMember $GruppenName $Mitglied
                                                  }
                                            else {Write-Host "$Mitglied ist bereits Mitglied der Gruppe $GruppenName" }
                                             
                                             }
                                       else {Write-Host "$Mitglied existiert nicht im AD, daher konnte er der Gruppe $GruppenName nicht hinzugefügt werden! " -ForegroundColor Yellow}
                                    }

                               }
                            }
                } 
            }
           
}
######################################################################################################################################################################
$Name12="add-ADGruppe"
New-Item -Path $home\Documents\WindowsPowerShell\Modules\$Name12\$Name12.psm1 -ItemType File -Force -Value "function $Name12 {$((Get-Item function:\$Name12).definition) }"  | Out-Null
######################################################################################################################################################################





Function Set-IPv6Config
{   <#
        .SYNOPSIS
            Setzt die IPv6-Parameter, wenn nicht die Konfiguration über DHCPv6  erfolgen soll

        .Parameter IP
            IPv4-Adresse des Computers
            Erforderlicher Parameter!
 
        .Parameter Cred
            Credentials Berechtigter Admin
            Erforderlicher Parameter!
        
        .Parameter IPv6Adresse
            IPv6-Adresse des Computers die festgelegt werden soll
            Erforderlicher Parameter!
        
        .Parameter PrefixLength
            PrefixLength des Netzsegments
            Erforderlicher Parameter!
            
        .Parameter Gateway
            Gateway im IPv6 Segment
            Erforderlicher Parameter!

        .Parameter DNS6Server
            Zu nutzender DNSServer für ipV6
            Erforderlicher Parameter!

        .Parameter IPv6Prefix
            IPv6Prefix des Netzsegments
            Erforderlicher Parameter!

        .Parameter IPv4Bevorzugen
            Prioritaet der IPv6-Behandlung
            Erforderlicher Parameter!
   
        
        
        .Notes
            Wird fuer AI2 benoetigt.
        .link
            http://www.raucamp-solutions.de/AI2
     #>
    Param(
            $IP =$(throw '- Der Parameter -IP wird benoetigt!') ,
            $Cred  =$(throw '- Der Parameter -Cred wird benoetigt!') ,
            [string]$IPv6Adresse =$(throw '- Der Parameter -IPv6Adresse wird benoetigt!'),
            [string]$PrefixLength =$(throw '- Der Parameter -PrefixLength wird benoetigt!'),
            [string]$Gateway =$(throw '- Der Parameter -Gateway wird benoetigt!'),
            [string]$DNS6Server =$(throw '- Der Parameter -DNS6Server wird benoetigt!'),
            [string]$IPv6Prefix =$(throw '- Der Parameter -IPv6Prefix wird benoetigt!'),

            [bool]$IPv4Bevorzugen =$(throw '- Der Parameter -IPv4Bevorzugen des Eintrags wird benoetigt!') 
       )
            
    Check-WMSCon -ComputerName $IP | Out-Null
    Invoke-Command  -ComputerName $IP -Credential $Cred  -ScriptBlock {
        $IPv6Adresse=$Using:IPv6Adresse
        $PrefixLength=$using:PrefixLength
        $Gateway=$using:Gateway
        $DNS6Server=$using:DNS6Server
        $IPv6Prefix=$using:IPv6Prefix
        $IPv4Bevorzugen=$using:IPv4Bevorzugen
        New-NetIPAddress -InterfaceAlias "Ethernet" -IPAddress $IPv6Adresse -PrefixLength $PrefixLength -DefaultGateway $Gateway
        Set-DnsClientServerAddress -InterfaceAlias "Ethernet" -ServerAddresses $DNS6Server
        $DestinationPrefix=$IPv6Prefix+"/"+$PrefixLength
        New-NetRoute -DestinationPrefix $DestinationPrefix -InterfaceAlias "Ethernet" -NextHop $Gateway -AddressFamily IPv6
        Write-Host "IP-Adresse: $IPv6Adresse / Prefix: $PrefixLength / Gateway : $gateway / DNS-Server: $DNS6Server / Dest.Pref $DestinationPrefix" -ForegroundColor DarkCyan
        Set-NetFirewallRule -Name "FPS-ICMP6-ERQ-In"  -Enabled True -Direction Inbound -Action Allow  #-DisplayName “Datei- und Druckerfreigabe (Echoanforderung - ICMPv6 eingehend)"
        if ($IPv4Bevorzugen -eq $true) {
                          New-ItemProperty -Path HKLM:\SYSTEM\CurrentControlSet\Services\Tcpip6\Parameters\  -name  DisabledComponents -Value 0x20 -PropertyType dword
                          Write-Host "IPv4 wird bevorzugt!" -ForegroundColor DarkCyan
                        } # Anstelle der ipv6-Adresse wird wieder die IPv4-Adresse bei ping angezeigt
    }
           
}
######################################################################################################################################################################
$name13="Set-IPv6Config"
New-Item -Path $home\Documents\WindowsPowerShell\Modules\$name13\$name13.psm1 -ItemType File -Force -Value "function $name13 {$((Get-Item function:\$name13).definition) }"  | Out-Null
######################################################################################################################################################################




Function Set-IPv6TransitionTechnologies 
{   <#
        .SYNOPSIS
            Setzt die IPv6-Transition Protokolle

        .Parameter Net6to4Configuration
            Enabled oder Disabled
            Optionaler Parameter!
 
        .Parameter NetTeredoConfiguration
            Enabled oder Disabled
            Optionaler Parameter!

        .Parameter NetIsatapConfiguration
            Enabled oder Disabled
            Optionaler Parameter!
   
        
        
        .Notes
            Wird fuer AI2 benoetigt.
        .link
            http://www.raucamp-solutions.de/AI2
     #>
    Param(
            $IP =$(throw '- Der Parameter -IP wird benoetigt!') ,
            $Cred  =$(throw '- Der Parameter -Cred wird benoetigt!') ,
            $Net6to4Configuration ,
            $NetTeredoConfiguration ,
            $NetIsatapConfiguration

       )
            
            
    write-host "!"     
    
    Check-WMSCon -ComputerName $IP | Out-Null
    Invoke-Command  -ComputerName $IP -Credential $Cred  -ScriptBlock {
                         $Net6to4Configuration=$using:Net6to4Configuration
                         $NetTeredoConfiguration=$using:NetTeredoConfiguration
                         $NetIsatapConfiguration=$using:NetIsatapConfiguration

                         If (!([string]::IsNullOrEmpty($Net6to4Configuration))) {Set-Net6to4Configuration -State $Net6to4Configuration}
                         If (!([string]::IsNullOrEmpty($Net6to4Configuration))) {Set-NetTeredoConfiguration -Type $NetTeredoConfiguration}
                         If (!([string]::IsNullOrEmpty($NetIsatapConfiguration))) {Set-NetIsatapConfiguration -State $NetIsatapConfiguration }
    }
           
}
######################################################################################################################################################################
$name14="set-IPv6TransitionTechnologies"
New-Item -Path $home\Documents\WindowsPowerShell\Modules\$name14\$name14.psm1 -ItemType File -Force -Value "function $name14 {$((Get-Item function:\$name14).definition) }"  | Out-Null
######################################################################################################################################################################


function wait-forPC
    {
     <#
        .SYNOPSIS
            wartet darauf, dass der Host anpingbar wird
        .Parameter IP
            IP des Computers, auf den gewartet werden soll 
            Erforderlicher Parameter!
        .Parameter Cred
            Credentials für den Computer
             Erforderlicher Parameter!
        .Example
            Wait-forPC -Computer DC1 -Cred $Credentials
            Ueberprueft solange per Ping bis Computer DC1 ansprechbar ist.
        .Notes
            Hilft, wenn der entfernte Computer zwischendurch neu gestartet wird
            Voraussetzung ist, dass auf dem Computer die Firewall-Regel WMI-WINMGMT-In-TCP aktiviert ist
            
        .link
            http://www.raucamp-solutions.de/AI2
     #>
     Param(
            [string]$computer =$(throw '- Der Parameter -Computer wird benoetigt!'),
            $Cred 
            )
     $ErrorActionPreference="SilentlyContinue"
     $Error.Clear()   
     do
           { [string]$status=(Get-WmiObject -Query "Select * from Win32_service where Name='LanmanWorkstation'" -ComputerName $computer -Credential $Cred).state
             if (!($status -eq "running")){ 
             sleep 5
             Write-Host "o" -NoNewline -ForegroundColor Cyan
             $status = "n.v"
           }
           }
     until ($status -eq "Running")

    }

######################################################################################################################################################################
$Name15="wait-forPC"
New-Item -Path $home\Documents\WindowsPowerShell\Modules\$Name15\$Name15.psm1 -ItemType File -Force -Value "function $Name15 {$((Get-Item function:\$Name15).definition) }"  | Out-Null
######################################################################################################################################################################


Function check-ADMember
{   <#
        .SYNOPSIS
            Überprüft und erstellt eine Gruppe im AD
        .Parameter Member
            Name des zu überprüfenden AD-Benutzers bzw. AD-Gruppe
            Erforderlicher Parameter!
 
  
        
        
        .Notes
            Wird fuer AI2 benoetigt.
        .link
            http://www.raucamp-solutions.de/AI2
     #>
    Param(
            [string]$Member =$(throw '- Der Parameter -Name des Eintrags wird benoetigt!')  )
            
            
         
    [xml]$config = Get-Content ((get-ItemProperty -Path HKLM:\SOFTWARE\AI2).Configfile)
    $DCIP=($config.CFG.VMs.vm | where {$_.Rollen -match "DC"}).srvip
    $DomainAdmin = New-Object System.Management.Automation.PSCredential ($config.CFG.Domain.Name + "\"+$config.cfg.Domain.Admin), (ConvertTo-SecureString $config.CFG.Domain.DomainAdminPW -AsPlainText -Force)
    wait-forPC -computer $DCIP -Cred $DomainAdmin
    #wait-forHost -computer $DCIP | Out-Null
    #Check-WMSCon -ComputerName $DCIP | Out-Null
 

    do
        { sleep 1
        }
 
    until (((Get-WmiObject -Query "Select * from Win32_service " -ComputerName $DCIP  -Credential $DomainAdmin) |where {$_.Name -eq "DNS" }).state -eq "Running")
    $erg= Invoke-Command  -ComputerName $DCIP -Credential $DomainAdmin  -Scriptblock {
                $Member=$using:Member
                $success=$false
                if(((Get-ADUser -Filter "*").name) -contains $Member){$success="User" }
                if(((Get-ADGroup -Filter "*").name) -contains $Member){$success="Gruppe"}    
                $success
              }
                            
    $erg       
}
######################################################################################################################################################################
$Name16="check-ADMember"
New-Item -Path $home\Documents\WindowsPowerShell\Modules\$Name16\$Name16.psm1 -ItemType File -Force -Value "function $Name16 {$((Get-Item function:\$Name16).definition) }"  | Out-Null
######################################################################################################################################################################




######################################################################################################################################################################

write-host "******************************************************"
"Ausführungszeit: {0:hh}:{0:mm}:{0:ss}" -f ((get-date)-$Start)
write-host "******************************************************"

Get-Date



######################################################################################################################################################################
######################################################################################################################################################################


