﻿#Requires –Version 3

Param 
      (
      [string]$configfile
       )


$Start=Get-Date
write-host "     ************************************************************     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     *     AI2 Configure HOST-vSwitche  by Thorsten Raucamp     *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     *                  Version 0.94 2014-05-15                 *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     ************************************************************     " -ForegroundColor DarkGreen
Write-Host ""
Write-Host ""
write-host "     Konfiguriere  HOST-vSwitche am: " -NoNewline
Get-Date
$Host.UI.RawUI.WindowTitle = "Configure HOST-vSwitche"

if (!(Test-Admin)) {
                    $powershell = [System.Diagnostics.Process]::GetCurrentProcess()
                    $psi = New-Object System.Diagnostics.ProcessStartInfo $powerShell.Path
                    $script = $MyInvocation.MyCommand.Path
                    $prm = $script
                    foreach($a in $args) {$prm += ' ' + $a}
                    $psi.Arguments = $prm
                    $psi.Verb = "runas"
                    #$psi
                    [System.Diagnostics.Process]::Start($psi) | Out-Null
                    return;
                    # Neustart des Skriptes mit Adminrechten, sollte das aktuelle Skript nicht mit Administratorrechten 
                    # gestartet worden sein. Übernommen von der c't www.ct.de/1017144
                   }
if([string]::IsNullOrEmpty($configfile)) {$configfile=(Get-ItemProperty -path HKLM:\SOFTWARE\ai2).Configfile}
if (!(Test-Path $configfile)) {Write-Host "Bitte starten Sie das Skript erneut mit dem Parameter -configfile und der entsprechenden Pfadangabe"}
set-ItemProperty -Path HKLM:\SOFTWARE\ai2 -name Configfile -Value $configfile
[xml]$config = Get-Content $configfile
# Ende Header
$log=$config.cfg.LOG
if (!(Test-Path $log)){md $log}
$logfile=$log+"\configure-VSwitches.txt"
$ErrorActionPreference="SilentlyContinue"
Stop-Transcript | Out-Null
$ErrorActionPreference="Continue"

Start-Transcript -Path $logfile -Append


$aktuelleSwitches=(Get-VMSwitch ).name

ForEach ($Switch in $config.Cfg.HOST.vSwitches.vSwitch)
    {

    $Switchname=$Switch.Name
    $switchHOSTIP=$switch.HOSTIP
    if ($aktuelleSwitches -match $SwitchName){Write-Host "Switch $Switchname ist schon vorhanden, es werden keine Änderungen vorgenommen!!!"-ForegroundColor Cyan}
    else {
            If (([string]::IsNullOrEmpty($Switch.Type)) -or ($Switch.type -eq "External"))
     
                {
                 [bool]$allow = ([System.Convert]::ToBoolean($Switch.AllowManagementOS)) 
                 New-VMSwitch -name $Switch.name -notes $Switch.note -NetAdapterName $Switch.netadaptername -AllowManagementOS $allow
                 # $adapter= Get-NetAdapter | where {$_.name -match "2"}
                 # New-VMSwitch -name $Switch.name -notes $Switch.note -NetAdapterInterfaceDescription $adapter.ifDesc -AllowManagementOS $allow 
                 
                 If (!([string]::IsNullOrEmpty($SwitchHOSTIP))){
                        new-NetIPAddress -InterfaceAlias $Switch.netadaptername -IPAddress $SwitchHOSTIP -PrefixLength $Switch.HostPrefix
                    }
                }
            else
                { New-VMSwitch -name $Switch.name -notes $Switch.note -SwitchType $Switch.type 
                 if ($Switch.type -eq "Internal") 
                    {$swName=$Switch.name
                     new-NetIPAddress -InterfaceAlias "vEthernet ($swName)" -IPAddress $SwitchHOSTIP -PrefixLength $Switch.HostPrefix
                    }

                }
            Write-Host "$Switchname wurde neu angelegt und mit IP $switchHOSTIP konfiguriert."   -ForegroundColor Green
         }
      }


 

write-host "******************************************************"
"Ausführungszeit: {0:hh}:{0:mm}:{0:ss}" -f ((get-date)-$Start)
write-host "******************************************************"

Get-Date

Stop-Transcript | Out-Null
