﻿Param 
      (
      [string]$vmName =$(throw '- Der Parameter -vmName wird benoetigt!') ,
      [switch]$mitRollen
      )


write-host "     ************************************************************     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     *       Skript Create-VM für AI2 by Thorsten Raucamp       *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     *                  Version 0.95 2014-05-15                 *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     ************************************************************     " -ForegroundColor DarkGreen
Write-Host ""
Write-Host ""
 
$Start=Get-Date
if([string]::IsNullOrEmpty($configfile)) {$configfile=(Get-ItemProperty -path HKLM:\SOFTWARE\AI2).Configfile}
[xml]$config = Get-Content $configfile
$lang=Import-Csv ((Split-Path $configfile -Parent)+"\translations.csv")
$LID=(((Get-WmiObject Win32_OperatingSystem))).OSLanguage
$ConfirmPreference = "none"

$logfile=$config.cfg.log +$vmName+".txt"
$ErrorActionPreference="SilentlyContinue"
Stop-Transcript | Out-Null
$ErrorActionPreference="Continue"

Start-Transcript -Path $logfile -Append
$Host.UI.RawUI.WindowTitle = "Create-VM -- $vmName -- AI2 --"
Write-Host "Erstelle $vmName, gestartet um $Start"
Write-Host "Am Ende werden die Rollen installiert: $mitRollen "
Write-Host "Configfile: " -NoNewline -ForegroundColor Yellow
Write-Host "$configfile" -ForegroundColor Green

$Def=$config.CFG.VMs.Default
$vmx= ($config.cfg.VMs.vm)  | where {$_.name -eq $vmName}
$vmx
# Variablen belegen
$GB=1024*1024*1024
$ScriptDir=(Get-ItemProperty HKLM:\SOFTWARE\AI2).scriptdir


$IsoDir=$config.CFG.HOST.ISO
$IsoInfo=($IsoDir+"\IsoInfo.csv")
if (!(Test-Path $IsoInfo))
    {   $xecute=$ScriptDir+"\tools\get-Isoinfo.ps1"
        Start-Process   -WorkingDirectory $PSHOME -FilePath "powershell.exe" -ArgumentList "$xecute" -Wait -NoNewWindow | Out-Host           
    }


[int]$osbuild=  (((Get-WmiObject Win32_OperatingSystem).version).split("."))[-1]
$Def=$config.CFG.VMs.Default
# Konfiguration aus Default und zusätzlich definierten Einstellungen zusammensetzen
$vm="" # Löschen w/ der automatischen Referenzierung bei XML
        if ($def.ChildNodes.name -match "AdditionalNICs")  {$def.RemoveChild($def.SelectSingleNode("AdditionalNICs"))| Out-Null} # Löschen w/ der automatischen Referenzierung bei XML
        if ($def.ChildNodes.name -match "additionalDisks") {$def.RemoveChild($def.SelectSingleNode("additionalDisks"))| Out-Null} # Löschen w/ der automatischen Referenzierung bei XML 
        if ($def.ChildNodes.name -match "Dedup") {$def.RemoveChild($def.SelectSingleNode("Dedup"))| Out-Null} # Löschen w/ der automatischen Referenzierung bei XML
$vm=$def #Defaultwerte werden übernommen
        foreach($vmchild in $VMx.ChildNodes){ # in der VM definierte Werte überschreiben die Default-Werte
                #if ($vmchild.ChildNodes.Count -gt 1 ){$s2.AppendChild($vmchild)} #sobald er eine Position hinzugefügt hat, wird die Schleife verlassen!
                if (!([string]::IsNullOrEmpty($vmchild.'#text'))){# Ersetze den Default-Wert mit dem angegebenen Wert. Achtung! Leere Angaben werden übersprungen!
                      $vm.($vmchild.Name)=$vmchild.'#text'
                     }
               }
$vm.SetAttribute("VMName",$vmx.Name)
        if ($VMx.ChildNodes.name -match "AdditionalNics") {$vm.AppendChild($VMx.AdditionalNics)} # Der Bereich AdditionalNics wird separat übernommen
        if ($VMx.ChildNodes.name -match "additionalDisks") {$vm.AppendChild($VMx.AdditionalDisks)} # Der Bereich additionalDisks wird separat übernommen
        if ($VMx.ChildNodes.name -match "Dedup") {$vm.AppendChild($VMx.Dedup)} # Der Bereich Deduplikation wird separat übernommen
        # Konfiguration der VM kann beginnen        
$generation=""
$success=$true
$VMd=$config.cfg.HOST.VMPrefix+$vm.VMName
          # Speicherangeben in GB umrechnen
            [uint64]$VhdSize = [uint64]$VM.SystemDiskSize * $GB
            [uint64]$MemoryMinimumBytes = [uint64]$VM.MemoryMinimumBytes * $GB
            [uint64]$MemoryMaximumBytes = [uint64]$VM.MemoryMaximumBytes * $GB
            [uint64]$MemoryStartupBytes = [uint64]$VM.MemoryStartupBytes * $GB
            $Path=$vm.Path
            $VHDName = "System_"+$vm.vmname
            # Systemdisk 
            $VMd=$config.cfg.HOST.VMPrefix+$vm.vmname
            $DiskPath = "$Path\$VMd\Virtual Hard Disks"
            $DestDisk = "$Path\$VMd\Virtual Hard Disks\$vhdName.vhdx"
            $DestDisk2 = "$Path\$VMd\'Virtual Hard Disks'\$vhdName.vhdx"
            $ISOPath= $vm.ISOPath
            $VHDFormat= 'vhdx'

#    $skipVHD=$True

    if (!($skipVHD)) 
        {
            If (!(test-path $DiskPath)) {md $DiskPath }# Ueberpruefen, ob Verzeichnis existiert, wenn nicht, dann erstellen

            If ((([string]::IsNullOrEmpty($vm.edition)))-or ($vm.edition -eq "NonMS") )
                {#--> Wenn noch keine System-Disk angelegt wurde dann wird eine anleglegt.
                 if (!(test-path $DestDisk)){
                        $VHDName = $vm.VHDName
                        [uint64]$VhdSize = [uint64]$vm.SystemDiskSize * $GB
                        if ($vm.SystemDiskType -eq "Fixed") {New-VHD   –Path  $DestDisk –SizeBytes $VhdSize} 
                        else {New-VHD   –Path  $DestDisk –SizeBytes $VhdSize -Dynamic}
                       }
                }
            
            else
                { #  Nur fuer Windows Betriebssysteme gedacht, bei denen die Edition angegeben ist
                 If (!(test-path $DestDisk))          
                    {
                    $creat=$true
                    if (!([System.IO.Path]::GetExtension($ISOPath) -eq ".vhdx")) 
                        {
                          if ((((Get-ChildItem function:[f-z]: -Name | Where-Object { -not (Test-Path -Path $_)}) | where {$_ -ne $x})).count -lt 5)
                                {Write-Host "Nicht genuegend Laufwerksbuchstaben frei! Warte auf freie Laufwerksbuchstaben!" -ForegroundColor Yellow
                                 do
                                    { sleep 10
                                      $frei=(((Get-ChildItem function:[f-z]: -Name | Where-Object { -not (Test-Path -Path $_)}) | where {$_ -ne $x})).count
                                    }
                                 until ( $frei -gt 4)
                                }
                          Write-Host "Erstelle System-Disk mit Convert-WindowsImage"
                          $success=$false
                          $dldir=$config.CFG.HOST.DL
                          if (!(test-path ($ScriptDir + "\Tools\Convert-WindowsImage.ps1"))){robocopy.exe $dldir ($ScriptDir+"\Tools") "Convert-WindowsImage.ps1" /np /ns /nc /ndl /np /nfl}
                          if (!(test-path ($ScriptDir + "\Tools\Convert-WindowsImage.ps1")) ){
                                write-host "Das Benötigte Tool convert-WindowsImage.ps1 wurde nicht im Ordner $ScriptDir\Tools gefunden! Bitte herunterladen und Programm neu starten!" -ForegroundColor red
                                break 
                            }
                          $Generation= $vm.Generation
                          if([string]::IsNullOrEmpty($Generation) ) {$generation=$config.cfg.VMs.Default.Generation}
                          if ($osbuild -lt 9600){$Generation=1} # ab 9600 können erst Generation 2 VMs erstellt werden!
                          if( $Generation -eq 2){$VHDPartitionStyle="GPT"}
                          else {$VHDPartitionStyle="MBR"}
                          $xecute=$ScriptDir + "\Tools\Convert-WindowsImage.ps1 -SourcePath $ISOPath -vhdformat $VHDFormat -sizebytes $VhdSize -vhdpath "+ $DestDisk2 +" -Edition " +$vm.edition  +"  -VHDPartitionStyle $VHDPartitionStyle "
                          $xecute
                          Start-Process   -WorkingDirectory $PSHOME -FilePath "powershell.exe" -ArgumentList "$xecute" -Wait -NoNewWindow | Out-Host
                          
                          $success=$true 
                          Write-Host "VHDx ist jetzt da!"
                        }
                    else
                    {New-VHD –Path $DestDisk –ParentPath $ISOPath –Differencing}
                    }
                }

        }
#    $sikpcopy=$True
    $Host.UI.RawUI.WindowTitle = "Create-VM -- $vmName -- AI2 --"

$skipFeatures=$false
#if (!($skipFeatures))
if (( (Get-WmiObject -class Win32_OperatingSystem).caption -match "Server"))
    {        If (!((([string]::IsNullOrEmpty($vm.edition)))-or ($vm.edition -eq "NonMS"))){
                $Diskinfo=(Get-WindowsImage -ImagePath $DestDisk -index 1)
                if ($Diskinfo.InstallationType -match "Server")  
                    {   $Rollen=($vm.rollen).Split(",")
                        $preFeature=Import-Csv (($configDir=Split-Path $configfile -Parent)+"\PreFeature.csv")
                        $IsoSource= import-csv $IsoInfo
                        foreach ($rolle in $Rollen)
                            { $features= ($preFeature | where {$_.Rolle -eq $rolle})
                              foreach ($feature in $features) 
                                       {$mgmt=""
                                        $subf=""
                                        $Src1=""
                                        Write-Host $feature.Features
                                        if ([int]$Diskinfo.Build -lt 9200) {$cmmnd="Add-WindowsFeature"} Else {$cmmnd="Install-WindowsFeature"}
                                        if ([System.Convert]::ToBoolean($feature.IncludeMgmtTools ) -eq $true){$mgmt=" -IncludeManagementTools"}
                                        if ([System.Convert]::ToBoolean($feature.AllSubFeatures ) -eq $true){$subf=" -IncludeAllSubFeature"}
                                        if (!([string]::IsNullOrEmpty($feature.source))){
                                                If ($feature.Source -eq "IsoInfo"){
                                                      $ISOs=$IsoSource | where {($_.Language -EQ $Diskinfo.Languages) -and ($_.OSBuild -eq $Diskinfo.Build)}
                                                      Write-Host "Feature: " -ForegroundColor Cyan -NoNewline
                                                      $feature
                                                      $IsoSrc=""
                                                      foreach ($ISO in $ISOs) {if (Test-Path ($iso.Path)) { $IsoSrc= $ISO.Path }}
                                                      if ([string]::IsNullOrEmpty($IsoSrc))
                                                            {   
                                                                [System.Reflection.Assembly]::LoadWithPartialName("System.Windows.Forms") |Out-Null
                                                                [System.Windows.Forms.MessageBox]::Show("Keine ISO gefunden! Im nächsten Dialog bitte die Sourcen für $DestDisk angeben!" , "Achtung!")
                                                                
                                                                            Add-Type -AssemblyName System.Windows.Forms
                                                                            $dlg = New-Object -TypeName  System.Windows.Forms.OpenFileDialog
                                                                            if ($dlg.ShowDialog() -eq 'OK') { $IsoSrc=$dlg.FileName } 
                                                                            else  { Write-Host "Keine ISO angegeben, Source wird versucht, online zu installieren!" -ForegroundColor Red
                                                                                  }
                                                                          
                                                            }

                                                    }
                                                else {$Src1=$feature.Source}
                                           }
                                        if (!([string]::IsNullOrEmpty($feature.source))) { 
                                             if ( $IsoSrc -like "*.iso") {$idrive= mount-ISO -Path $IsoSrc
                                                  $Src1=" -Source $idrive"
                                                  if ($feature.Source -eq "IsoInfo"){$Src1=$Src1+"sources\sxs"}
                                                }
                                             else {$Src1=" -Source " +$IsoSrc}
                                           }
                                        #[string]$desti=$DestDisk
                                        $cmdline= $cmmnd + " -Vhd '$DestDisk'"+ " -Name " +$feature.Features + $mgmt + $subf + $Src1
                                        Invoke-Expression -Command $cmdline
    
                                        if (!([string]::IsNullOrEmpty($feature.source))) { 
                                        Dismount-DiskImage -ImagePath $IsoSrc
                                        sleep 10
                                        }
                                       
                                       }
                              #
                              #
                            }
                        sleep 10
                    }
               }             
            #Dismount-DiskImage -ImagePath $DestDisk
        }
#    $sikpcopy=$True


    if (!($skipVHD)) 
    {

            If (!((([string]::IsNullOrEmpty($vm.edition)))-or ($vm.edition -eq "NonMS") )) 
                { # Kopieren von Daten nur für MS-Produkte
                
                 If ((test-path $DestDisk))  
                    { # Einbinden der VHD, Dateien darauf kopieren und unattend.xml anpassen
                    # inspiriert durch Thomas Lee http://tfl09.blogspot.de/ http://pshscripts.blogspot.de/2013/01/create-vmps1.html
                    $ErrorActionPreference="SilentlyContinue"
                    Mount-DiskImage -ImagePath $DestDisk

                    (Get-Partition (Get-Diskimage -ImagePath $DestDisk).Number | where {$_.size -gt $GB}).DriveLetter

                    if (!([string]::IsNullOrEmpty((get-disk | where {$_.OperationalStatus -eq "Offline"} ).Number)) )   {Set-Disk (get-disk | where {$_.OperationalStatus -eq "Offline"} ).Number -IsOffline $False} 
                
                   [string]$dest = (Get-DiskImage –ImagePath $DestDisk | Get-Disk | Get-Partition | Get-Volume).DriveLetter + ":\"
                    if ($dest.Length -ne 3) {
                                             #Write-Host "VHD $DestDisk sollte gebunden werden" -ForegroundColor Yellow
                                             #Get-Disk | ft
                                             #Write-Host "Ergebnis : >$dest<" -ForegroundColor Yellow
                                             $cnt=0
                                             do
                                             {  $cnt++
                                                Mount-DiskImage -ImagePath $DestDisk
                                                sleep 10
                                                [string]$dest = (Get-DiskImage –ImagePath $DestDisk | Get-Disk | Get-Partition | Get-Volume).DriveLetter + ":\"
                                                #Write-Host "nächstes Ergebnis : >$dest<" -ForegroundColor Yellow
                                             }
                                             until ($dest.Length -eq 3)
                                             Write-Host "Setze Script nach $cnt Versuchen fort."
                                             if (!([string]::IsNullOrEmpty((get-disk | where {$_.OperationalStatus -eq "Offline"} ).Number)) )   {Set-Disk (get-disk | where {$_.OperationalStatus -eq "Offline"} ).Number -IsOffline $False} 
                
                                             }
                    Write-Host "Aktuelles Ziel-Verzeichnis: $dest ! " -ForegroundColor Green -NoNewline
                    $ErrorActionPreference="Continue"
                    get-date 

               
                    #################################################################
                    # Fileoperationen, Rollenspezifisch
                    $Rollen=($vm.rollen).Split(",")  
                    $ConfirmPreference = "none"
                    If (!(test-path ($dest+"install"))) {md ($dest+"install") | Out-Null }# Ueberpruefen, ob Verzeichnis existiert, wenn nicht, dann erstellen
                    foreach($rolle in $Rollen)
                       { 
                        $flsrc=$config.CFG.HOST.DL + "\"+$rolle
                        if (test-path ($flsrc))
                            {
                             if (!(Test-Path ($dest+"install\"+$rolle))) {md ($dest+"install\"+$rolle) | Out-Null}
                             robocopy.exe $flsrc ($dest+"install\"+$rolle) /s /np /ns /nc /nfl /ndl /J | Out-Host
                            
                        }
                        
                     
                       }                         
                    Remove-ReadOnlyAttribute ($dest+"install")
                    Write-Host "Kopiere Startdateien auf VHD"
                    robocopy ($ScriptDir+"\CFG\Files") $dest /np /ns /nc /nfl /ndl | Out-Host
                    #Ueberpruefen der Variablen für die unattend.xml
                    $pwd=$vm.AdminPW
                    if (([string]::IsNullOrEmpty($pwd))) {$PWD=$Config.CFG.Domain.DomainAdminPW}
                    $Owner=$vm.Owner
                    If (([string]::IsNullOrEmpty($owner))) {$Owner=$Config.CFG.Domain.Owner}
                    #Einlesen des Templates der unattend.xml und modifizieren
                    $Locale=$vm.locale
                    If (([string]::IsNullOrEmpty($Locale))){$Locale="de-de"}
                    [xml]$unattend = (Get-Content ((split-path -Parent $configfile) + "\unattend_template.xml")) -replace ("10.0.0.250",$vm.srvip) -replace ("10.0.0.254",$config.cfg.network.gwip) -replace ("SERVER", $vm.vmname)  -replace ("XXX",$Owner)   -replace ("---",$config.cfg.domain.organization)  -replace ("admin@123",$PWD) -replace("de-de",$Locale)
 
                   if (!([string]::IsNullOrEmpty($vm.key))) 
                        { $key="" # Wenn ein Produktkey hintelegt ist, wird er in die unattend.xml aufgenommen
                          $key=$unattend.CreateElement("ProductKey")
                          $key.set_innertext($vm.key)
                          (($unattend.unattend.settings | Where-Object { ($_.pass -eq "specialize")}).component | Where-Object {($_.name -eq "Microsoft-Windows-Shell-Setup")}).appendchild($key)}

                    ($unattend.unattend.settings | Where-Object { ($_.pass -eq "specialize")}).component | Where-Object {($_.name -eq "Microsoft-Windows-Shell-Setup")}
                    $unattend.Save("$dest\unattend.xml")
                    Write-Host "unattend.xml wurde gespeichert!"
                    Dismount-DiskImage -ImagePath $DestDisk
                    #################################################################
 
                    }
                 else
                    {
                    Write-Host "Fehler beim erstellen der Systemdisk fuer $vmd!"
                    Dismount-DiskImage -ImagePath $DestDisk
                    $success=$false
                    }
               }
    }
     $srvIP=$vm.srvip
# $skipcreateVM=$True
    $Host.UI.RawUI.WindowTitle = "Create-VM -- $vmName -- AI2 --"
if (!($skipcreateVM)) 
    {               
            $ComputerName= "localhost" #$vm.ComputerName
            # VM anlegen
           
            

             $bootdevice=$vm.BootDevice
            
             $VMPath=$VM.Path
             $SwitchName=$VM.SwitchName
             #$Generation= 1 # $vm.Generation
             $Generation= $vm.Generation
             if([string]::IsNullOrEmpty($Generation) ) {$generation=$config.cfg.VMs.Default.Generation}

             $createVM="New-VM -VHDPath $DestDisk2 -BootDevice $BootDevice  -MemoryStartupBytes $MemoryStartupBytes -Name $vmd -Path $VMPath -SwitchName $SwitchName "
             if ( $osbuild -gt 9200 ){$createVM = $createVM+"-Generation $Generation"}
             Write-Host " Es wird eine Generation $generation VM erstellt" -ForegroundColor Green
             Invoke-Expression -Command $createVM 

             # VM-Einstellungen
             if ($vm.Memorytype -eq "static") {Set-VM -Name $vmd  -AutomaticStartAction $VM.AutomaticStartAction -AutomaticStartDelay $vm.AutomaticStartDelay -AutomaticStopAction $VM.AutomaticStopAction -MemoryStartupBytes $MemoryStartupBytes -ProcessorCount $VM.ProcessorCount -StaticMemory}
             else{            
                 Set-VM -Name $vmd   `
                    -AutomaticStartAction $VM.AutomaticStartAction `
                    -AutomaticStartDelay $vm.AutomaticStartDelay `
                    -AutomaticStopAction $VM.AutomaticStopAction `
                    -DynamicMemory `
                    -MemoryStartupBytes $MemoryStartupBytes `
                    -MemoryMinimumBytes $MemoryMinimumBytes `
                    -MemoryMaximumBytes $MemoryMaximumBytes `
                    -ProcessorCount $VM.ProcessorCount
                }
            # Kompatibilitätsmodus für unterschiedliche Prozessorgenerationen
            if (!([string]::IsNullOrEmpty($config.cfg.host.CompatibilityForMigrationEnabled))) {Set-VMProcessor -VMName $vmd -CompatibilityForMigrationEnabled ([System.Convert]::ToBoolean($config.cfg.host.CompatibilityForMigrationEnabled))}
            # DVD-Einstellungen
            If (!([string]::IsNullOrEmpty($VM.DVDISO))) {Set-VMDvdDrive -VMName $vmd -Path $VM.DVDISO }
            
            if ($generation -eq 2) {
                $HDD0= get-VMHardDiskDrive -VMName $vmd -ControllerNumber 0 -ControllerLocation 0
                $DVD0= Get-VMDvdDrive   -VMName $vmd
                #$NET0= (Get-VMNetworkAdapter   -VMName $vmd)[0] 
                Set-VMFirmware -VMName $vmd  -EnableSecureBoot $vm.EnableSecureBoot -FirstBootDevice $HDD0 #-BootOrder $HDD0,$DVD0 

                }
                else {Set-VMBios   -VMName $vmd -EnableNumLock}



            # 1. Netzwerkadapter    
            If (!([string]::IsNullOrEmpty($vm.StaticMacAddress)))
                    {Set-VMNetworkAdapter   -VMName $vmd -StaticMacAddress $VM.StaticMacAddress}
            # weitere Netzwerkadapter    
            # Wenn nur aeltere Netzwerkadapter genutzt werden koennen, muss der automatisch erstellte Adapter entfernt werden
            if (([System.Convert]::ToBoolean($vm.AdditionalNICs.Del1NIC)) -eq $true) 
                    {Remove-VMNetworkAdapter   -VMName $vmd}
            # Weiteren Netzwerkadapter erstellen
            ForEach ($NIC in $VM.AdditionalNICs.AdditionalNIC)
                    {
                        $isLegacy=[System.Convert]::ToBoolean($nic.islegacy)
                        Add-VMNetworkAdapter   -VMName $vmd -IsLegacy $isLegacy -SwitchName $nic.SwitchName -Name $NIC.Name 
                        If (!([string]::IsNullOrEmpty($NIC.StaticMacAddress)))
                            {Set-VMNetworkAdapter   -VMName $vmd -Name $NIC.Name -StaticMacAddress $NIC.StaticMacAddress}
                        #VLAN-ID setzen, wenn angegeben
                        If (!([string]::IsNullOrEmpty($nic.VLANID)))
                            {Set-VMNetworkAdapterVlan   -VMName $vmd -Access -VlanId $nic.VLANID -VMNetworkAdapterName $NIC.Name}
                    }
            # Weitere Festplatten erzeugen und einbinden
            ForEach ($Disk in $VM.Additionaldisks.Disk)
                    { 
                     If (!([string]::IsNullOrEmpty($Disk.File)))
                        {$DiskPath=$Disk.File}
                     else 
                        {$Path=$Disk.Speicherort
                         $VHDName = $Disk.VHDName
                         $DiskPath = "$Path\$VMd\Virtual Hard Disks\$vhdName"
                        }
                     if (([System.Convert]::ToBoolean($disk.Create)) -eq $true) 
                        { 
                        [uint64]$VhdSize = [uint64]$Disk.VHDSize * $GB
                        New-VHD  –Path $DiskPath –SizeBytes $VhdSize
                    }
                    $controllerType="SCSI"
                     if($disk.BUS -eq"IDE"){$controllerType="IDE"}
                     Add-VMHardDiskDrive  -VMName $vmd -ControllerType $controllerType -ControllerNumber 0 -Path $DiskPath 
            
                    }
}    


# ToDo: if ($ComputerName -ne "localhost" { move VM to  -ComputerName $ComputerName }


$Host.UI.RawUI.WindowTitle = "Create-VM -- $vmName -- AI2 -- Firewall-Settings"
If (!((([string]::IsNullOrEmpty($vm.edition)))-or ($vm.edition -eq "NonMS") )) 
   {#Start der VM, damit die Installation schon beginnen kann
    Start-VM  -ComputerName $ComputerName -Name $vmd
    #Start-VM  -Name $vmd
    sleep 10 
    if ((get-vm -Name $vmd).state -ne "Running") {
        Write-host "2. Versuch" -ForegroundColor Yellow
        Start-VM  -Name $vmd 
        sleep 10
        Get-VM
        if ((get-vm -Name $vmd).state -ne "Running") {pause}
        }
    Write-host "$vmd wurde erstellt und gestartet."
    $ADMPW= $vm.AdminPW
    If (([string]::IsNullOrEmpty($ADMPW))) {$ADMPW =$config.cfg.Domain.DomainAdminPW}
    $Cred = New-Object System.Management.Automation.PSCredential "Administrator", (ConvertTo-SecureString $ADMPW -AsPlainText -Force)
    sleep 10 
    wait-forHost -computer  $vm.SrvIP -Pause 10
    
    
    $waitcount=0 | Out-Null
    do
        {[int]$waitcount++
         wait-forHost -computer $vm.SrvIP -Pause 15
         if (($waitcount %4)  -eq 0 )
            {
             $zeit=$waitcount/4 
             Write-Host "Warte schon $zeit Minuten!"
            }
        }
    until ((Check-WMSCon $vm.SRVIP))
    write-host "VM ist jetzt bereit."
    get-date 
    $skipInitialize=$false
    if (!($skipInitialize))        
           {
             $ADMPW= $vm.AdminPW
            If (([string]::IsNullOrEmpty($ADMPW)))
                {$ADMPW =$config.cfg.Domain.DomainAdminPW}
            $Cred = New-Object System.Management.Automation.PSCredential "Administrator", (ConvertTo-SecureString $ADMPW -AsPlainText -Force)
            $DVDLetter=$vm.dvdletter
            $Session= New-PSSession -ComputerName $vm.SrvIP -Credential $Cred
  
            $x=Invoke-Command  -Session $Session  -ScriptBlock  {(Get-Item -Path HKLM:\SOFTWARE).GetSubKeyNames()}# Nur wenn nicht schon durch das Skript bearbeitet 
           if(($X) -notcontains"AI2")
                    {
                    #allgemeine Settings
                    Invoke-Command  -Session $Session  -ScriptBlock {
                        (Get-WmiObject -Class "Win32_TerminalServiceSetting" -Namespace root\cimv2\terminalservices).SetAllowTsConnections(1) |Out-File -FilePath c:\log\ps.txt -Append
                        (Get-WmiObject -class "Win32_TSGeneralSetting" -Namespace root\cimv2\terminalservices -Filter "TerminalName='RDP-tcp'").SetUserAuthenticationRequired(1) |Out-File -FilePath c:\log\ps.txt -Append
                        Write-Host "Aktualisiere Firewall-Regeln"
                        #netsh advfirewall firewall set rule name="Remotedesktop - Benutzermodus (TCP eingehend)" new profile="domain,private" enable=yes
                        #netsh advfirewall firewall set rule name="Remotedesktop - Benutzermodus (UDP eingehend)" new profile="domain,private" enable=yes
                        #set-NetFirewallRule -DisplayName “Datei- und Druckerfreigabe (Echoanforderung - ICMPv4 eingehend)” -enabled True -Profile Any
                        #set-NetFirewallRule -DisplayName "Remotedesktop - Benutzermodus (TCP eingehend)" -enabled True -Profile Domain,private       
                        #set-NetFirewallRule -DisplayName "Remotedesktop - Benutzermodus (UDP eingehend)" -enabled True -Profile Domain,private       
                        #netsh firewall set service RemoteAdmin enable
                        #set-NetFirewallRule -DisplayGroup "Remoteverwaltung"  -Profile Domain,private -Enabled True
                        New-NetRoute -InterfaceAlias "Ethernet" -NextHop $using:config.CFg.Network.GWIP   -DestinationPrefix "0.0.0.0/0"
                        Set-DnsClientServerAddress -InterfaceAlias "Ethernet" -ServerAddresses $using:config.CFg.Rollen.DHCP.DNSServer
                        

                        fsutil.exe behavior set disable8dot3 1
                        if ( $osbuild -gt 9200 ){ Enable-NetAdapterRSS -Name * -IncludeHidden}
                       
                        Enable-NetAdapterIPsecOffload -Name *

                        ######################################################
                        $LID=(((Get-WmiObject Win32_OperatingSystem))).OSLanguage
                        $v = ($using:lang | where {$_.lid -eq $lid})
                        If ([string]::IsNullOrEmpty($v.language)){$v=$lang[0]}
                        $v.language
                        set-NetFirewallRule -Name "FPS-ICMP4-ERQ-In" -enabled True -Profile Any # -DisplayName “Datei- und Druckerfreigabe (Echoanforderung - ICMPv4 eingehend)”
                        set-NetFirewallRule -Name  "RemoteDesktop-UserMode-In-TCP" -enabled True -Profile Domain,private # -DisplayName "Remotedesktop - Benutzermodus (TCP eingehend)" 
                        set-NetFirewallRule -Name "RemoteDesktop-UserMode-In-UDP" -enabled True -Profile Domain,private  #-DisplayName "Remotedesktop - Benutzermodus (UDP eingehend)"     
                        set-NetFirewallRule -DisplayGroup  $v.Remote_Service_Management  -Profile any -Enabled True
                        Set-NetFirewallRule -Name "NETDIS-NB_Name-In-UDP" -Profile any -Enabled True
                        Set-NetFirewallRule -Name "WMI-WINMGMT-In-TCP"  -Profile any -Enabled True
  
                        #BPA-Einträge
                        $Cmmand= "sc.exe config srv start= demand"
########                        Invoke-Expression -Command $Cmmand
                        #BPA-Einträge Ende
                        sleep 10
                        set-NetConnectionProfile -NetworkCategory Private


                        # Settings für lokalen Admin
                        Set-ItemProperty -Path hkcu:\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced -name ShowSuperHidden -Value 1 
                        Set-ItemProperty -Path hkcu:\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced -name HideFileExt -Value 0 

 






                        $DVDLetter=$using:DVDLetter
                        If (!([string]::IsNullOrEmpty($DVDLetter)))
                            {   $DVDLetter=$DVDLetter+":"
                                (gwmi Win32_cdromdrive).drive | %{$a = mountvol $_ /l;mountvol $_ /d;$a = $a.Trim();mountvol $DVDLetter $a} |Out-File -FilePath c:\log\ps.txt -Append
                            }
                        } | Out-Host

                    if(([System.Convert]::ToBoolean($IPv6.Configure)) -eq $true){
                        if ((!([string]::IsNullOrEmpty($vm.IPv6)))){
                                  $DNS6Server=($config.CFG.VMs.vm | where {$_.Rollen -match "DC"}).ipv6
                                  Set-IPv6Config -ip $vm.SrvIP -Cred $Cred -Ipv6Adresse $vm.IPv6 -PrefixLength $IPv6.PrefixLength -Gateway $IPv6.Gateway -DNS6Server $DNS6Server -IPv6Prefix $IPv6.prefix -IPv4Bevorzugen ([System.Convert]::ToBoolean($IPv6.IPv4Bevorzugen))
                           }
                       }
                       Set-IPv6TransitionTechnologies -IP $vm.SRVIP -Cred $Cred -Net6to4Configuration $IPv6.Net6to4Configuration -NetTeredoConfiguration $IPv6.NetTeredoConfiguration -NetIsatapConfiguration $IPv6.NetIsatapConfiguration

                    #Festplatten
                    #$Session= New-PSSession -ComputerName $vm.SrvIP -Credential $Cred
                    $diskCounter=0
                    ForEach ($Disk in $VM.Additionaldisks.Disk)
                        {
                        $diskCounter=$diskCounter+1 
                        Invoke-Command  -Session $Session  -ScriptBlock  {
                            initialize-disk -number $using:diskcounter -partitionStyle GPT  |Out-File -FilePath c:\log\ps.txt -Append
                            New-Partition -DiskNumber $using:diskcounter -UseMaximumSize -DriveLetter $using:Disk.name  |Out-File -FilePath c:\log\ps.txt -Append
                            Format-Volume -DriveLetter $using:Disk.name -FileSystem $using:disk.FS -NewFileSystemLabel $using:disk.Label -confirm:$false
                            Out-File -FilePath c:\log\ps.txt -Append -InputObject "Festplatten wurden konfiguriert!"
                            get-date  |Out-File -FilePath c:\log\ps.txt -Append
                        } | Out-Host
                    }
                    Write-Host " $($diskCounter) Festplatten wurden formatiert!" -ForegroundColor Green
                    #if (($skipFeatures))
                    if (( (Get-WmiObject -class Win32_OperatingSystem).caption -notmatch "Server"))
                       {

                        $Rollen=($vm.rollen).Split(",")
                        # Install Features und weitere Aktionen 
                        if ($rollen -ccontains "DA")           { Invoke-Command  -Session $Session  -ScriptBlock  { Install-WindowsFeature RemoteAccess -IncludeManagementTools}  | Out-Host }
                        if ($rollen -ccontains "DHCP")         { Invoke-Command  -Session $Session  -ScriptBlock  { Add-WindowsFeature DHCP -IncludeAllSubFeature -IncludeManagementTools |Out-File -FilePath c:\log\ps.txt -Append} | Out-Host } 
                        if ($rollen -ccontains "WSUS")         { Invoke-Command  -Session $Session  -ScriptBlock  { Install-WindowsFeature -name UpdateServices-WidDB, UpdateServices-Services, UpdateServices-RSAT, UpdateServices-API,UpdateServices-UI -IncludeManagementTools}| Out-Host }
                        if ($rollen -ccontains "DC")           { Invoke-Command  -Session $Session  -ScriptBlock  {Install-windowsfeature -name AD-Domain-Services –IncludeManagementTools} | Out-Host }
                        if ($rollen -ccontains "IIS")
                            { Invoke-Command  -Session $Session  -ScriptBlock  {
                                        Write-Host "Installiere .Net-Framework 3.5.1"
                                        Install-WindowsFeature Net-Framework-Core -IncludeAllSubFeature -source W:\sources\sxs
                                        Import-Module Servermanager
                                        Write-Host "Installiere .NET WCF-HTTP Aktivierung"
                                        Add-WindowsFeature NET-WCF-HTTP-Activation45,NET-WCF-TCP-Activation45,NET-WCF-Pipe-Activation45
                                        Write-Host "Installiere .Net Features Webserver etc."
                                        Add-WindowsFeature Net-Framework-Features,Web-Server,Web-WebServer,Web-Common-Http,Web-Static-Content,Web-Default-Doc,Web-Dir-Browsing,Web-Http-Errors,Web-App-Dev,Web-Asp-Net,Web-Net-Ext,Web-ISAPI-Ext,Web-ISAPI-Filter,Web-Health,Web-Http-Logging,Web-Log-Libraries,Web-Request-Monitor,Web-Http-Tracing,Web-Security,Web-Basic-Auth,Web-Windows-Auth,Web-Filtering,Web-Digest-Auth,Web-Performance,Web-Stat-Compression,Web-Dyn-Compression,Web-Mgmt-Tools,Web-Mgmt-Console,Web-Mgmt-Compat,Web-Metabase,Application-Server,AS-Web-Support,AS-TCP-Port-Sharing,AS-WAS-Support, AS-HTTP-Activation,AS-TCP-Activation,AS-Named-Pipes,AS-Net-Framework,WAS,WAS-Process-Model,WAS-NET-Environment,WAS-Config-APIs,Web-Lgcy-Scripting,Windows-Identity-Foundation,Server-Media-Foundation,Xps-Viewer
                                        Write-Host ".net-Features wurden installiert"
                                        get-date  |Out-File -FilePath c:\log\ps.txt -Append
  
                                        } | Out-Host
                            }
                        
                       }
                              
                    Invoke-Command  -Session $Session  -ScriptBlock { 
                                                                        netsh firewall set service RemoteAdmin enable
                                                                        new-Item -Path HKLM:\SOFTWARE -name AI2
                                                                        set-NetConnectionProfile -NetworkCategory Private
                                                                        Start-Service -name RemoteRegistry
                                                                        Set-Service -Name RemoteRegistry -StartupType Automatic 
                                                                        Get-NetConnectionProfile
                                                                        Get-Service -Name RemoteRegistry
                                                                        Write-Host "Remoteregistry gestartet" -ForegroundColor Green
                                                                        slmgr /rearm 

                                                                    }
                    If (!([string]::IsNullOrEmpty($VM.DeduplicationDrives))){   
                                Invoke-Command  -Session $Session  -ScriptBlock  {
                                    Import-Module ServerManager
                                    Add-WindowsFeature -name FS-Data-Deduplication
                                    Import-Module Deduplication
                                    $drives=($using:VM.DeduplicationDrives).split(',')
                                    foreach($drive in $drives){
                                        Enable-DedupVolume ($drive+":")
                                        Set-DedupVolume -Volume ($drive+":") -MinimumFileAgeDays 1
                                    }
                                    ForEach ($Plan in $VM.VM.dedup){New-dedupschedule -Name $plan.name -Type $Plan.Type -full -Days $plan.Days -Start $plan.start -DurationHours $plan.DurationHours}
                                 }
                            }
                    Write-Host "Integration-Services-Check: Aktuelles OS des Servers: " -ForegroundColor Cyan -NoNewline 
                    Write-Host " $osbuild" -NoNewline
                    Write-Host " OS des Gastes: " -NoNewline -ForegroundColor Cyan
                    ((get-vm  $vmd).Integrationservicesversion.build)
                    if ((get-vm  $vmd).Integrationservicesversion.build -lt $osbuild){
                         Write-Host "Aktualsieiere Integration-Services" -ForegroundColor Green
                         $oldISO= (Get-VMDvdDrive -VMName $vmd).path
                         # inspiriert durch http://p0w3rsh3ll.wordpress.com/2012/11/15/follow-up-about-hyper-v-vm-integration-services/
                         Get-VMDvdDrive -VMName $vmd  | Set-VMDvdDrive -Path "C:\Windows\system32\vmguest.iso"
                         Invoke-Command  -Session $Session  -ScriptBlock  { Write-Host "IS wird aktualisiert!" -ForegroundColor Cyan
                                                                            $DVDLetter=$using:DVDLetter 
                                                                            $cmdline= $DVDLetter+":\support\$env:PROCESSOR_ARCHITECTURE\setup.exe"
                                                                            $ps = new-object System.Diagnostics.Process 
                                                                            $ps.StartInfo.Filename = $cmdline
                                                                            $ps.StartInfo.Arguments = " /quiet /norestart" 
                                                                            $ps.StartInfo.RedirectStandardOutput = $True 
                                                                            $ps.StartInfo.UseShellExecute = $false
                                                                            $ps.start()
                                                                            $ps.WaitForExit()            
                                                                            'Exit code {0}' -f $ps.ExitCode  #
                                                                          } 
                         Get-VMDvdDrive -VMName $vmd  | Set-VMDvdDrive -Path $oldISO
                         Write-Host "DVD wird zurückgesetzt" -ForegroundColor Cyan
                       }

                    $Error.Clear()
                    Restart-Computer -ComputerName $srvIP -Wait -For PowerShell -Force -Credential $Cred
                    if ($error[0].CategoryInfo.Category -eq "OperationStopped") {
                        Check-WMSCon -ComputerName $srvIP
                        $NotskipRestart = $true 
                        Write-Host "----" -ForegroundColor Yellow
                       }
                    $Error.Clear()
                    # $NotskipRestart = $true
                    if (($NotskipRestart)){
                        Invoke-Command  -Session $Session  -ScriptBlock  { Restart-Computer -Force } | Out-Host
                        Write-Host "Computer $srvIP wurde neu gestartet!"
                        Get-Date
                        #Restart-Computer -ComputerName $srv -Wait -For WinRM -Force -Credential $VMAdmin
                        $waitcount=0 | Out-Null
                        do
                            {[int]$waitcount++
                            sleep 15
                            if (($waitcount %4)  -eq 0 )
                                {
                                 $zeit=$waitcount/4 
                                 Write-Host "Warte schon $zeit Minuten!"
                                }
                            }
                        until ((Check-WMSCon  $srvIP ))
                    }
                    write-host "VM ist bereit für die Rollenkonfiguration."
        
                    Remove-PSSession -id (Get-PSSession | Where-Object {$_.ComputerName -eq $vm.SRVIP}).Id
                    Get-PSSession
              }
          }
   
   }  
write-host "Die Konfiguration der VM ist nun beendet"

write-host "aktuelle Einstellung ob Rollen installiert werden sollen: $mitRollen " -ForegroundColor Yellow
if ($mitRollen){
             
             
             If (!((([string]::IsNullOrEmpty($vm.edition)))-or ($vm.edition -eq "NonMS") )) {
                    wait-forHost -computer $srvIP -Pause 40}
             $xecute="$ScriptDir\SUB\H4_config-VM.ps1 -vmName " + $VMx.name
             Start-Process   -WorkingDirectory $PSHOME -FilePath "powershell.exe" -ArgumentList "$xecute" -RedirectStandardError $logfile  -Wait -NoNewWindow
             Write-Host "Die Rollenkonfiguration wurde beendet am:" -NoNewline -ForegroundColor Green
             Get-Date
             
            }
$ErrorActionPreference="SilentlyContinue"
Stop-Transcript | Out-Null
$ErrorActionPreference="Continue"

"Ausführungszeit: {0:hh}:{0:mm}:{0:ss}" -f ((get-date)-$Start)

Get-Date
Stop-Transcript | Out-Null

 