﻿#Requires –Version 3

Param 
      (
          [string]$vmName =$(throw '- Der Parameter -vmName wird benoetigt!') ,
          [string]$configfile
       )


$Start=Get-Date
write-host "     ************************************************************     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     *   AI2 Rollenkonfiguration der VMs - by Thorsten Raucamp  *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     *                  Version 0.95 2014-05-15                 *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     ************************************************************     " -ForegroundColor DarkGreen
Write-Host ""
Write-Host ""
Write-Host ""
write-host "Erstelle VMs am: " -NoNewline
Get-Date

$Host.UI.RawUI.WindowTitle = "Kofiguriere Rollen -- $vmName -- "
if ((Get-Command Test-Admin -ErrorAction Ignore).Verb -ne "Test") {Start-Process   -WorkingDirectory $PSHOME -FilePath "powershell.exe" -ArgumentList "$PSScriptRoot\SUB\H1_globale-Funktionen.ps1 "  -Wait}


if (!(Test-Admin)) {
                    $powershell = [System.Diagnostics.Process]::GetCurrentProcess()
                    $psi = New-Object System.Diagnostics.ProcessStartInfo $powerShell.Path
                    $script = $MyInvocation.MyCommand.Path
                    $prm = $script
                    foreach($a in $args) {$prm += ' ' + $a}
                    $psi.Arguments = $prm
                    $psi.Verb = "runas"
                    #$psi
                    [System.Diagnostics.Process]::Start($psi) | Out-Null
                    return;
                    # Neustart des Skriptes mit Adminrechten, sollte das aktuelle Skript nicht mit Administratorrechten 
                    # gestartet worden sein. Übernommen von der c't www.ct.de/1017144
                   }
if([string]::IsNullOrEmpty($configfile)) {$configfile=(Get-ItemProperty -path HKLM:\SOFTWARE\AI2).Configfile}
if (!(Test-Path $configfile)) {Write-Host "Bitte starten Sie das Skript erneut mit dem Parameter -configfile und der entsprechenden Pfadangabe"}
set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name Configfile -Value $configfile
[xml]$config = Get-Content $configfile
# Ende Header
$logfile=$config.cfg.log +$vmName+"-H4.txt"
#$ErrorActionPreference="SilentlyContinue"
#Stop-Transcript | Out-Null
#$ErrorActionPreference="Continue"

Start-Transcript -Path $logfile -Append
Get-Date
#################################################################################################################################################
 $skpath=(Get-ItemProperty HKLM:\SOFTWARE\AI2).scriptdir
 $vm= (($config.cfg.VMs.vm)  | where {$_.name -eq $vmname})
 $Rollen=($vm.rollen).Split(",")   
 #$Rollen      
 #$ErrorActionPreference="SilentlyContinue"
#Stop-Transcript | Out-Null
#$ErrorActionPreference="Continue"
#$ErrorActionPreference=
$Host.UI.RawUI.WindowTitle = "Configure-Rollen -- $vmName -- AI2 --"
 If (!((([string]::IsNullOrEmpty($vm.edition)))-or ($vm.edition -eq "NonMS") )) {
            $srvIP=$vm.srvip
            wait-forhost $srvIP -Pause 1
            write-host "Warte auf die WMSConnection zu $srvIP "
            Get-Date
            do
                        {Write-Host "." -ForegroundColor Magenta -NoNewline
                        }
            until ((Check-WMSCon $srvIP) -eq $true)
            Get-Date
        }

#Start-Transcript -Path $logfile -Append                              
 If ($Rollen -ccontains "SP"){ # Prerequisites installieren und autospinput.xml editieren
                                              write-host " Führe Skript Pre_SP.PS1 aus!" -ForegroundColor Green -NoNewline
                                              
                                             
                                              Write-host "Warte auf $vmName " -ForegroundColor Cyan -NoNewline
                                              $vm.SRVIP 

                                              $xecute="$skpath\SUB\Pre_SP.ps1 -vmName " +$vm.Name
                                              Start-Process   -WorkingDirectory $PSHOME -FilePath "powershell.exe" -ArgumentList "$xecute" -RedirectStandardError $logfile  -Wait -NoNewWindow
                                              write-host "Skript SP.PS1 wurde ausgeführt!" -ForegroundColor Green -NoNewline
                                              Get-Date
                                              #$ErrorActionPreference="SilentlyContinue"
                                              #Stop-Transcript | Out-Null
                                              #$ErrorActionPreference="Continue"

#Start-Transcript -Path $logfile -Append
                                            }
If ($Rollen -ccontains "SP2013"){ # Prerequisites installieren und autospinput.xml editieren
                                              write-host " Führe Skript Pre_SP2013.PS1 aus!" -ForegroundColor Green -NoNewline
                                              
                                             
                                              Write-host "Warte auf $vmName " -ForegroundColor Cyan -NoNewline
                                              $vm.SRVIP 

                                              $xecute="$skpath\SUB\Pre_SP2013.ps1 -vmName " +$vm.Name
                                              Start-Process   -WorkingDirectory $PSHOME -FilePath "powershell.exe" -ArgumentList "$xecute" -RedirectStandardError $logfile  -Wait -NoNewWindow
                                              write-host "Skript Pre_SP2013.PS1 wurde ausgeführt!" -ForegroundColor Green -NoNewline
                                              Get-Date
                                              #$ErrorActionPreference="SilentlyContinue"
                                              #Stop-Transcript | Out-Null
                                              #$ErrorActionPreference="Continue"

#Start-Transcript -Path $logfile -Append
                                            }
If ($Rollen -ccontains "SP2010"){ # Prerequisites installieren und autospinput.xml editieren
                                              write-host " Führe Skript Pre_SP2010.PS1 aus!" -ForegroundColor Green -NoNewline
                                              
                                             
                                              Write-host "Warte auf $vmName " -ForegroundColor Cyan -NoNewline
                                              $vm.SRVIP 

                                              $xecute="$skpath\SUB\Pre_SP2010.ps1 -vmName " +$vm.Name
                                              Start-Process   -WorkingDirectory $PSHOME -FilePath "powershell.exe" -ArgumentList "$xecute" -RedirectStandardError $logfile  -Wait -NoNewWindow
                                              write-host "Skript Pre_SP2010.PS1 wurde ausgeführt!" -ForegroundColor Green -NoNewline
                                              Get-Date
                                              #$ErrorActionPreference="SilentlyContinue"
                                              #Stop-Transcript | Out-Null
                                              #$ErrorActionPreference="Continue"

#Start-Transcript -Path $logfile -Append
                                            }
                                     
 foreach($rolle in $Rollen) {
                            Write-host "$rolle..." -NoNewline
                            $xecuteSkript="$skpath\SUB\$rolle.ps1"
                            if (Test-Path $xecuteSkript){
                                    write-host " Führe Skript $rolle.PS1 aus!" -ForegroundColor Green -NoNewline
                                    Get-Date
                                    $xecute="$xecuteSkript -vmName " + $vm.name
                                    $xecute
                                     if (!([string]::IsNullOrEmpty((get-disk | where {$_.OperationalStatus -eq "Offline"} ).Number)) )   {Set-Disk (get-disk | where {$_.OperationalStatus -eq "Offline"} ).Number -IsOffline $False} 
                                    #Invoke-Expression $xecute 
                                    Start-Process   -WorkingDirectory $PSHOME -FilePath "powershell.exe" -ArgumentList "$xecute" -RedirectStandardError $logfile  -Wait -NoNewWindow
                                    #Stop-Transcript | Out-Null
                                    #$ErrorActionPreference="Continue"
                                    #Start-Transcript -Path $logfile -Append
                                    write-host "Skript $rolle.ps1 wurde ausgeführt!" -ForegroundColor Green -NoNewline
                                    Get-Date
                                            
                                   }
                           }

write-host "Die Konfiguration der VMs ist nun beendet"
write-host "******************************************************"
"Ausführungszeit: {0:hh}:{0:mm}:{0:ss}" -f ((get-date)-$Start)
write-host "******************************************************"
Get-Date  

Stop-Transcript | Out-Null