﻿#Requires –Version 3

Param 
      (
          [string]$vmName =$(throw '- Der Parameter -vmName wird benoetigt!') ,
          [string]$configfile
       )


$Start=Get-Date
write-host "     ************************************************************     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     *   AI2 Configure-Inet1 für DA-Demo   by Thorsten Raucamp  *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     *                  Version 0.95 2014-04-04                 *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     ************************************************************     " -ForegroundColor DarkGreen
Write-Host ""
Write-Host ""
write-host "     Konfiguriere Server $VMName am: " -NoNewline
Get-Date
$VMName="INET1"
$Host.UI.RawUI.WindowTitle = "Configure Demo-Umgebung -- $vmName --"

if (!(Test-Admin)) {
                    $powershell = [System.Diagnostics.Process]::GetCurrentProcess()
                    $psi = New-Object System.Diagnostics.ProcessStartInfo $powerShell.Path
                    $script = $MyInvocation.MyCommand.Path
                    $prm = $script
                    foreach($a in $args) {$prm += ' ' + $a}
                    $psi.Arguments = $prm
                    $psi.Verb = "runas"
                    #$psi
                    [System.Diagnostics.Process]::Start($psi) | Out-Null
                    return;
                    # Neustart des Skriptes mit Adminrechten, sollte das aktuelle Skript nicht mit Administratorrechten 
                    # gestartet worden sein. Übernommen von der c't www.ct.de/1017144
                   }
if([string]::IsNullOrEmpty($configfile)) {$configfile=(Get-ItemProperty -path HKLM:\SOFTWARE\AI2).Configfile}
if (!(Test-Path $configfile)) {Write-Host "Bitte starten Sie das Skript erneut mit dem Parameter -configfile und der entsprechenden Pfadangabe"}
set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name Configfile -Value $configfile
[xml]$config = Get-Content $configfile
# Ende Header
$logfile=$config.cfg.log +$vmName+"-INET.txt"
$ErrorActionPreference="SilentlyContinue"
Stop-Transcript | Out-Null
$ErrorActionPreference="Continue"

Start-Transcript -Path $logfile -Append
#################################################################################################################################################

# Ende Header



# $Domain=$config.CFG.Domain 
# $DomainAdmin = New-Object System.Management.Automation.PSCredential ($Domain.Name + "\"+$Domain.Admin), (ConvertTo-SecureString $Domain.AdminPW -AsPlainText -Force)

$srv =$config.CFG.VMs.vm | where {$_.name -match $VMName}
$srvIP=$srv.srvip


$VMAdminPW=$srv.AdminPW
if([string]::IsNullOrEmpty($VMAdminPW)) {$VMAdminPW=$config.cfg.VMs.Default.AdminPW}
$VMAdmin = New-Object System.Management.Automation.PSCredential "Administrator", (ConvertTo-SecureString $VMAdminPW -AsPlainText -Force)



write-host "Überprüfe die Voraussetzungen für den Server $srvIP ..."

        wait-forHost $srvIP
Write-Host " $srvIP ist jetzt erreichbar! "
sleep 30 

do
{ sleep 10
  Write-Host "." -NoNewline -ForegroundColor Yellow
}
until ((Check-WMSCon $srvip) -eq $true)
Write-Host "Host steht zur Verfügung" -ForegroundColor Cyan
Get-Date

$daconf=$config.CFG.Rollen.DirectAccess

$PubAddr=$daconf.publicAdress.Split(".")
$FWIP=$config.CFG.rollen.fw.DMZNetzIPFW

$VMAdmin = New-Object System.Management.Automation.PSCredential "Administrator", (ConvertTo-SecureString $VMAdminPW -AsPlainText -Force)

Invoke-Command  -ComputerName $srvIP -Credential $VMAdmin  -Scriptblock {
                Set-DnsClientServerAddress -InterfaceAlias "Ethernet" -ServerAddresses 127.0.0.1 
                Set-DnsClient -InterfaceAlias "Ethernet" -ConnectionSpecificSuffix isp.example.com
                #netsh advfirewall firewall set rule group="File and Printer Sharing" new enable=yes ###
                set-NetFirewallRule -DisplayName “Datei- und Druckerfreigabe (Echoanforderung - ICMPv4 eingehend)” -enabled True -Profile any

                install-WindowsFeature DNS -IncludeManagementTools
                Install-WindowsFeature Web-WebServer -IncludeManagementTools
                do
                    { sleep 10
                      Write-Host "." -NoNewline -ForegroundColor Yellow
                    }
                until ((Get-WmiObject -Query "Select * from Win32_service where Name='DNS'").state -eq "Running")
                Write-Host "Erstelle Zonen... "
                Get-Date
                Add-DnsServerPrimaryZone -Name isp.example.com -ZoneFile isp.example.com.dns
                Add-DnsServerResourceRecordA -ZoneName isp.example.com -Name inet1 -IPv4Address 131.107.0.1
                Add-DnsServerPrimaryZone -Name msftncsi.com -ZoneFile msftncsi.com.dns 
                Add-DnsServerResourceRecordA -ZoneName msftncsi.com -Name www -IPv4Address 131.107.0.1
                Add-DnsServerResourceRecordA -ZoneName msftncsi.com -Name dns -IPv4Address 131.107.255.255
                install-WindowsFeature DHCP -IncludeManagementTools
                do
                    { sleep 10
                      Write-Host "." -NoNewline -ForegroundColor Yellow
                    }
                until ((Get-WmiObject -Query "Select * from Win32_service where Name='DHCP'").state -eq "Running")
                Write-Host "Konfiguriere DHCP... " 
                Get-Date
                Add-DhcpServerv4Scope -name "Internet" -StartRange 131.107.0.100 -EndRange 131.107.0.150 -SubnetMask 255.255.255.0 
                Set-DhcpServerv4OptionValue -DnsDomain isp.example.com -DnsServer 131.107.0.1 -Router 131.107.0.1
                $filename = "C:\inetpub\wwwroot\ncsi.txt"
                $text = "Microsoft NCSI"
                [System.IO.File]::WriteAllText($fileName, $text)
                $Pa=$using:PubAddr
                if ($pa -ccontains "137") {$pa=""}
                if ($pa -ne "") {
                    $zName=""
                    $cnt=1 
                    do 
                        { $zName=$zName+$pa[$cnt]
                          $cnt++
                          if ($cnt -lt $pa.Count) {$zName=$zName+"."}
                        }
                    until ($cnt -eq $pa.Count )
                       
                    Add-DnsServerPrimaryZone -Name $zName -ZoneFile "$zName.dns" 
                    Add-DnsServerResourceRecordA -ZoneName $zName -Name $pa[0] -IPv4Address $using:FWIP
                        set-NetFirewallRule -Name "FPS-ICMP4-ERQ-In" -enabled True -Profile Any # -DisplayName “Datei- und Druckerfreigabe (Echoanforderung - ICMPv4 eingehend)”
                        set-NetFirewallRule -Name  "RemoteDesktop-UserMode-In-TCP" -enabled True -Profile Any # -DisplayName "Remotedesktop - Benutzermodus (TCP eingehend)" 
                        set-NetFirewallRule -Name "RemoteDesktop-UserMode-In-UDP" -enabled True -Profile any  #-DisplayName "Remotedesktop - Benutzermodus (UDP eingehend)"     
                        Set-NetFirewallRule -Name "NETDIS-NB_Name-In-UDP" -Profile any -Enabled True
                        Set-NetFirewallRule -Name "WMI-WINMGMT-In-TCP"  -Profile any -Enabled True
                                           netsh dhcp add securitygroups
                    Restart-service dhcpserver
                    Set-ItemProperty –Path registry::HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\ServerManager\Roles\12 –Name ConfigurationState –Value 2
      
                   }
               }


write-host "Die Konfiguration des Servers $VMName für die Demo-Umgebung ist nun beendet!"
"Ausführungszeit: {0:hh}:{0:mm}:{0:ss}" -f ((get-date)-$Start)
get-date
Stop-Transcript | Out-Null


     
