﻿#Requires –Version 3

Param 
      (
          [string]$vmName =$(throw '- Der Parameter -vmName wird benoetigt!') ,
          [string]$configfile
      )


$Start=Get-Date
write-host "     ************************************************************     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     * AI2 Installation SP-PreRequisites by Thorsten Raucamp    *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     *                  Version 0.95 2014-05-15                 *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     ************************************************************     " -ForegroundColor DarkGreen
Write-Host ""
Write-Host ""
write-host "     Konfiguriere Server $VMName." -NoNewline
$Host.UI.RawUI.WindowTitle = "Configure SP-PreRequisites -- $vmName --"
if ((Get-Command Test-Admin -ErrorAction Ignore).Verb -ne "Test") {Start-Process   -WorkingDirectory $PSHOME -FilePath "powershell.exe" -ArgumentList "$PSScriptRoot\H1_globale-Funktionen.ps1" -Wait}
if (!(Test-Admin)) {
                    $powershell = [System.Diagnostics.Process]::GetCurrentProcess()
                    $psi = New-Object System.Diagnostics.ProcessStartInfo $powerShell.Path
                    $script = $MyInvocation.MyCommand.Path
                    $prm = $script
                    foreach($a in $args) {$prm += ' ' + $a}
                    $psi.Arguments = $prm
                    $psi.Verb = "runas"
                    #$psi
                    [System.Diagnostics.Process]::Start($psi) | Out-Null
                    return;
                    # Neustart des Skriptes mit Adminrechten, sollte das aktuelle Skript nicht mit Administratorrechten 
                    # gestartet worden sein. Übernommen von der c't www.ct.de/1017144
                   }
if([string]::IsNullOrEmpty($configfile)) {$configfile=(Get-ItemProperty -path HKLM:\SOFTWARE\AI2).Configfile}
if (!(Test-Path $configfile)) {Write-Host "Bitte starten Sie das Skript erneut mit dem Parameter -configfile und der entsprechenden Pfadangabe"}
set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name Configfile -Value $configfile
[xml]$config = Get-Content $configfile
$lang=Import-Csv ((Split-Path $configfile -Parent)+"\translations.csv")

# Ende Header
$logfile=$config.cfg.log +$vmName+"-PreSP.txt"
$ErrorActionPreference="SilentlyContinue"
Stop-Transcript | Out-Null
$ErrorActionPreference="Continue"

Start-Transcript -Path $logfile -Append
#################################################################################################################################################




write-host "Beginne mit der Konfiguration des Prerequisites für SharePoint"
Write-Host "am: " -NoNewline
Get-Date 
write-host "******************************************************"
$vm=$config.CFG.VMs.vm | where {$_.name -match $VMName}
$srvIP=$vm.srvip
$srvIP
#wait-forHost -computer $srvIP
$Domain=$config.CFG.Domain
# Lokaler Admin

$VMAdminPW=$vm.AdminPW
if([string]::IsNullOrEmpty($VMAdminPW)) {$VMAdminPW=$config.cfg.VMs.Default.AdminPW}
$VMAdmin = New-Object System.Management.Automation.PSCredential "Administrator", (ConvertTo-SecureString $VMAdminPW -AsPlainText -Force)
$DomainAdmin = New-Object System.Management.Automation.PSCredential ($Domain.Name + "\"+$Domain.Admin), (ConvertTo-SecureString $Domain.DomainAdminPW -AsPlainText -Force)


<#                  do
                        {Write-Host "." -ForegroundColor DarkRed -NoNewline
                         $erg=(Check-WMSCon $srvIP)
                        }
                  until ($erg -eq $true)
#>				  
wait-forPC -computer $srvIP -Cred $VMAdmin			  

[int]$osbuild= Invoke-Command  -ComputerName $srvIP -Credential $VMAdmin  -ScriptBlock  { (((Get-WmiObject Win32_OperatingSystem).version).split("."))[-1]}
<# if ( $osbuild -gt 9200 ){
        Write-Host "SharePoint 2013 kann aktuell nicht auf Server 2012 R2 installiert werden. Sie sollten das Skript abbrechen" -ForegroundColor Red
        pause
    }
#>
<#
Invoke-Command  -ComputerName $srvIP -Credential $VMAdmin  -ScriptBlock {
                     set-NetConnectionProfile -NetworkCategory Private 
                     Get-NetConnectionProfile -NetworkCategory Private
                    }

 $ErrorActionPreference="SilentlyContinue"

sleep 30
Write-Host "Warte auf IIS"-NoNewline -ForegroundColor Cyan
Get-Date
$statusOK=$false

 do
{ sleep 10
  Write-Host ">" -NoNewline -ForegroundColor Yellow
  $erg=  Invoke-Command  -ComputerName $srvIP -Credential $VMAdmin  -ScriptBlock {
                     Get-Service -Name "iisAdmin"}
   if($erg.Status -eq "running"){$statusOK=$true}                 
}
until ((($statusOK) ))
sleep 10
Write-Host "Setze Installation fort. "-NoNewline -ForegroundColor Cyan
#>

Get-Date
$ErrorActionPreference="Continue"

# do
#       { sleep 10
#         Write-Host "." -NoNewline -ForegroundColor Magenta
#         $Erg = (Get-WmiObject -Query "Select * from Win32_service where Name='IISADMIN'" -ComputerName $srvIP -Credential $VMAdmin).state
#       }
# until ($erg -eq "Running") 



$PreScript=  {
                   #dir $using:instDir
                   Write-host "Beginne mit der Installation der Prerequisite-Dateien für Sharepoint 2013:   " -ForegroundColor Green -NoNewline
                   get-date
                   do
                   { sleep 10   
                     $status= ((get-service | where {$_.name -eq "IISADMIN"}).Status)
                   }
                   until ($status -eq "Running")
                   Write-Host "IISAdmin ist gestartet" -ForegroundColor Green
                   #get-service | where {$_.status -eq "Running"} | tl

                   $instDir="C:\install\sp2013\sp\2013\SharePoint"
                   Start-Process -WAIT -PassThru "$instDir\PrerequisiteInstaller.exe" -ArgumentList "/unattended `
                                                                                             /SQLNCli:`"$instDir\PrerequisiteInstallerFiles\sqlncli.msi`" `
                                                                                             /PowerShell:`"$instDir\PrerequisiteInstallerFiles\Windows6.1-KB2506143-x64.msu`" `
                                                                                             /NETFX:`"$instDir\PrerequisiteInstallerFiles\dotNetFx45_Full_x86_x64.exe`" `
                                                                                             /IDFX:`"$instDir\PrerequisiteInstallerFiles\Windows6.1-KB974405-x64.msu`" `
                                                                                             /IDFX11:`"$instDir\PrerequisiteInstallerFiles\MicrosoftIdentityExtensions-64.msi`" `
                                                                                             /Sync:`"$instDir\PrerequisiteInstallerFiles\Synchronization.msi`" `
                                                                                             /AppFabric:`"$instDir\PrerequisiteInstallerFiles\WindowsServerAppFabricSetup_x64.exe`" `
                                                                                             /KB2671763:`"$instDir\PrerequisiteInstallerFiles\AppFabric1.1-RTM-KB2671763-x64-ENU.exe`" `
                                                                                             /MSIPCClient:`"$instDir\PrerequisiteInstallerFiles\setup_msipc_x64.msi`" `
                                                                                             /WCFDataServices:`"$instDir\PrerequisiteInstallerFiles\WcfDataServices.exe`""
                 sleep 1 
                 Start-Process -WAIT  -FilePath "C:\Windows\System32\wusa.exe" -ArgumentList "`"$instDir\PrerequisiteInstallerFiles\Windows8-RT-KB2765317-x64.msu`" /quiet /norestart" 
                 Start-Process -WAIT  -FilePath "$instDir\PrerequisiteInstallerFiles\WcfDataServices5.6.exe " -ArgumentList "/quiet /norestart"
                 # $instDir= "c:\install\SP\2013\SharePoint"
                 Start-Process -WAIT -PassThru -FilePath "$instDir\PrerequisiteInstallerFiles\AppFabric1.1-RTM-KB2671763-x64-ENU.exe" -ArgumentList "/quiet /norestart" 
                 # Liste der installierten Programme ausgeben, gefunden auf http://blog.blackseals.net/2011/12/07/liste-der-installierten-programme-per-powershell-auslesen/
                 Write-Host "Installierte Software:"
                 Get-ItemProperty HKLM:\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\* | sort -Property DisplayName | Format-Table DisplayName, Publisher, DisplayVersion
                 set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name PreReqSP -Value $true
               
}

Get-Date
#Write-Host "Installiere Prerequisites für SharePoint..." -NoNewline -ForegroundColor Cyan
 do
 {  Invoke-Command  -ComputerName $srvIP -Credential $VMAdmin  -ScriptBlock $PreScript
    $erg= Invoke-Command  -ComputerName $srvIP -Credential $VMAdmin  -ScriptBlock {Get-ItemProperty HKLM:\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\* | sort -Property DisplayName | Format-Table DisplayName, Publisher, DisplayVersion}
    Write-Host "."-ForegroundColor Cyan -NoNewline

 }
 until ($erg.count -gt 4)
 Write-Host "OK!"-ForegroundColor Green
 Get-Date

if (!([string]::IsNullOrEmpty($config.cfg.Rollen.sp.require))){
       if ($config.cfg.Rollen.sql.require -match "DC") {
            $preRolle="DC"
            $preSrvIP=($config.CFG.VMs.vm | where {$_.Rollen -match $preRolle}).srvip
            Write-Host "Warte auf  $preRolle..." -NoNewline -ForegroundColor Cyan
            do{write-host "." -NoNewLine -ForegroundColor "Red"}
            until (Check-Rolle -Rolle $preRolle -IP $preSrvIP)
            Write-Host "Die Rolle $preRolle steht zur Verfügung." -ForegroundColor Green -NoNewline
            Get-Date
         }
}
 wait-forPC -computer ( ($config.CFG.VMs.vm | where {$_.Rollen -match "DC"}).srvip  ) -Cred $DomainAdmin
 check-DomainMember  $srvIP
 $SVC=import-Csv   ((split-path -Parent $configfile) + "\svc.csv")
 $Admin=$svc | where-object {$_.Diensttyp -eq "SP_Admin"}   
 $SP_Farm=$svc | where-object {$_.Diensttyp -eq "SP_Farm"}
 Invoke-Command  -ComputerName $srvIP -Credential $DomainAdmin  -ScriptBlock {
        $LID=(((Get-WmiObject Win32_OperatingSystem))).OSLanguage
        $v = ($using:lang | where {$_.lid -eq $lid})
        $admins=$v.Administrators
        If ([string]::IsNullOrEmpty($v.language)){$v=$lang[0]}
        $v.language
        $FarmADM= "WinNT://"+$using:config.cfg.Domain.NetBIOSName+"/"+$using:Admin.sam
        $farm="WinNT://"+$using:config.cfg.Domain.NetBIOSName+"/"+$using:SP_Farm.sam
        ([ADSI]"WinNT://$env:COMPUTERNAME/$admins,group").add($FarmADM)
        Write-Host "$FarmADM wurde erfolgreich in die Gruppe der $admins aufgenommen!"
        ([ADSI]"WinNT://$env:COMPUTERNAME/$admins,group").add($farm)   
        Write-Host "$farm wurde erfolgreich in die Gruppe der $admins aufgenommen!"
        #$Adm="WinNT://"+$using:config.cfg.Domain.NetBIOSName+"/"+$admin.sam
        #([ADSI]"WinNT://$env:COMPUTERNAME/Administratoren,group").add($adm)  
        set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name "preSP" -Value $true
      }






write-host "Die Vorarbeiten für SharePoint sind nun beendet"
"Ausführungszeit: {0:hh}:{0:mm}:{0:ss}" -f ((get-date)-$Start)
Stop-Transcript | Out-Null
#pause