﻿$Start=Get-Date
write-host "********************************************"
write-host "*  AI2 Configure-SF  by Thorsten Raucamp   *"
write-host "*        Version 0.94 2014-01-20          *"
write-host "********************************************"
Write-Host ""
Write-Host ""
write-host "Erstelle Sample Firewall (Testnetz): " -NoNewline
Get-Date
$Host.UI.RawUI.WindowTitle = " Konfiguriere Firewall für das Testnetz -- $vmName --"
if (!(Test-Admin)) {
                    $powershell = [System.Diagnostics.Process]::GetCurrentProcess()
                    $psi = New-Object System.Diagnostics.ProcessStartInfo $powerShell.Path
                    $script = $MyInvocation.MyCommand.Path
                    $prm = $script
                    foreach($a in $args) {$prm += ' ' + $a}
                    $psi.Arguments = $prm
                    $psi.Verb = "runas"
                    #$psi
                    [System.Diagnostics.Process]::Start($psi) | Out-Null
                    return;
                    # Neustart des Skriptes mit Adminrechten, sollte das aktuelle Skript nicht mit Administratorrechten 
                    # gestartet worden sein. Übernommen von der c't www.ct.de/1017144
                   }
if([string]::IsNullOrEmpty($configfile)) {$configfile=(Get-ItemProperty -path HKLM:\SOFTWARE\AI2).Configfile}
if (!(Test-Path $configfile)) {Write-Host "Bitte starten Sie das Skript erneut mit dem Parameter -configfile und der entsprechenden Pfadangabe"}

[xml]$config = Get-Content $configfile

# Ende Header

$config.cfg.rollen.SF
$SF =$config.CFG.VMs.vm | where {$_.Rollen -match "SF"}
$SFPath=$SF.Path
if([string]::IsNullOrEmpty($SFPath)){$SFPath=$config.cfg.VMs.Default.Path}
$vmName = $SF.Name

$logfile=$config.cfg.log +$vmName+"SF.txt"
$ErrorActionPreference="SilentlyContinue"
Stop-Transcript | Out-Null
$ErrorActionPreference="Continue"

Start-Transcript -Path $logfile -Append
#################################################################################################################################################


#################################################################################################################################################


$vhd=$SFPath+"\"+$config.CFG.HOST.vmPrefix+$SF.Name+"\Virtual Hard Disks\"+$SF.additionalDisks.Disk.VHDName
$Host.UI.RawUI.WindowTitle = "Configure-VM -- $vmName -- AI2 --"

function set-cgswerte
{ Param(
            [string]$FileToChange
            
        )

    If (!(Test-Path $FileToChange)) 
            {Write-Host "Die angegebene Datei $FileToChange konnte nicht gefunden werden." -ForegroundColor Red
            break}
    #$fi= Get-Content -Path "f:\collax-ai.conf"
    $fi= [IO.File]::ReadAllText($FileToChange)
    
    $SFs=$config.CFG.rollen.SF
    $SFIP= $SF.SRVIP
  
    $fi=$fi.replace( "#SRVIP#", $SFIP)
    $fi=$fi.replace( "#NetMask#", $SFs.SubNetMask)
    $fi=$fi.replace( "#FQDN#", $vmname + "." + $SFs.DomainName)
    $fi=$fi.replace( "#IPGW#", $SFIP)
    $fi=$fi.replace( "#NETZ#", $SFs.NetID)
    $fi=$fi.replace( "#SUBNET#", $SFs.SubNetMask)
    $fi=$fi.replace( "#Lang#", $SFs.Lang)
    $fi=$fi.replace( "#continent#", $SFs.Continent)
    $fi=$fi.replace( "#location#", $SFs.Region)
    $fi=$fi.replace("#DOMAINNAME#",  $SFs.DomainName)
    $fi=$fi.replace("#CertPW#", $SFs.CertPW)
    $fi=$fi.replace("#ADMMail#", $SFs.CollaxAdminMail)
    $fi=$fi.replace("#CAdmPW#", $SFs.CollaxAdminPW)
    $fi=$fi.replace("#CRootPW#",  $SFs.CollaxRootPW)
    $fi=$fi.replace("#SRV#", $vmname)
    $fi=$fi.replace("#DMZNetwork#", $SFs.DMZNetwork) 
    $fi=$fi.replace("#DMZNetMask#", $SFs.DMZNetMask) 
    $fi=$fi.replace("#DMZNetzIPFW#", $SFs.DMZNetzIPFW)
    $fi=$fi.replace("#DMZROUTERIP#", $SFs.DMZROUTERIP)
    $fi=$fi.replace( "#FIRST#", $SFs.FIRST)
    $fi=$fi.replace( "#LAST#", $SFs.LAST)
    #($SFs.NetID).substring(0,(($SFs.NetID).Length-1))
      $fi=$fi.replace("#FIRST#", $vmname)
        $fi=$fi.replace("#LAST#", $vmname)

    Out-File -FilePath "$FileToChange" -InputObject $fi -Force -Encoding ascii
}


#$Destdrive=$config.CFG.HOST.tmpLW
$destdrive = (((Get-ChildItem function:[f-z]: -Name | Where-Object { -not (Test-Path -Path $_)}) | where {$_ -ne $x})[-5]).remove(1,1)
#[string]$dest = ((Get-Partition (Get-Diskimage -ImagePath $vhd).Number | where {$_.size -gt (512)}).DriveLetter)+ ":\"
$a=(Get-Disk).Number
    Mount-DiskImage -ImagePath $vhd
$b=(Get-Disk).Number
$c= Compare-Object -ReferenceObject $a -DifferenceObject $b -PassThru
initialize-disk -number $c -partitionStyle mbr 
New-Partition -DiskNumber $c -UseMaximumSize -DriveLetter $Destdrive
Format-Volume -DriveLetter $Destdrive -FileSystem "FAT" -NewFileSystemLabel "Config" -confirm:$false
$pth=  (split-path -Parent $configfile)

$dest=$Destdrive+":\"
if (!(Test-Path $dest)){
        # Auf grund eines sporadisch auftrendenden Problems, dass zwar das Laufwerk vorhanden ist, Powershell aber nicht darauf zugreifen kann, wird der Vorgang wiederholt
        Remove-Partition -DiskNumber $c -PartitionNumber 1 -Confirm $false 
        $destdrive = (((Get-ChildItem function:[f-z]: -Name | Where-Object { -not (Test-Path -Path $_)}) | where {$_ -ne $x})[-6]).remove(1,1)
        New-Partition -DiskNumber $c -UseMaximumSize -DriveLetter $Destdrive
        Format-Volume -DriveLetter $Destdrive -FileSystem "FAT" -NewFileSystemLabel "Config" -confirm:$false
        $dest=$Destdrive+":\"
        write-Host "Alternativer Laufwerksbuchstabe $dest"
        Test-Path $dest}

 If (Test-Path($pth+'\SF'))
     {
      robocopy.exe "$pth\SF" ($Dest) /np /ns /nc /ndl /np /nfl /e  /is

      Remove-ReadOnlyAttribute -Path $dest
     }
$SFIP= $SF.srvip

$inis=Get-ChildItem ($dest+"*.*" ) -Recurse
$files=$inis.VersionInfo.fileName

foreach($file in $files)
{ set-cgswerte $file }

Dismount-DiskImage -ImagePath $vhd




$vmx= $config.CFG.HOST.vmPrefix+$sf.Name 
$nics=$sf.AdditionalNICs.AdditionalNIC 
foreach ($nic in $nics)
            {
             $Adapter=$nic.Name
             $switchName=$nic.SwitchName
             Write-Host $Adapter , $switchName
             $NetworkAdapter= Get-VMNetworkAdapter -VMName $vmx | where {$_.Switchname -eq $switchName}
             Disconnect-VMNetworkAdapter -VMNetworkAdapter $NetworkAdapter 
             Get-VMNetworkAdapter -VMName $vmx
             Write-Host "---"
             sleep 10
             connect-VMNetworkAdapter -VMNetworkAdapter $NetworkAdapter -SwitchName $switchName
             Get-VMNetworkAdapter -VMName $vmx
            }





#start-vm ($config.cfg.host.VMPrefix + $mail.Name)

write-host "*************************************"
Write-Host ""
write-host "Bitte Starten Sie die VM $vmName manuell und wählen Sie den Menüpunkt  " -ForegroundColor Yellow
write-host '"Collax Security Gateway Installation" aus!' -ForegroundColor Yellow
write-host '"Die weitere Installation wird dann automatisch fortgesetzt!' -ForegroundColor Yellow


Get-Date 

write-host "Die Konfiguration der Firewall für das Testnetz ist nun beendet!"
"Ausführungszeit: {0:hh}:{0:mm}:{0:ss}" -f ((get-date)-$Start)
Stop-Transcript | Out-Null
#pause
