﻿#Requires –Version 3

Param 
      (
          [string]$vmName =$(throw '- Der Parameter -vmName wird benoetigt!') ,
          [string]$configfile
      )


$Start=Get-Date
write-host "     ************************************************************     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     *  AI2 Installation Rolle SharePoint  by Thorsten Raucamp  *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     *                  Version 0.95 2014-05-15                 *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     ************************************************************     " -ForegroundColor DarkGreen
Write-Host ""
Write-Host ""
Write-Host ""
write-host "Erstelle VMs am: " -NoNewline
Get-Date
$Host.UI.RawUI.WindowTitle = "Configure SharePoint -- $vmName --"
if (!(Test-Admin)) {
                    $powershell = [System.Diagnostics.Process]::GetCurrentProcess()
                    $psi = New-Object System.Diagnostics.ProcessStartInfo $powerShell.Path
                    $script = $MyInvocation.MyCommand.Path
                    $prm = $script
                    foreach($a in $args) {$prm += ' ' + $a}
                    $psi.Arguments = $prm
                    $psi.Verb = "runas"
                    #$psi
                    [System.Diagnostics.Process]::Start($psi) | Out-Null
                    return;
                    # Neustart des Skriptes mit Adminrechten, sollte das aktuelle Skript nicht mit Administratorrechten 
                    # gestartet worden sein. Übernommen von der c't www.ct.de/1017144
                   }
if([string]::IsNullOrEmpty($configfile)) {$configfile=(Get-ItemProperty -path HKLM:\SOFTWARE\AI2).Configfile}
if (!(Test-Path $configfile)) {Write-Host "Bitte starten Sie das Skript erneut mit dem Parameter -configfile und der entsprechenden Pfadangabe"}
set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name Configfile -Value $configfile
[xml]$config = Get-Content $configfile
$lang=Import-Csv ((Split-Path $configfile -Parent)+"\translations.csv")

# Ende Header
$logfile=$config.cfg.log +$vmName+"-SP.txt"
$ErrorActionPreference="SilentlyContinue"
Stop-Transcript | Out-Null
$ErrorActionPreference="Continue"

Start-Transcript -Path $logfile -Append
#################################################################################################################################################

Set-ExecutionPolicy bypass -force
# Ende Header
$vm=$config.CFG.VMs.vm | where {$_.name -match $VMName}
$srvIP=$vm.srvip

#überprüfe, ob DC schon fertig ist.
if (!([string]::IsNullOrEmpty($config.cfg.Rollen.sp.require))){
    $preRollen=($config.cfg.Rollen.sp.require).Split(",")
    foreach ($preRolle in $preRollen)
            { $preSrvIP=($config.CFG.VMs.vm | where {$_.Rollen -match $preRolle}).srvip
              if ($preRolle -eq "SQL"){$preSrvIP=($config.CFG.VMs.vm | where {$_.name -match $config.cfg.Rollen.sp.DBServer}).srvip}
              do{write-host "." -NoNewLine -ForegroundColor "Red"}
              until (Check-Rolle -Rolle $preRolle -IP $preSrvIP)
              Write-Host "Die Rolle $preRolle steht zur Verfügung." -ForegroundColor Green
            }
            
    }
    
if (!(Check-Rolle -Rolle "preSP" -IP $srvIP))
           {
            $xecute="$skpath\SUB\Pre_SP.ps1 -vmName " +$vmName
            Start-Process   -WorkingDirectory $PSHOME -FilePath "powershell.exe" -ArgumentList "$xecute" -RedirectStandardError $logfile  -Wait
           }
else {Write-Host "SharePoint Prerequisites sind installiert." -ForegroundColor Green}
       
 
    


$Domain=$config.CFG.Domain
$DomainAdmin = New-Object System.Management.Automation.PSCredential ($Domain.Name + "\"+$Domain.Admin), (ConvertTo-SecureString $Domain.DomainAdminPW -AsPlainText -Force)


$SPsrv=$VMName
$sqlsrv=$config.CFG.rollen.sp.DBServer
$inputFile=((split-path -Parent $configfile) + "\autoSpInstallerInput.xml")
$SVC=import-Csv   ((split-path -Parent $configfile) + "\svc.csv")

[xml]$xmlinput = (Get-Content $inputFile) -replace ("localhost", $SPsrv)
$domain=$config.cfg.Domain.NetBIOSName
$Admin=$svc | where-object {$_.Diensttyp -eq "SP_Admin"}

                  do
                        {Write-Host "." -ForegroundColor DarkRed -NoNewline
                        }
                  until ((Check-WMSCon $srvIP) -eq $true)

      
write-host "Starte mit SP-Installation"
$SPAdmin = New-Object System.Management.Automation.PSCredential ($config.CFG.Domain.Name + "\"+$Admin.sam), (ConvertTo-SecureString $Admin.Password -AsPlainText -Force)
if(!(Check-Rolle -Rolle "AutoSPInstaller" -IP $srvIP)){
            Invoke-Command  -ComputerName $srvIP -Credential $SPAdmin  -ScriptBlock {
                            Set-ExecutionPolicy bypass -force
                            c:\install\sp\autospinstaller\AutoSPInstallerMain.ps1 -inputfile c:\install\sp\autospinstaller\AutoSPInstallerInput.xml | Echo "Waiting"
                            set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name "AutoSPInstaller" -Value $true 
                        }  -Authentication Credssp
            write-host "Die Basis-Installation des SharePoint Servers ist nun beendet"
            "Ausführungszeit: {0:hh}:{0:mm}:{0:ss}" -f ((get-date)-$Start)
            
    }
$spready=$false
Write-Host "Warte auf das SharePoint-Powershell-Snapin..." -ForegroundColor Cyan -NoNewline
do
{$ErrorActionPreference="silentlyContinue"
  $spready=   Invoke-Command  -ComputerName $srvIP -Credential $SPAdmin  -ScriptBlock {
                    $result=$false
                     Add-PSSnapin -Name Microsoft.SharePoint.PowerShell
                    $snaps= Get-PSSnapin -Name Microsoft.SharePoint.PowerShell

                    if ( $snaps.Name -match "SharePoint"){$result=$true}
                    else { Write-Host "." -ForegroundColor DarkRed -NoNewline
                           sleep 10
                         }
                    $result
                    }


    }
until ($spready -eq $true)  
$ErrorActionPreference="Continue"
Write-Host "OK!" -ForegroundColor Green
Get-Date

####################################################################################################################################################################################
$SP_Farm=$svc | where-object {$_.Diensttyp -eq "SP_Farm"}
$SPFarmAdmin =New-Object System.Management.Automation.PSCredential ($config.CFG.Domain.Name + "\"+$SP_Farm.sam), (ConvertTo-SecureString $SP_Farm.Password -AsPlainText -Force)
# Erstellen der Abteilungs-Websites         
Invoke-Command  -ComputerName $srvIP -Credential $SPFarmAdmin  -ScriptBlock {
                Add-PSSnapin -Name Microsoft.SharePoint.PowerShell
                #Get-SPWebTemplate
                $template = Get-SPWebTemplate $using:config.CFG.rollen.sp.PortalTemplate
 
                $template2 = Get-SPWebTemplate $using:config.CFG.rollen.sp.PortalTemplate2
                $template3 = Get-SPWebTemplate $using:config.CFG.rollen.sp.PortalTemplateIntern

                Foreach($Abteilung in ($using:config.CFG.Domain.Abteilungen).Split(',')){
                    $website="http://"+($using:config.cfg.rollen.sp.SRV)+"/$Abteilung"
                    New-SPWeb -Url $website  -Template $template2 -name "$Abteilung" -Description "Öffentliche Website der Abteilung: $Abteilung" -AddToQuickLaunch -UseParentTopNav -AddToTopNav 
                    New-SPWeb -Url "$website/intern"  -Template $template3 -name "Intern" -Description "$Abteilung INTERN"  -AddToQuickLaunch -UseParentTopNav -AddToTopNav 
                    }
                write-host "Abteilungswebsites wurden hinzugefuegt."
                #Demo fuer die verschiedenen Templates
                if(!($using:config.cfg.rollen.sp.Demosite -eq "false")){
                    $spwt=get-spwebtemplate | where {$_.hidden -eq $false} | where {$_.name -notmatch "SRCH"}
                    $SRv=  ($using:config.cfg.rollen.sp.SRV)
                    New-SPWeb -Url "http://$srv/demo"  -Template $template -name "Demo " -Description "Demowebseite für Templates "  -AddToQuickLaunch -UseParentTopNav -AddToTopNav
                       
                    foreach ($tmpl in $spwt)
                           {$tname=$tmpl.title + $tmpl.CompatibilityLevel
                            $template=$tmpl.name
                            $des=$tmpl.desciption
                            New-SPWeb -Url "http://$srv/demo/$tname"  -Template $template -name $tname -Description "Demoseite für Template: $tname -->$template<-- $des "  -AddToQuickLaunch -UseParentTopNav -AddToTopNav
                            }
                     write-host "Demo-Websites wurden hinzugefuegt."
                     set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name "SP_Web" -Value $true 
                     }
            }  -Authentication Credssp



If (!([string]::IsNullOrEmpty($config.cfg.rollen.sp.Alias))){
        # Hinzufügen des Aliases für die SharePoint-Websammlung "Portal"
        # Inspiriert durch http://gallery.technet.microsoft.com/sharepoint/The-final-guide-to-551bd75b
        $SPAlias=$config.cfg.rollen.sp.Alias
        $SPAliasFQDN=$SPAlias+"."+$config.cfg.domain.name
        Import-Module add-DNSEintrag
        add-DNSEintrag -Name $SPAlias -IP $srvIP

                  do
                        {Write-Host "." -ForegroundColor DarkRed -NoNewline
                        }
                  until ((Check-WMSCon $srvIP) -eq $true)


        Invoke-Command  -ComputerName $srvIP -Credential $SPFarmAdmin  -ScriptBlock {
                        Add-PSSnapin Microsoft.sharepoint.powershell 
                        $url1=$using:SPAlias
                        $url2=$using:SPAliasFQDN
                        $SPURL=$using:config.CFG.rollen.sp.srv
                        $Webapplication="Portal"
                        New-SPAlternateURL –WebApplication "http://$SPURL" –Url "http://$url1" –Zone intranet 
                        New-SPAlternateURL –WebApplication "http://$SPURL" –Url "http://$url2" –Zone custom 
                        Import-Module WebAdministration 
                        Set-WebBinding -Name 'Default Web Site' -BindingInformation "*:80:" -PropertyName Port -Value 88
                        New-WebBinding –Name $Webapplication –Protocol http –Port 80 –IPAddress * -HostHeader $url1
                        New-WebBinding –Name $Webapplication –Protocol http –Port 80 –IPAddress * -HostHeader $url2
                        start-website -Name $Webapplication


                       }  -Authentication Credssp
        }


                  do
                        {Write-Host "." -ForegroundColor DarkRed -NoNewline
                        }
                  until ((Check-WMSCon $srvIP) -eq $true)


 write-host "Starte nun mit Berechtigungen"
                $LID=(((Get-WmiObject Win32_OperatingSystem))).OSLanguage
                $v = ($lang | where {$_.lid -eq $lid})
                If ([string]::IsNullOrEmpty($v.language)){$v=$lang[0]}
                $v.language
                
 add-ADGruppe -GruppenName "SP_Admins" -Displayname "SharePoint-Administratorengruppe" -Gruppenmitglieder  $SP_Farm.sam


#Berechtigungen setzen
Invoke-Command  -ComputerName $srvIP -Credential $SPFarmAdmin  -ScriptBlock {
                $LID=(((Get-WmiObject Win32_OperatingSystem))).OSLanguage
                $v = ($using:lang | where {$_.lid -eq $lid})
                If ([string]::IsNullOrEmpty($v.language)){$v=$lang[0]}
                $v.language

                 $LIDSP=(((Get-WmiObject Win32_OperatingSystem))).OSLanguage
                $vSP = ($using:lang | where {$_.lid -eq $lidSP})
                If ([string]::IsNullOrEmpty($vSP.language)){$vSP=$lang[0]}
                $vSP.language

                $admins=$v.Administrators
                $authUser=$v.authUser
                $Read=$vSP.read
                $Contribute=$vSP.Contribute
                $FullControl=$vSP.FullControl
                $DomainAdmins=$v.DomainAdmins

          # Inspiriert durch http://blog.pointbeyond.com/2011/06/03/powershell-to-create-sharepoint-groups/
            $SPsrv=$using:config.CFG.rollen.sp.srv
          # Berechtigungen fuer alle lesend auf der obersten Ebene erstellen
            Add-PSSnapin -Name Microsoft.SharePoint.PowerShell
            $website="http://"+$SPsrv
            $web = Get-SPWeb $website
          # Reader Group
            $web.SiteGroups.Add('Leser', $web.Site.Owner, $web.Site.Owner, 'Mitglieder dieser Gruppe haben lesenden Zugriff')
            $ReaderGroup = $web.SiteGroups["Leser"]
            $ReaderGroup.AllowMembersEditMembership = $true
            $ReaderGroup.Update()
            $user = $web.Site.RootWeb.EnsureUser($authUser)
            $ReaderGroup.AddUser($user)
            $ReaderGroupAssignment = new-object Microsoft.SharePoint.SPRoleAssignment($ReaderGroup)
            $ReaderGroupRoleDefinition = $web.Site.RootWeb.RoleDefinitions[$Read]
            $ReaderGroupAssignment.RoleDefinitionBindings.Add($ReaderGroupRoleDefinition)
            $web.RoleAssignments.Add($ReaderGroupAssignment)
            $web.Update()
            write-host "Starte individuelle Berechtigungen"
          # Gruppen und Berechtigungen fuer alle Abteilungs-Websites erstellen
            Add-PSSnapin -Name Microsoft.SharePoint.PowerShell
            Foreach($Abteilung in ($using:config.CFG.Domain.Abteilungen).Split(',')){
                    $website="http://"+$SPsrv+"/$Abteilung/intern"
                    $web = Get-SPWeb $website
                    Write-Host "http://$SPsrv/$Abteilung/intern"
                    if ($web.HasUniquePerm -eq $false) {$web.BreakRoleInheritance($true, $true) }
                    # Unnoetige Berechtigungen entfernen
                    for ($i = $web.RoleAssignments.Count - 1; $i -ge 0; $i--)
                            {$i
                                $web.RoleAssignments
                            $web.RoleAssignments.Remove($i)        }                    
                    #Gruppe Mitglieder erstellen
                    $web.SiteGroups.Add("$Abteilung Mitglieder", $web.Site.Owner, $web.Site.Owner, "Mitglieder dieser Gruppe dürfen Beiträge erstellen auf der internen Seite von $Abteilung")
                    $MemberGroup = $web.SiteGroups["$Abteilung Mitglieder"]
                    $MemberGroup.AllowMembersEditMembership = $true
                    $memberGroup.Update()
                    #Gruppe Besitzer erstellen
                    $web.SiteGroups.Add("$Abteilung Besitzer", $web.Site.Owner, $web.Site.Owner, "Mitglieder dieser Gruppe haben volle Zugrifsrechte auf der internen Seite von $Abteilung")
                    $BesitzerGroup = $web.SiteGroups["$Abteilung Besitzer"]
                    $BesitzerGroup.AllowMembersEditMembership = $true
                    $BesitzerGroup.update()
                    #Gruppe Leser erstellen
                    $web.SiteGroups.Add("$Abteilung Leser", $web.Site.Owner, $web.Site.Owner, "Mitglieder dieser Gruppe haben nur lesenden Zugriffauf der internen Seite von $Abteilung")
                    $ReaderGroup = $web.SiteGroups["$Abteilung Leser"]
                    $ReaderGroup.AllowMembersEditMembership = $true
                    $ReaderGroup.Update()
                    $memberGroup.Update()
                    #Benutzer hinzufuegen
                    $user1 = $web.Site.RootWeb.EnsureUser(($using:config.cfg.Domain.NetBIOSName+"\SP_Admins"))
                    $BesitzerGroup.AddUser($user1)
                    $user2 = $web.Site.RootWeb.EnsureUser(($using:config.cfg.Domain.NetBIOSName+"\$Abteilung"))
                    $MemberGroup.AddUser($user2)
                    #Definitionen erstellen
                    $BesitzerGroupAssignment = new-object Microsoft.SharePoint.SPRoleAssignment($BesitzerGroup)
                    $MemberGroupAssignment = new-object Microsoft.SharePoint.SPRoleAssignment($MemberGroup)
                    $ReaderGroupAssignment = new-object Microsoft.SharePoint.SPRoleAssignment($ReaderGroup)
                    $ReaderGroupRoleDefinition = $web.Site.RootWeb.RoleDefinitions[$Read]
                    $MemberGroupRoleDefinition = $web.Site.RootWeb.RoleDefinitions[$Contribute]
                    $BesitzerGroupRoleDefinition = $web.Site.RootWeb.RoleDefinitions[$FullControl]       
                    $BesitzerGroupAssignment.RoleDefinitionBindings.Add($BesitzerGroupRoleDefinition)
                    $MemberGroupAssignment.RoleDefinitionBindings.Add($MemberGroupRoleDefinition)
                    $ReaderGroupAssignment.RoleDefinitionBindings.Add($ReaderGroupRoleDefinition)
                    $web.RoleAssignments.Add($BesitzerGroupAssignment)
                    $web.RoleAssignments.Add($MemberGroupAssignment)
                    $web.RoleAssignments.Add($ReaderGroupAssignment)
                    #Anwenden
                    $web.Update()
                    set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name "SP_Rights" -Value $true 
            }
}  -Authentication Credssp

                  do
                        {Write-Host "." -ForegroundColor DarkRed -NoNewline
                        }
                  until ((Check-WMSCon $srvIP) -eq $true)


Invoke-Command  -ComputerName $srvIP -Credential $SPFarmAdmin  -ScriptBlock {
                 set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name "SP" -Value $true 
              }  -Authentication Credssp

   write-host "Die Konfiguration des SharePoint Servers ist nun beendet."
"Ausführungszeit: {0:hh}:{0:mm}:{0:ss}" -f ((get-date)-$Start)
Stop-Transcript | Out-Null
#pause


