﻿#Requires –Version 3

Param 
      (
          [string]$vmName =$(throw '- Der Parameter -vmName wird benoetigt!') ,
          [string]$configfile
       )


$Start=Get-Date
write-host "     ************************************************************     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     *  AI2 Installation Rolle SQL-Server  by Thorsten Raucamp  *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     *                  Version 0.95 2014-04-04                 *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     ************************************************************     " -ForegroundColor DarkGreen
Write-Host ""
Write-Host ""
Write-Host ""
write-host "Konfiguriere SQL-Server auf $VMName am: " -NoNewline
Get-Date
$Host.UI.RawUI.WindowTitle = "Configure SQL-Server -- $vmName --"
if (!(Test-Admin)) {
                    $powershell = [System.Diagnostics.Process]::GetCurrentProcess()
                    $psi = New-Object System.Diagnostics.ProcessStartInfo $powerShell.Path
                    $script = $MyInvocation.MyCommand.Path
                    $prm = $script
                    foreach($a in $args) {$prm += ' ' + $a}
                    $psi.Arguments = $prm
                    $psi.Verb = "runas"
                    #$psi
                    [System.Diagnostics.Process]::Start($psi) | Out-Null
                    return;
                    # Neustart des Skriptes mit Adminrechten, sollte das aktuelle Skript nicht mit Administratorrechten 
                    # gestartet worden sein. Übernommen von der c't www.ct.de/1017144
                   }
if([string]::IsNullOrEmpty($configfile)) {$configfile=(Get-ItemProperty -path HKLM:\SOFTWARE\ai2).Configfile}
if (!(Test-Path $configfile)) {Write-Host "Bitte starten Sie das Skript erneut mit dem Parameter -configfile und der entsprechenden Pfadangabe"}
set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name Configfile -Value $configfile
[xml]$config = Get-Content $configfile
# Ende Header
$logfile=$config.cfg.log +$vmName+"-SQL.txt"
$ErrorActionPreference="SilentlyContinue"
Stop-Transcript | Out-Null
$ErrorActionPreference="Continue"

Start-Transcript -Path $logfile -Append
#################################################################################################################################################

# Ende Header



 function ConvertTo-ScriptBlock {
    param(
            [parameter(ValueFromPipeline=$true,Position=0)]
                [string]
                $string
          )
        #gefunden auf http://get-powershell.com/post/2008/12/15/ConvertTo-ScriptBlock.aspx Author: Andy Schneider
        $sb = [scriptblock]::Create($string)
        return $sb
}

#überprüfe, ob DC schon fertig ist.
if (!([string]::IsNullOrEmpty($config.cfg.Rollen.sql.require))){
    $preRolle=$config.cfg.Rollen.sql.require
    $preSrvIP=($config.CFG.VMs.vm | where {$_.Rollen -match $preRolle}).srvip
    
    do{write-host "." -NoNewLine -ForegroundColor "Red"}
    until (Check-Rolle -Rolle $preRolle -IP $preSrvIP)
    Write-Host "Die Rolle $preRolle steht zur Verfügung. Setzte das Skript SQL fort." -ForegroundColor Green
   }


$Domain=$config.CFG.Domain 
$DomainAdmin = New-Object System.Management.Automation.PSCredential ($Domain.Name + "\"+$Domain.Admin), (ConvertTo-SecureString $Domain.AdminPW -AsPlainText -Force)
$SVC=import-Csv   ($config.cfg.Domain.Servicekonten)
 $srv =$config.CFG.VMs.vm | where {$_.name -match $VMName}
 $srvIP=$srv.srvip
write-host "Überprüfe die Voraussetzungen für den Server $srvIP ..."

        wait-forHost ($config.CFG.VMs.vm | where {$_.Rollen -match "DC"}).srvip

        Write-Host "Überprüfe, ob $srvIP Mitglied in der Domäne ist" -BackgroundColor DarkGreen -ForegroundColor Yellow
        check-DomainMember  $srvIP
        #CredSSP enablen
        Invoke-Command  -ComputerName $srvIP -Credential $DomainAdmin  -Scriptblock {Enable-WSManCredSSP -Role Server -Force}
        Write-Host "OK! " -ForegroundColor Green
        

Invoke-Command  -ComputerName $srvIP -Credential $DomainAdmin  -Scriptblock {
    $srvIP=$using:srvIP     
    $DomainAdmin=$using:DomainAdmin            
    if (!(Get-WindowsFeature -Name "Net-framework-core").Installed)  { 
            Install-WindowsFeature Net-Framework-Core -IncludeAllSubFeature -source W:\sources\sxs -ComputerName $srvIP -Credential $DomainAdmin
            Add-WindowsFeature NET-WCF-HTTP-Activation45,NET-WCF-TCP-Activation45,NET-WCF-Pipe-Activation45 -ComputerName $srvIP -Credential $DomainAdmin
            Add-WindowsFeature Net-Framework-Features,Web-Server,Web-WebServer,Web-Common-Http,Web-Static-Content,Web-Default-Doc,Web-Dir-Browsing,Web-Http-Errors,Web-App-Dev,Web-Asp-Net,Web-Net-Ext,Web-ISAPI-Ext,Web-ISAPI-Filter,Web-Health,Web-Http-Logging,Web-Log-Libraries,Web-Request-Monitor,Web-Http-Tracing,Web-Security,Web-Basic-Auth,Web-Windows-Auth,Web-Filtering,Web-Digest-Auth,Web-Performance,Web-Stat-Compression,Web-Dyn-Compression,Web-Mgmt-Tools,Web-Mgmt-Console,Web-Mgmt-Compat,Web-Metabase,Application-Server,AS-Web-Support,AS-TCP-Port-Sharing,AS-WAS-Support, AS-HTTP-Activation,AS-TCP-Activation,AS-Named-Pipes,AS-Net-Framework,WAS,WAS-Process-Model,WAS-NET-Environment,WAS-Config-APIs,Web-Lgcy-Scripting,Windows-Identity-Foundation,Server-Media-Foundation,Xps-Viewer -ComputerName $srvIP -Credential $DomainAdmin
            Restart-Computer -ComputerName $srvIP -Credential $DomainAdmin -Force
        }
   }

Check-WMSCon -ComputerName $srvIP 
 
Invoke-Command  -ComputerName $srvIP -Credential $DomainAdmin  -Scriptblock {
    $srvIP=$using:srvIP     
    $DomainAdmin=$using:DomainAdmin    
    if (!(Get-WindowsFeature -Name "Net-framework-core" ).Installed)  {Write-Host ".net-Framework konnte nicht installiert werden. Das Skript sollte abgebrochen werden!" -ForegroundColor Red
          pause }
  }        
 Invoke-Command  -ComputerName $srvIP -Credential $DomainAdmin  -Scriptblock {Enable-WSManCredSSP -Role Server -Force}                                 

ForEach ($SQLInst in  ($config.Cfg.Rollen.SQL.Instanzen.Instanz |where {$_.srvip -EQ $srvIP })){
         $instance=$SQLInst.Name
         $instKey="SQL-$instance"
         Get-Date
         $srvname=$srv.name
         $SQLAdmGroup=$srvname+"_"+$instance+"_Admin"
         $usr=$SQLInst.SQLSYSADMINACCOUNTS
         if ([string]::IsNullOrEmpty($usr)){ $usr = $config.cfg.domain.admin }
         
         add-ADGruppe -GruppenName $SQLAdmGroup -Displayname "SQL-Administratorengruppe für $instance auf Server $srvname " -Gruppenmitglieder $usr



         if(!(Check-Rolle -Rolle $instKey -IP $srvIP)){
            write-host "Bereite Instanz $instance vor...."
            $src=$SQLInst.installSource
            if ([System.IO.Path]::GetExtension($src) -eq ".ISO") 
                    {#Verbinde ISO-Datei mit VM
                    Set-VMDvdDrive -VMName ($config.cfg.host.VMPrefix + $VMName) -Path $src
                    $LW=$srv.DVDLetter
                    if ([string]::IsNullOrEmpty($LW)) {$LW=$config.cfg.vms.default.DVDLetter}
                     $src=$lw +":\setup.exe"
                    }
            # Fallback, falls kein User für SQL-Dienst in der Config ist.
            $s1=$svc | where-object {$_.Diensttyp -eq "SQL-Dienst"}
            $Username=$config.CFG.Domain.NetBIOSName +"\"+ $s1.sam
            $Password =$s1.Password
            $instance=$SQLInst.Name
            $idir=$SQLInst.INSTANCEDIR
            $FILESTREAMLEVEL=$SQLInst.FILESTREAMLEVEL
            $FILESTREAMSHARENAME=$SQLInst.FILESTREAMSHARENAME
            $TCPENABLED=$SQLInst.TCPENABLED
            $NPENABLED=$SQLInst.NPENABLED
            $RSINSTALLMODE=$SQLInst.RSINSTALLMODE
            $SQLSYSADMINACCOUNTS=$config.CFG.Domain.NetBIOSName +"\"+ $SQLAdmGroup +", "+ $config.CFG.Domain.NetBIOSName +"\SQLM"
            $skript= "if (Test-Path  $src)
                {md  $idir
            $src /Q=true /INDICATEPROGRESS /IACCEPTSQLSERVERLICENSETERMS=1 /ACTION=Install /UpdateEnabled=False  /SQMREPORTING=0 /INSTANCEID=$instance /INSTANCENAME=$instance /INSTANCEDIR=$idir /FILESTREAMLEVEL=$FILESTREAMLEVEL /FILESTREAMSHARENAME=$FILESTREAMSHARENAME /TCPENABLED=$TCPENABLED /NPENABLED=$NPENABLED /RSINSTALLMODE=$RSINSTALLMODE /SQLSYSADMINACCOUNTS=$SQLSYSADMINACCOUNTS "
            $SQLa=$SQLInst.SQLSVCACCOUNT
            $s2=$svc | where-object {$_.sam -eq ($SQLInst.SQLSVCACCOUNT)}
            $SQLSVCACCOUNT=$config.CFG.Domain.NetBIOSName +"\"+ $s2.sam
            $SQLSVCPassword =$s2.Password 
            #/ENABLERANU
            If ([string]::IsNullOrEmpty($SQLSVCPassword)){
                $SQLSVCACCOUNT=$Username
                $SQLSVCPassword =$Password
               }
            If (!([string]::IsNullOrEmpty($SQLSVCACCOUNT))){$skript=$skript + " /SQLSVCACCOUNT=$SQLSVCACCOUNT  /SQLSVCPassword=$SQLSVCPassword ` "}
            $s2=$svc | where-object {$_.sam -eq $SQLInst.RSSVCACCOUNT}
            $RSSVCACCOUNT=$config.CFG.Domain.NetBIOSName +"\"+ $s2.sam
            $RSSVCPassword =$s2.Password 
            If (!([string]::IsNullOrEmpty($RSSVCPassword))){$skript=$skript + " /RSSVCACCOUNT=$RSSVCACCOUNT  /RSSVCPassword= $RSSVCPassword ` "}
            $s2=$svc | where-object {$_.sam -eq $SQLInst.AGTSVCACCOUNT}
            $AGTSVCACCOUNT=$config.CFG.Domain.NetBIOSName +"\"+ $s2.sam
            $AGTSVCPASSWORD =$s2.Password 
            If (!([string]::IsNullOrEmpty($AGTSVCPASSWORD))){$skript=$skript + " /AGTSVCACCOUNT=$AGTSVCACCOUNT  /AGTSVCPASSWORD= $AGTSVCPASSWORD ` "}
            $FEATURES=$SQLInst.FEATURES
            $skript=$skript + "/FEATURES=$FEATURES"
            if(!($src -match "setup.exe")) { $skript=$skript+ ' |echo "waiting"   '}

            $skript=$skript + ' } '
            $Inst=$SQLInst.Name
            $PORT =$SQLInst.DBPort            
            $skript
            #pause
            write-host "Installiere $instance. Dieses dauert etwas länger..."
            Invoke-Command  -ComputerName $srvIP -Credential $DomainAdmin  -Scriptblock (ConvertTo-ScriptBlock($skript))  -Authentication Credssp
            write-host "$instance wurde installiert. " -ForegroundColor Green  
             Invoke-Command  -ComputerName $srvIP -Credential $DomainAdmin  -Scriptblock {
            Get-ItemProperty HKLM:\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\* | sort -Property DisplayName | Format-Table DisplayName, Publisher, DisplayVersion
            }  -Authentication Credssp
            #pause

            If (!([string]::IsNullOrEmpty($Port))){
                    Invoke-Command  -ComputerName $srvIP -Credential $DomainAdmin  -Scriptblock {
                                # TCP/IP-Einstellungen für SQL-Instanz setzen
                                Write-Host "TCP/IP-Einstellungen für SQL-Instanz: $using:Inst Port: $using:PORT setzen!"
                                $PORT1=$using:PORT
                                $Inst1=$using:Inst
                                # SQL-Modul laden
                                import-module "sqlps" -DisableNameChecking
                                [reflection.assembly]::LoadWithPartialName("Microsoft.SqlServer.Smo")
                                [reflection.assembly]::LoadWithPartialName("Microsoft.SqlServer.SqlWmiManagement")
                                # Neues Objekt erstellen
                                $MachineObject = new-object ('Microsoft.SqlServer.Management.Smo.WMI.ManagedComputer') 
                                # Instanz für Dateninstanz laden
                                $ProtocolUri = "ManagedComputer[@Name='" + (get-item env:\computername).Value + "']/ServerInstance[@Name='"+ $inst1 + "']/ServerProtocol"
                                # TCP auswählen
                                $tcp = $MachineObject.getsmoobject($ProtocolUri + "[@Name='Tcp']")
                                # IPAll auswählen
                                $MachineObject.getsmoobject($tcp.urn.value + "/IPAddress[@Name='IPAll']")
                                # Port festlegen
                                $MachineObject.getsmoobject($tcp.urn.Value + "/IPAddress[@Name='IPAll']").IPAddressProperties[1].Value = $PORT1
                                # Dynamische Ports leeren
                                $MachineObject.getsmoobject($tcp.urn.Value + "/IPAddress[@Name='IPAll']").IPAddressProperties[0].Value = ""
                                # Änderungen durchführen
                                $tcp.alter()
                                #Instanz neu starten
                                $Service="MSSQL$"+$Inst1
                                restart-service -name $Service
                               }
                }

            # Firewall-Settings
            Invoke-Command  -ComputerName $srvIP -Credential $DomainAdmin -Scriptblock {
                            $PORT1=$using:PORT
                            $Inst1=$using:Inst    
                            Import-Module NetSecurity
                            If (!([string]::IsNullOrEmpty($Port1))){
                                New-NetFirewallRule -Name SQL_$PORT1 -DisplayName "SQL Port $port1 für Instanz $inst1"`
                                    -Description "SQL Port für die Instanz $Inst1" `
                                    -Protocol TCP  -LocalPort $PORT1 -Enabled True -Profile Domain -Action Allow 
                                }
                            if((Get-Item -Path HKLM:\SOFTWARE\AI2).GetValueNames() -notcontains"SQLFW_Open")
                               {
                                New-NetFirewallRule -Name Allow_Ping -DisplayName "Ping erlauben" `
                                    -Description "Packet Internet Groper ICMPv4" `
                                    -Protocol ICMPv4 -IcmpType 8 -Enabled True -Profile Any -Action Allow 
                                New-NetFirewallRule -Name SQL_1434 -DisplayName "SQL-Administratorverbindung"`
                                    -Description "SQL-Administratorverbindung" `
                                    -Protocol TCP  -LocalPort  1434 -Enabled True -Profile Domain -Action Allow 
                                New-NetFirewallRule -Name SQL_4022 -DisplayName "SQL-Service Broker"`
                                    -Description "für den konventionellen SQL Server-Service Broker" `
                                    -Protocol TCP  -LocalPort  4022 -Enabled True -Profile Domain -Action Allow 
                                New-NetFirewallRule -Name SQL_135 -DisplayName "SQL-Debugger/RPC"`
                                    -Description "Port 135 für Transact-SQL-Debugger/RPC" `
                                    -Protocol TCP  -LocalPort  135 -Enabled True -Profile Domain -Action Allow 
                                # =========  Ports für Analysedienste  ==============
                                New-NetFirewallRule -Name SQL_2383 -DisplayName "Analysedienste"`
                                    -Description "Port 2383 für die SSAS-Standardinstanz" `
                                    -Protocol TCP  -LocalPort 2383 -Enabled True -Profile Domain -Action Allow 
                                New-NetFirewallRule -Name SQL_2382 -DisplayName "SQL-Browser"`
                                    -Description "Port 2382 für den SQL Server-Browserdienst" `
                                    -Protocol TCP  -LocalPort 2382 -Enabled True -Profile Domain -Action Allow 
                                New-NetFirewallRule -Name SQL_1434U -DisplayName "SQL-Browser UDP"`
                                    -Description "Port 1434 UDP für die Schaltfläche -Durchsuchen- des SQL Server-Browserdiensts" `
                                    -Protocol TCP  -LocalPort 1434 -Enabled True -Profile Domain -Action Allow 
                                # =========  Verschiedene Anwendungen  ==============
                                New-NetFirewallRule -Name TCP_80 -DisplayName "HTTP"`
                                    -Description "Port 80 für HTTP" `
                                    -Protocol TCP  -LocalPort 80 -Enabled True -Profile Domain -Action Allow 
                                New-NetFirewallRule -Name TCP_443 -DisplayName "SSL"`
                                    -Description "Port 443 für SSL" `
                                    -Protocol TCP  -LocalPort 443 -Enabled True -Profile Domain -Action Allow 
                                # @echo Zulassen von Multicast-/Broadcastantwort auf UDP (Aufzählung der Browserdienste OK)
                                netsh firewall set multicastbroadcastresponse ENABLE 
                                set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -Name "SQLFW_Open" -Value 1
                                $instance=$using:instance
                                set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name "SQL-$instance" -Value $true
                                }
                            }


                        }
         Else {Write-Host "Instanz $instKey ist auf $srvIP schon vorhanden!" -ForegroundColor Yellow}

        if ([System.IO.Path]::GetExtension($src) -eq ".ISO") 
                {
                #dismnount ISO-Datei mit VM                               
                }

        Invoke-Command  -ComputerName $srvIP -Credential $DomainAdmin -Scriptblock {set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name "SQL" -Value $true}
        }

write-host "Die Konfiguration des SQL-Servers ist nun beendet!"
"Ausführungszeit: {0:hh}:{0:mm}:{0:ss}" -f ((get-date)-$Start)
Stop-Transcript | Out-Null
