﻿# Download der zusätzlich benötigten Ressourcen 
# 
Param 
      (
      [string]$DownloadDirectory = "d:\DL",
      [string]$ISODirectory = "d:\ISO",
      [string]$RessourcesFile = "d:\AI2\CFG\downloads.csv",
      [switch]$NoCheck 
       )


$Start=Get-Date
$Start=Get-Date
write-host "     ************************************************************     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     *            AI2 Downloader by Thorsten Raucamp            *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     *                  Version 0.94 2014-01-15                 *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     ************************************************************     " -ForegroundColor DarkGreen
Write-Host ""
Write-Host ""
write-host "     Beginne mit dem Download der Dateien am: " -NoNewline
Get-Date
$Host.UI.RawUI.WindowTitle = "AI2 Downloader "


# Funktion Get-Checksum gefunden auf http://www.tinyint.com/index.php/2011/09/14/get-an-md5-or-sha1-checksum-with-powershell/#more-288
function Get-Checksum
{
    Param (
        [string]$FiletoCheck=$(throw("You must specify a filename to get the checksum of.")),
        [ValidateSet("sha1","md5")]
        [string]$Algorithm="sha1"
    )
    $fs = new-object System.IO.FileStream $FiletoCheck, "Open"
    $algo = [type]"System.Security.Cryptography.$Algorithm"
	$crypto = $algo::Create()
    $hash = [BitConverter]::ToString($crypto.ComputeHash($fs)).Replace("-", "")
    $fs.Close()
    $hash
}

# Verzeichnisse überprüfen
if (!(Test-Path $DownloadDirectory)){
    if (!(Test-Path (Split-Path $DownloadDirectory -Qualifier))){
            Write-Host "Ungültiges Laufwerk! Bitte geben Sie ein anderes DownloadDirectory an!"
            Exit
            }
    else {md $DownloadDirectory}
    }

if (!(Test-Path $ISODirectory)){
    if (!(Test-Path (Split-Path $ISODirectory -Qualifier))){
            Write-Host "Ungültiges Laufwerk! Bitte geben Sie ein anderes ISODirectory an!"
            Exit
            }
    else {md $ISODirectory}
    }
 If ([string]::IsNullOrEmpty($RessourcesFile)) 
        {$RessourcesFile = (Split-Path -parent $MyInvocation.MyCommand.Definition)+"\downloads.csv" 
         $RessourcesFile =$RessourcesFile.Replace("\Tools\","\cfg\")
        }

        # replace tools with cfg !!!!
else {if (!(Test-Path $RessourcesFile)){
            Write-Host "Ungültige Ressouren-Datei Downloads.csv! Bitte geben Sie eine gültige Datei an!"
            Exit
            }}

import-Csv(($RessourcesFile)) | ForEach {
    $FileName= $_.Filename
    $URL=$_.URL
    $Checksum=$_.Checksum

if ($_.include -ne "#"){
   if (!([string]::IsNullOrEmpty($_.Dest))){
        # Zielverzeichnis festlegen
        if ($_.Dest -eq "ISODIR")
            {$target=$ISODirectory+"\"}
        elseif (Split-Path $_.Dest -IsAbsolute) 
            {$target=$_.Dest} 
        else 
            {$target=$DownloadDirectory+$_.Dest}
    # Verzeichnis anlegen, falls es noch nicht existiert
    if (!(Test-Path $target)){md $target}

    if (($_.Include -eq "1") -or ($_.Include -eq "X")) 
        { #Download-Check
         if (!(Test-Path ($target+$FileName) )){
         #Download
         Write-Host "Datei $FileName wird heruntergeladen! Bitte warten..." -ForegroundColor Yellow
         $WebClient = New-Object system.Net.WebClient
         $WebClient.downloadfile($URL,($target+$FileName))
    

         }
         else {Write-Host "Datei $FileName ist schon vorhanden, Download wird übersprungen!"} 
         }
        #$_.Include,$_.URL,$_.FileName,$target,$_.Checksum,$_.Type 

 
        if ((Test-Path ($target+$FileName)) -and (!($NoCheck))){
            Write-Host "Überprüfe im Verzeichnis - $target - Datei: $FileName "
            if (([string]::IsNullOrEmpty($Checksum))){
                    Write-Host "Die Checksumme ist aktuell nicht hinterlegt. Bitte selber überprüfen"-ForegroundColor Yellow
                    $sha1= (Get-Checksum -FiletoCheck ($target+$FileName) -Algorithm sha1)
                    $md5= (Get-Checksum -FiletoCheck ($target+$FileName) -Algorithm md5)
                    Write-Host "aktuell ermittelte Werte für $FileName : SHa1: $sha1, MD5: $md5" -ForegroundColor Yellow
                   }
            else {
                  $cs=Get-Checksum -FiletoCheck ($target+$FileName) -Algorithm $_.Type
                  if ($cs -eq $_.Checksum){Write-Host "Checksum für $FileName ist OK: $cs" -ForegroundColor Green}
                  else {
                          Write-Host "Die Werte für $FileName weichen ab! Ermittelt: $Cs, gespeichert: $Checksum" -ForegroundColor Red
                          Write-Host "Bitte überprüfen, ggf. den Download nochmals durchführen!" -ForegroundColor Red
                       }
                  }
            }


    }
  }
}

write-host "******************************************************"
"Ausführungszeit: {0:hh}:{0:mm}:{0:ss}" -f ((get-date)-$Start)
write-host "******************************************************"

