﻿#Requires –Version 3
Param 
      (
      [string]$configfile
       )


$Start=Get-Date
write-host "     ************************************************************     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     *         AI2 Create-Wim-Images by Thorsten Raucamp        *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     *                  Version 0.95 2014-02-10                 *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     ************************************************************     " -ForegroundColor DarkGreen
Write-Host ""
Write-Host ""
write-host "     Beginne mit der Erstellung der WIM-Dateien am: " -NoNewline
Get-Date
$Host.UI.RawUI.WindowTitle = "Create-WIM "


# Abfrageschwelle herabsetzten
$ConfirmPreference = "none"

# hole Skriptdir 
If (([string]::IsNullOrEmpty($PSCommandPath)))
                {$ScriptDir = (split-path -parent $psISE.CurrentFile.Fullpath) }
    else 
                {$ScriptDir =  (Split-Path -parent $PSCommandPath) }

$xecute=("$ScriptDir\H1_globale-Funktionen.ps1").Replace("\Tools","\sub")
Start-Process   -WorkingDirectory $PSHOME -FilePath "powershell.exe" -ArgumentList "$xecute"  -Wait

# suche nach config-datei
    If (([string]::IsNullOrEmpty($configfile))){
          if((Get-Item -Path HKLM:\SOFTWARE).GetSubKeyNames() -notcontains"AI2")
                {# Anlage eines neuen Schluessels fuer die Skripte
                 new-Item -Path HKLM:\SOFTWARE -name AI2
                 set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name Configfile -Value ""
                }
          $configfile=(Get-ItemProperty -path HKLM:\SOFTWARE\ai2).Configfile
          If (([string]::IsNullOrEmpty($configfile))){$configfile= ("$ScriptDir\ai2config.xml").Replace("\Tools\","\cfg\")}
         } 
    If (!(Test-Path  $configfile)) 
        {Write-Host "$sbsrvconfig nicht gefunden! bitte Skript mit Angabe der Konfigdatei erneut ausführen!"
        break }
Get-Config -Configfile $configfile -SkriptDir $ScriptDir.Replace("\Tools\","\")

[xml]$config = Get-Content $configfile
$RessourcesFile=(split-path -parent $configfile)+"\createWIM.csv"
If (!(Test-Path  $RessourcesFile)) 
        {Write-Host "Abbruch: $RessourcesFile nicht gefunden! !" -ForegroundColor Red
        break }

 $Files=import-Csv  $RessourcesFile
$log=$config.cfg.LOG
if (!(Test-Path $log)){md $log}


$logfile=$config.cfg.log +"createWIM.txt"
$ErrorActionPreference="SilentlyContinue"
Stop-Transcript | Out-Null
$ErrorActionPreference="Continue"

Start-Transcript -Path $logfile -Append


             $xecute=("$ScriptDir\H1_globale-Funktionen.ps1 ").Replace("\Tools\","\sub\")
             Start-Process   -WorkingDirectory $PSHOME -FilePath "powershell.exe" -ArgumentList "$xecute" -RedirectStandardError $logfile  -Wait -NoNewWindow

$IsoDir=$config.cfg.HOST.ISO
$WimDir=$config.cfg.HOST.WIM
if (!(Test-Path $WimDir)) {md $WimDir}

$Files | ForEach-Object     {
     $Name=$_.Name
     $File=$_.File
     $Hash=$_.Hash
     $WIM=$_.WIM
     if ($_.create -eq "X") {
         if (Test-Path ("$WimDir\$wim")){Write-Host "Wim $wim existiert bereits." -NoNewline }
         Else {  $xecute= "$scriptdir\Copy-Wim.ps1 -iso $isoDir\$File -DestDir $WimDir -WimName $WIM "
                Write-Host "Erstelle $WIM " -NoNewline
                #$xecute
                 Start-Process   -WorkingDirectory $PSHOME -FilePath "powershell.exe" -ArgumentList "$xecute" -RedirectStandardError $logfile  -Wait }
        }
     if (Test-Path ("$WimDir\$wim")){
         if ($_.create -ne "#") {      
             $CS=get-Checksum -FiletoCheck ("$WimDir\$wim") -Algorithm sha1
             if ($CS -eq $Hash){Write-Host "Checksumme OK " -ForegroundColor Green}
             else {Write-Host "Abweichende Checksummen für $wim : erwartet: $Hash, berechnet: $cs" -ForegroundColor Red}
            }
         }
    }


write-host "Die Erstellung der WIM-Dateien ist nun beendet."
write-host "******************************************************"
"Ausführungszeit: {0:hh}:{0:mm}:{0:ss}" -f ((get-date)-$Start)
write-host "******************************************************"

Get-Date
Stop-Transcript | Out-Null
