﻿Param 
      (
      [string]$WIMFile =$(throw '- Der Parameter -WimName wird benoetigt!(Name der WIM-Datei, die gepatched werden soll.'),
      [string]$Updates =$(throw '- Der Parameter -Updates wird benoetigt!(Name der WSUS-Offline-CD')
       
       )




$Start=Get-Date
write-host "******************************************"
write-host "*    AI2-Patch-Wim by Thorsten Raucamp   *"
write-host "*         Version 0.9 2013-11-11         *"
write-host "******************************************"
write-host "******************************************"
write-host "**          nur experimentell!          **"
write-host "******************************************"
write-host "******************************************"
Write-Host ""
Write-Host ""
write-host "Beginne mit dem Aktualisieren der WIM-Dateien am: " -NoNewline
Get-Date

# Funktion übernommen von John Savill        http://www.savilltech.com/
 function Install-Patch
{
    <#
    .SYNOPSIS
        Patches a WIM or VHD file
    .DESCRIPTION
        Applies downloaded patches to a VHD or WIM file
    .NOTES
        File Name: Install-Patch.psm1
        Author: John Savill
        Requires: Tests on PowerShell 3 on Windows Server 2012
        Copyright (c) 2013 John Savill
    .LINK#
	http://www.savilltech.com/
    .PARAMETER updateTargetPassed
        File (WIM, VHD or VHDX) to be patched
    .PARAMETER patchpath
        Path containing the updates
    .EXAMPLE
        Install-Patch d:\files\test.vhd d:\updates\win2012\
        Install-Patch d:\files\install.wim:4 d:\updates\win2012\
    #>
    [cmdletbinding()]
    Param(
    [Parameter(ValuefromPipeline=$false,Mandatory=$true)][string]$updateTargetPassed,
    [Parameter(ValuefromPipeline=$false,Mandatory=$true)][string]$patchpath)

    #$updateTargetPassed = "G:\Temp\Win2012DatacenterRTM.vhdx"
    #or
    #$updateTargetPassed = "d:\sources\install.wim:4"
    #$patchpath = "D:\software\Windows 2012 Updates\"
    if(($updateTargetPassed.ToLower().Contains(".vhd")) -eq $true) # if its VHD or VHDX. Contains is case sensitive so have to convert to lower when comparing
    {
        $isVHD = $true
    }
    else
    {
        $isVHD = $false
    }

    if($isVHD)
    {
        $updateTarget=$updateTargetPassed
        if ((Test-Path $updateTarget) -eq $false) #if not found
        {
            write-output "Source not found ($updateTarget)"
            break
        }
        else
        {
            mount-vhd -path $updateTarget
            $disks = Get-CimInstance -ClassName Win32_DiskDrive | where Caption -eq "Microsoft Virtual Disk"          
            foreach ($disk in $disks)
            {          
                $vols = Get-CimAssociatedInstance -CimInstance $disk -ResultClassName Win32_DiskPartition            
                foreach ($vol in $vols)
                {          
                    $updatedrive = Get-CimAssociatedInstance -CimInstance $vol -ResultClassName Win32_LogicalDisk |          
                    where VolumeName -ne 'System Reserved'        
                }          
            }
            $updatepath = $updatedrive.DeviceID + "\"
        }
    }
    if(!$isVHD)  #its a WIM file
    {
        #Need to extract the WIM part and the index
        #extract file name and the index number
        $updateTargetPassedSplit = $updateTargetPassed.Split(":")
        if($updateTargetPassedSplit.Count -eq 3) #one for drive letter, one for folder and one for image number so would have been two colons in it c:\temp\install.wim:4
        {
            $updateTarget = $updateTargetPassedSplit[0] + ":" + $updateTargetPassedSplit[1]   #There are two colons. The first is drive letter then the folder!
            $updateTargetIndex = $updateTargetPassedSplit[2]
            $updatepath = "c:\wimmount\"
#            #check if exists and if not create it
            if ((Test-Path $updatepath) -eq $false) #if not found
            {
                Write-Host "Creating folder " + $updatepath
                New-Item -Path $updatepath -ItemType directory
                #could have also used [system.io.directory]::CreateDirectory($updatepath)
            }

            # Mount it as folder
            #dism /get-wiminfo /wimfile:install.wim
            dism /Mount-Wim /wimfile:$updateTarget /index:$updateTargetIndex /mountdir:$updatepath
        }
        else
        {
            write-output "Missing index number for WIM file. Example: c:\temp\install.wim:4"
            break
        }
    }

   # For WIM or VHD
    $updates = get-childitem -path $patchpath -Recurse | where {($_.extension -eq ".msu") -or ($_.extension -eq ".cab")} | select fullname
    foreach($update in $updates)
    {
        write-debug $update.fullname
        $command = "dism /image:" + $updatepath + " /add-package /packagepath:'" + $update.fullname + "'"
        write-debug $command
        Invoke-Expression $command
    }

    $command = "dism /image:" + $updatepath + " /Cleanup-Image /spsuperseded"
    Invoke-Expression $command

    if($isVHD)
    {
        dismount-vhd -path $updateTarget -confirm:$false
    }
    else
    {
        dism /Unmount-Wim /mountdir:$updatepath /commit
        #dism /Unmount-Wim /mountdir:$updatepath /discard
    }
}


function Patch-File
{
param(
        [string]$WIM,
        [String]$updatePfad
     )
    $Anzahl=4
    

     $info= dism /get-wiminfo /wimfile:$WIM
     if($info -match 'Index: "4"'){$Anzahl=4}
     else {if($info -match 'Index: "2"'){$Anzahl=2}
            else{$Anzahl=1}
          }
    Write-Host $WIM
    Write-Host "----------------"
   # If ([string]::IsNullOrEmpty($MaxIndex)){
   #     if($Anzahl -gt $MaxIndex){$Anzahl=$MaxIndex}
    Write-Host $Anzahl
    Write-Host "----------------"
    
    #  }
    Write-Host "Insgesamt werden $Anzahl Abbild(er) bearbeitet:"
    $Durchgang=1      
    for($Durchgang=1;$Durchgang-le $Anzahl;$Durchgang++)    
        { [string]$DG=$Durchgang

            write-host "******************************************"
            Write-Host "Bearbeite Abbild Nr: $Durchgang, bitte warten ..."
            write-host "******************************************"
            $Abbild=$WIM.TrimEnd()+":"+$DG.TrimStart()
            Write-Host $Abbild
            Install-Patch $Abbild $updatePfad
            
        }
    write-host "******************************************************"
    write-host "Des Patchen ist nun beendet"
    Write-Host "Es wurden $Anzahl Abbilder in der Datei $WIM aktualisiert!"
    write-host "******************************************************"
    }


     If (!(Test-Path $WIMFile))
        {Write-Host "Das angegebene WIM-Image $WIMFile existiert nicht!"
        break}
     If (!(Test-Path $Updates))
        {Write-Host "Das angegebene ISO-Image $Updates mit den Updates existiert nicht!"
        break}
     if ( [System.IO.Path]::GetExtension($Updates) -eq ".ISO")
            {Mount-DiskImage -ImagePath $Updates
             $updatePfad= (Get-DiskImage -ImagePath $Updates | Get-Volume).DriveLetter+ ":\" 
            }
     else   {$updatePfad=$Updates}
 
     if (Test-Path $WIMFile -PathType Container)
            {
             $files=Get-ChildItem -Recurse -Path $WIMFile
             foreach($file in $files)
                    {Patch-File -WIM $file.FullName -updatePfad $updatePfad}
            }
        else{Patch-File -WIM $WIMFile -updatePfad $updatePfad}

Start-Sleep -Seconds 10
if ( [System.IO.Path]::GetExtension($Updates) -eq ".ISO")
    {Dismount-DiskImage $Updates}


write-host "******************************************************"
"Ausführungszeit: {0:hh}:{0:mm}:{0:ss}" -f ((get-date)-$Start)
write-host "******************************************************"

Get-Date
