﻿#Requires –Version 3

Param 
      (
      [string]$configfile
       )


$Start=Get-Date
write-host "     ************************************************************     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     *  AI2 Configure-HOST - NetworkTeam   by Thorsten Raucamp  *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     *                  Version 0.94 2014-01-15                 *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     ************************************************************     " -ForegroundColor DarkGreen
Write-Host ""
Write-Host ""
write-host "     Konfiguriere HOST-Network-Team am: " -NoNewline
Get-Date
$Host.UI.RawUI.WindowTitle = "Configure HOST-Network Team "

if([string]::IsNullOrEmpty($configfile)) {$configfile=(Get-ItemProperty -path HKLM:\SOFTWARE\ai2).Configfile}
if (!(Test-Path $configfile)) {Write-Host "Bitte starten Sie das Skript erneut mit dem Parameter -configfile und der entsprechenden Pfadangabe"}
#set-ItemProperty -Path HKLM:\SOFTWARE\ai2 -name Configfile -Value $configfile
[xml]$config = Get-Content $configfile
$log=$config.cfg.LOG
if (!(Test-Path $log)){md $log}
$logfile=$log+"create-VMSwitches.txt"
$ErrorActionPreference="SilentlyContinue"
Stop-Transcript | Out-Null
$ErrorActionPreference="Continue"

Start-Transcript -Path $logfile -Append
# Ende Header

if (([System.Convert]::ToBoolean($config.cfg.HOST.Teaming)) -eq $true)
    { # Neues Team aus allen verfügbaren Netzwerkkarten bilden
     New-NetLbfoTeam -Name $config.cfg.HOST.TeamName -TeamMember (($config.cfg.HOST.TeamMember).Split(",")) -TeamingMode $config.cfg.HOST.TeamingMode  -confirm:$false
     # Dem Team IP-Adresse und Gateway setzen
     New-NetIPAddress -InterfaceAlias $config.cfg.HOST.TeamName –IPAddress $config.cfg.HOST.TeamIP -PrefixLength $config.cfg.Host.TeamPrefixLength  -DefaultGateway $config.cfg.Host.TeamGWIP -AddressFamily IPv4 
     # DNS-Einstellungen setzen
     Set-DnsClientServerAddress -InterfaceAlias $config.cfg.HOST.TeamName -ServerAddresses $config.cfg.Host.TeamDnsSrv
    }
Stop-Transcript | Out-Null