﻿#Requires –Version 3
Param 
      (
      [string]$configfile
       )


$Start=Get-Date
write-host "     ************************************************************     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     *  AI2SBS Configure-HOST - Features   by Thorsten Raucamp  *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     *                  Version 0.94 2014-01-20                 *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     ************************************************************     " -ForegroundColor DarkGreen
Write-Host ""
Write-Host ""
write-host "     Beginne mit der Konfiguration des Hosts am: " -NoNewline
Get-Date
$Host.UI.RawUI.WindowTitle = "Configure HOST "

# hole Skriptdir 
If (([string]::IsNullOrEmpty($PSCommandPath)))
                {$ScriptDir = (split-path -parent $psISE.CurrentFile.Fullpath) }
    else 
                {$ScriptDir =  (Split-Path -parent $PSCommandPath) }

$xecute=("$ScriptDir\H1_globale-Funktionen.ps1 ").Replace("\Tools\","\sub\")
Start-Process   -WorkingDirectory $PSHOME -FilePath "powershell.exe" -ArgumentList "$xecute"  -Wait  -NoNewWindow


if ((Get-Command Test-Admin -ErrorAction Ignore).Verb -ne "Test") {Start-Process   -WorkingDirectory $PSHOME -FilePath "powershell.exe" -ArgumentList "$PSScriptRoot\SUB\H1_globale-Funktionen.ps1"  -Wait}

if (!(Test-Admin)) {
                    $powershell = [System.Diagnostics.Process]::GetCurrentProcess()
                    $psi = New-Object System.Diagnostics.ProcessStartInfo $powerShell.Path
                    $script = $MyInvocation.MyCommand.Path
                    $prm = $script
                    foreach($a in $args) {$prm += ' ' + $a}
                    $psi.Arguments = $prm
                    $psi.Verb = "runas"
                    #$psi
                    [System.Diagnostics.Process]::Start($psi) | Out-Null
                    return;
                    # Neustart des Skriptes mit Adminrechten, sollte das aktuelle Skript nicht mit Administratorrechten 
                    # gestartet worden sein. Übernommen von der c't www.ct.de/1017144
                   }

# Abfrageschwelle herab setzten
$ConfirmPreference = "none"



# suche nach config-datei
 If (([string]::IsNullOrEmpty($configfile))){
          if((Get-Item -Path HKLM:\SOFTWARE).GetSubKeyNames() -notcontains"AI2")
                {# Anlage eines neuen Schluessels fuer die Skripte
                 new-Item -Path HKLM:\SOFTWARE -name AI2
                 set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name Configfile -Value ""
                }
          $configfile=(Get-ItemProperty -path HKLM:\SOFTWARE\ai2).Configfile
          If (([string]::IsNullOrEmpty($configfile))){$configfile= ("$ScriptDir\ai2config.xml").Replace("\Tools\","\cfg\")}
         } 
    If (!(Test-Path  $configfile)) 
        {Write-Host "$sbsrvconfig nicht gefunden! bitte Skript mit Angabe der Konfigdatei -erneut ausführen!"
        break }
Get-Config -Configfile $configfile -SkriptDir $ScriptDir.Replace("\Tools\","\")

[xml]$config = Get-Content $configfile
$log=$config.cfg.LOG
if (!(Test-Path $log)){md $log}



$LogDatei=$log+"\201.txt"

$Start=Get-Date
if([string]::IsNullOrEmpty($configfile)) {$configfile=(Get-ItemProperty -path HKLM:\SOFTWARE\AI2).Configfile}
[xml]$config = Get-Content $configfile
$logfile=$config.cfg.log +$vmName+".txt"
$ErrorActionPreference="SilentlyContinue"
Stop-Transcript | Out-Null
$ErrorActionPreference="Continue"

Start-Transcript -Path $logfile -Append

# Powershell Remoting zulassen (fuer diese Maschine, muss aber zumindest fuer die Konfiguration des naechsten Befehls aktiviert werden)
Enable-PSRemoting -SkipNetworkProfileCheck -Force 
# Remoting (von dieser Maschine) auch auf Systeme ermoeglichen, die noch nicht in der Domain sind.Somit wird der Remotezugriff 
# fuer alle System z.B. ueber IP-Adresse akiviert
Set-item WSMan:\localhost\Client\TrustedHosts * -Force 

# PS-Remoting unterstuetzt zunaechst nur Single-Hop um Double-Hop einzurichten, muss auf dem Zielsystem 
# Enable-WSManCredSSP -role Server -force ausgefuehrt worden sein. Auf dem Quell-System entsprechend:
Enable-WSManCredSSP -Role Client -DelegateComputer * -Force
# Somit koennen die Credentieals an alle Systeme weitergegeben werden.Alternativ kann das ueber die Registry eingestellt werden:
# new-Item -Path HKLM:\SOFTWARE\Policies\Microsoft\Windows\CredentialsDelegation -name AllowFreshCredentials
# set-ItemProperty -Path HKLM:\SOFTWARE\Policies\Microsoft\Windows\CredentialsDelegation\AllowFreshCredentials -name 1 -Value wsman/*

# Auch hier muss noch eine Einstellung gemacht werden, damit Systeme ausserhalb der Domain angesprochen werden koennen. Dieses kann nur ueber die
# lokale Gruppenrichtlinie "Computerkonfiguration/Administrative Vorlagen/System/Delegierung der Anmeldeinformationen/Aktuelle Anmeldeinfrormationen mit reiner NTML-Serverauthentifizierung zulassen"
# eingeschaltet werden, bzw. ueber den Registry-Eintrag:
new-Item -Path HKLM:\SOFTWARE\Policies\Microsoft\Windows\CredentialsDelegation -name AllowFreshCredentialsWhenNTLMOnly
set-ItemProperty -Path HKLM:\SOFTWARE\Policies\Microsoft\Windows\CredentialsDelegation\AllowFreshCredentialsWhenNTLMOnly -name 1 -Value wsman/*
#Remote Desktop zulassen, sofern noch nicht geschehen:
(Get-WmiObject -Class "Win32_TerminalServiceSetting" -Namespace root\cimv2\terminalservices).SetAllowTsConnections(1) |Out-File -FilePath $LogDatei -Append
(Get-WmiObject -class "Win32_TSGeneralSetting" -Namespace root\cimv2\terminalservices -Filter "TerminalName='RDP-tcp'").SetUserAuthenticationRequired(1) |Out-File -FilePath $LogDatei -Append

netsh advfirewall firewall set rule name="Remotedesktop - Benutzermodus (TCP eingehend)" new profile="domain,private" enable=yes
netsh advfirewall firewall set rule name="Remotedesktop - Benutzermodus (UDP eingehend)" new profile="domain,private" enable=yes
netsh firewall set service RemoteAdmin enable
set-NetConnectionProfile -NetworkCategory Private

# Settings für lokalen Admin
Set-ItemProperty -Path hkcu:\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced -name ShowSuperHidden -Value 1 
Set-ItemProperty -Path hkcu:\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced -name HideFileExt -Value 0 

 

if ((Get-WmiObject Win32_OperatingSystem).Caption -notmatch "Windows 8") {
        Install-windowsfeature -name Hyper-V –IncludeManagementTools |Out-File -FilePath $LogDatei -Append
        Add-WindowsFeature windows-Server-backup -IncludeAllSubFeature -IncludeManagementTools
       }
else {Dism /online /enable-feature /featurename:Microsoft-Hyper-V}



if (([System.Convert]::ToBoolean($config.cfg.HOST.SecureHDDs)) -eq $true)
    { Add-WindowsFeature BitLocker
    }

# CD-Laufwerk auf anderen Laufwerksbuchstaben legen 
if (!([string]::IsNullOrEmpty($config.CFG.HOST.DVDLetter)))
{ $LW=$config.CFG.HOST.DVDLetter+":"
(gwmi Win32_cdromdrive).drive | %{$a = mountvol $_ /l;mountvol $_ /d;$a = $a.Trim();mountvol $LW $a} |Out-File -FilePath $LogDatei -Append
}


    
if (!([string]::IsNullOrEmpty($config.CFG.HOST.Name)))
    {Rename-Computer $config.CFG.HOST.Name}



Set-Net6to4Configuration –State disabled
Set-NetTeredoConfiguration –Type disabled
Set-NetIsatapConfiguration –State disabled   


write-host "******************************************************"
"Ausführungszeit: {0:hh}:{0:mm}:{0:ss}" -f ((get-date)-$Start)
write-host "******************************************************"
write-host ""
write-host ""
Write-Host "Bitte den Computer neu starten, damit die Änderungen aktiviert werden können " -ForegroundColor Yellow

Get-Date
Stop-Transcript | Out-Null