﻿#Requires –Version 3

Param 
      (
      [string]$configfile
       )


$Start=Get-Date
write-host "     ************************************************************     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     *       AI2 Configure HOST-Teil2 by Thorsten Raucamp       *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     *                  Version 0.94 2014-01-15                 *     " -ForegroundColor DarkGreen
write-host "     *                                                          *     " -ForegroundColor DarkGreen
write-host "     ************************************************************     " -ForegroundColor DarkGreen
Write-Host ""
Write-Host ""
write-host "     Konfiguriere  HOST-vSwitche am: " -NoNewline
Get-Date
$Host.UI.RawUI.WindowTitle = "Configure HOST 2"

if (!(Test-Admin)) {
                    $powershell = [System.Diagnostics.Process]::GetCurrentProcess()
                    $psi = New-Object System.Diagnostics.ProcessStartInfo $powerShell.Path
                    $script = $MyInvocation.MyCommand.Path
                    $prm = $script
                    foreach($a in $args) {$prm += ' ' + $a}
                    $psi.Arguments = $prm
                    $psi.Verb = "runas"
                    #$psi
                    [System.Diagnostics.Process]::Start($psi) | Out-Null
                    return;
                    # Neustart des Skriptes mit Adminrechten, sollte das aktuelle Skript nicht mit Administratorrechten 
                    # gestartet worden sein. Übernommen von der c't www.ct.de/1017144
                   }


# hole Skriptdir 
If (([string]::IsNullOrEmpty($PSCommandPath)))
                {$ScriptDir = (split-path -parent $psISE.CurrentFile.Fullpath) }
    else 
                {$ScriptDir =  (Split-Path -parent $PSCommandPath) }

$xecute=("$ScriptDir\H1_globale-Funktionen.ps1").Replace("\Tools","\sub")
Start-Process   -WorkingDirectory $PSHOME -FilePath "powershell.exe" -ArgumentList "$xecute"  -Wait

 If (([string]::IsNullOrEmpty($configfile))){
          if((Get-Item -Path HKLM:\SOFTWARE).GetSubKeyNames() -notcontains"AI2")
                {# Anlage eines neuen Schluessels fuer die Skripte
                 new-Item -Path HKLM:\SOFTWARE -name AI2
                 set-ItemProperty -Path HKLM:\SOFTWARE\AI2 -name Configfile -Value ""
                }
          $configfile=(Get-ItemProperty -path HKLM:\SOFTWARE\ai2).Configfile
          If (([string]::IsNullOrEmpty($configfile))){$configfile= ("$ScriptDir\ai2config.xml").Replace("\Tools\","\cfg\")}
         } 
if (!(Test-Path $configfile)) {Write-Host "Bitte starten Sie das Skript erneut mit dem Parameter -configfile und der entsprechenden Pfadangabe"}
set-ItemProperty -Path HKLM:\SOFTWARE\ai2 -name Configfile -Value $configfile
[xml]$config = Get-Content $configfile
# Ende Header
$log=$config.cfg.LOG
if (!(Test-Path $log)){md $log}
$LogDatei=$log+"\202.txt"
$logfile=$config.cfg.log +"202.txt"
$ErrorActionPreference="SilentlyContinue"
Stop-Transcript | Out-Null
$ErrorActionPreference="Continue"

Start-Transcript -Path $logfile -Append

#Host-Einstellungen
Set-VMHost -EnableEnhancedSessionMode $true # 
#Set-VMHost  -MaximumStorageMigrations 2 -MaximumVirtualMachineMigrations 2 -UseAnyNetworkForMigration $true [-VirtualMachineMigrationAuthenticationType Kerberos  -VirtualMachineMigrationPerformanceOption Compression
Set-VMHost  -VirtualHardDiskPath $config.cfg.HOST.VmPath   -VirtualMachinePath $config.cfg.HOST.VirtualMachinePath 

#New-VMSwitch -name "vSwitch" -notes "Virtueller Switch auf Team, bei dem die gemeinsame Verwendung mit dem Host erlaubt ist. " -NetAdapterName "Team" -AllowManagementOS 1

$xecute=("$ScriptDir\H2_configure-VSwitches.ps1").Replace("\Tools\","\sub\")
Start-Process   -WorkingDirectory $PSHOME -FilePath "powershell.exe" -ArgumentList "$xecute"  -Wait


if (([System.Convert]::ToBoolean($config.cfg.HOST.SecureHDDs)) -eq $true)
    { $Pw = convertto-securestring $config.cfg.HOST.HDDPW -asplaintext -force
        
        Get-Volume | where {$_.driveletter -gt "C"} | where {$_.drivetype -EQ "fixed"} | foreach { 
        Enable-Bitlocker $_.mountpoint -passwordProtector -Password $PW -UsedSpaceOnly   -EncryptionMethod AES256
        }
        $ftdl= (get-ItemProperty -Path HKLM:\SOFTWARE\ai2 -name Scriptdir).scriptdir+"\Tools\"
        robocopy.exe $ftdl ('C:\Users\All Users\start') "Unlock.ps1" /np /ns /nc /ndl /np /nfl 
        set-Item -Path HKLM:\Software\Microsoft\Windows\CurrentVersion\Run  -Value "powershell.exe -Command & 'C:\Users\All Users\start\unlock.ps1' -verb RunAs"
    }

 

write-host "******************************************************"
"Ausführungszeit: {0:hh}:{0:mm}:{0:ss}" -f ((get-date)-$Start)
write-host "******************************************************"

Get-Date

Stop-Transcript | Out-Null