﻿Param 
      (
      [string]$iso  =$(throw '- Der Parameter -ISO wird benoetigt! (Source fuer die WIM-Erstellung'),
      [string]$DestDir =$(throw '- Der Parameter -DestDir wird benoetigt! (Zielpfad fuer das WIM-Image)'),
      [string]$WimName  =$(throw '- Der Parameter -WimName wird benoetigt!(Name der WIM-Datei')
       )



$Start=Get-Date
write-host "*****************************************"
write-host "* AI2 - Copy2Wim  by Thorsten Raucamp   *"
write-host "*         Version 0.9 2013-11-11        *"
write-host "*****************************************"
Write-Host ""
write-host "Beginne mit dem Kopieren der Dateien am: " -NoNewline
Get-Date

# Input überprüfen:


If (([string]::IsNullOrEmpty($iso)))
    {Write-Host "Die angegebene ISO-Datei $iso konnte nicht gefunden werden."
    break}
If (([string]::IsNullOrEmpty($DestDir)))
    {Write-Host "Das angegebene Verzeichnis $DestDir konnte nicht gefunden werden."
    break}

Mount-DiskImage -ImagePath $iso
$drive= (Get-DiskImage -ImagePath $iso | Get-Volume).DriveLetter+ ":\"
$src= $Drive+"sources\install.wim" 
dir $src

$dest=$DestDir+"\"+$WimName

Robocopy.exe ($Drive+"sources") $DestDir "install.wim"  /copy:DT /np /ns /nc /ndl /np /nfl 
    ren ($DestDir+"\install.wim") ($DestDir+"\"+$WimName)
    Set-ItemProperty -Path ($DestDir+"\"+$WimName) -Name Attributes -Value "Archive"
Start-Sleep -Seconds 5
Dismount-DiskImage $iso

write-host "******************************************************"
"Ausführungszeit: {0:hh}:{0:mm}:{0:ss}" -f ((get-date)-$Start)
write-host "******************************************************"
