﻿      if([string]::IsNullOrEmpty($configfile)) {$configfile=(Get-ItemProperty -path HKLM:\SOFTWARE\AI2).Configfile}
      [xml]$config = Get-Content $configfile
      $IsoInfo=($configDir=Split-Path $configfile -Parent)+"\IsoInfo.csv"
      $DestDisk="D:\VM\D_DAG1\Virtual Hard Disks\System_DAG1.vhdx"
      
      $Diskinfo=(Get-WindowsImage -ImagePath $DestDisk -index 1)
            if ($Diskinfo.InstallationType -match "Server") 
                {   #$Rollen=($vm.rollen).Split(",")
                    $Rollen = ("DA,WSUS,iis").Split(",")
                    $preFeature=Import-Csv (($configDir=Split-Path $configfile -Parent)+"\PreFeature.csv")
                    $IsoSource= import-csv $IsoInfo
                    foreach ($rolle in $Rollen)
                            { $features= ($preFeature | where {$_.Rolle -eq $rolle})
                              foreach ($feature in $features) 
                                       {$mgmt=""
                                        $subf=""
                                        $Src=""
                                        $proceed=$true
                                        if ($Diskinfo.Build -lt 9200) {$cmmnd="Add-WindowsFeature"} Else {$cmmnd="Install-WindowsFeature"}
                                        if ([System.Convert]::ToBoolean($feature.IncludeMgmtTools ) -eq $true){$mgmt=" -IncludeManagementTools"}
                                        if ([System.Convert]::ToBoolean($feature.AllSubFeatures ) -eq $true){$subf=" -IncludeAllSubFeature"}
                                        if (!([string]::IsNullOrEmpty($feature.source))){
                                                If ($feature.Source -eq "IsoInfo"){
                                                      $ISOs=$IsoSource | where {($_.Language -EQ $Diskinfo.Languages) -and ($_.OSBuild -eq $Diskinfo.Build)}
                                                      $IsoSrc=""
                                                      foreach ($ISO in $ISOs) {if (Test-Path ($iso.Path)) { $IsoSrc= $ISO.Path }}
                                                      if ([string]::IsNullOrEmpty($IsoSrc))
                                                            {   
                                                                [System.Reflection.Assembly]::LoadWithPartialName("System.Windows.Forms") |Out-Null
                                                                [System.Windows.Forms.MessageBox]::Show("Keine ISO gefunden! Im nächsten Dialog bitte die Sourcen für $DestDisk angeben!" , "Achtung!")
                                                                
                                                                            Add-Type -AssemblyName System.Windows.Forms
                                                                            $dlg = New-Object -TypeName  System.Windows.Forms.OpenFileDialog
                                                                            if ($dlg.ShowDialog() -eq 'OK') { $IsoSrc=$dlg.FileName } 
                                                                            else  { Write-Host "Keine ISO angegeben, Source wird versucht, online zu installieren!" -ForegroundColor Red
                                                                                    $proceed=$false
                                                                                  }
                                                                          
                                                            }

                                                    }
                                                else {$Src=$feature.Source}
                                                #if (!([string]::IsNullOrEmpty($feature.source))) {$src=" -Source " +$IsoSrc}
                                           }

                                        if (!([string]::IsNullOrEmpty($feature.source))) { 
                                            if ($IsoSrc -like "*.iso") {$drive= mount-ISO -Path $IsoSrc
                                                 $src=" -Source $drive"
                                                 if ($feature.Source -eq "IsoInfo"){$Src=$Src+"sources\sxs"}
                                                }
                                            else {$src=" -Source " +$IsoSrc}


                                           }
                                        $cmdline= $cmmnd + " -Vhd '$DestDisk'"+ " -Name " +$feature.Features + $mgmt + $subf + $Src

                                        Invoke-Expression -Command $cmdline

                                        if (!([string]::IsNullOrEmpty($feature.source))) { Dismount-DiskImage -ImagePath $IsoSrc}

                                       }
                              #
                              #
                            }
               }             
    