﻿
$configfile=(get-ItemProperty -Path HKLM:\SOFTWARE\AI2).Configfile
[xml]$config = Get-Content ((get-ItemProperty -Path HKLM:\SOFTWARE\AI2).Configfile)
$IsoDir=$config.CFG.HOST.ISO
$IsoInfo=($IsoDir+"\IsoInfo.csv")
if (!(Test-Path $IsoInfo))  { "Language,OSBuild,Path" | Set-Content $IsoInfo }
($files = (dir "$IsoDir\*.iso").Name)
foreach ($file in $files) {
        Write-Host "Ueberpruefe $file" -ForegroundColor Cyan
        Mount-DiskImage -ImagePath "$IsoDir\$file" 
        $drive=  (Get-DiskImage -ImagePath "$IsoDir\$file"  | Get-Volume).DriveLetter+ ":\"
        $Wim= "$drive\sources\install.wim"
        if (Test-Path $Wim)
            { $imgInfo=(Get-WindowsImage -ImagePath $Wim -index 1)
              $Language=$imgInfo.languages
              $osbuild=$imgInfo.build
              if ($imgInfo.InstallationType -match "Server")
              {"$Language,$osbuild,$IsoDir\$file" | Add-Content $IsoInfo
                               }
            }
        Dismount-DiskImage -ImagePath "$IsoDir\$file" 
    }

   